/* PlayerController.c generated by valac 0.56.8, the Vala compiler
 * generated from PlayerController.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file PlayerController.vala
 */

#include <glib-object.h>
#include <glib.h>
#include <gst/player/player.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#define TUNER_PLAYER_CONTROLLER_TEN_MINUTES_IN_SECONDS ((guint) 606)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;
typedef struct _TunerPlayerControllerPrivate TunerPlayerControllerPrivate;

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_MODEL_TYPE_METADATA (tuner_model_metadata_get_type ())
#define TUNER_MODEL_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadata))
#define TUNER_MODEL_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))
#define TUNER_MODEL_IS_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_IS_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))

typedef struct _TunerModelMetadata TunerModelMetadata;
typedef struct _TunerModelMetadataClass TunerModelMetadataClass;
typedef enum  {
	TUNER_PLAYER_CONTROLLER_IS_BUFFERING,
	TUNER_PLAYER_CONTROLLER_IS_PAUSED,
	TUNER_PLAYER_CONTROLLER_IS_PLAYING,
	TUNER_PLAYER_CONTROLLER_IS_STOPPED,
	TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR
} TunerPlayerControllerIs;

#define TUNER_PLAYER_CONTROLLER_TYPE_IS (tuner_player_controller_is_get_type ())
enum  {
	TUNER_PLAYER_CONTROLLER_0_PROPERTY,
	TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY,
	TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY,
	TUNER_PLAYER_CONTROLLER_STATION_PROPERTY,
	TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY,
	TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_SETTINGS (tuner_settings_get_type ())
#define TUNER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_SETTINGS, TunerSettings))
#define TUNER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_SETTINGS, TunerSettingsClass))
#define TUNER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_SETTINGS))
#define TUNER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_SETTINGS))
#define TUNER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_SETTINGS, TunerSettingsClass))

typedef struct _TunerSettings TunerSettings;
typedef struct _TunerSettingsClass TunerSettingsClass;
enum  {
	TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_METADATA_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_TAPE_COUNTER_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_SHUFFLE_REQUESTED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_NUM_SIGNALS
};
static guint tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_NUM_SIGNALS] = {0};

struct _TunerPlayerController {
	GObject parent_instance;
	TunerPlayerControllerPrivate * priv;
};

struct _TunerPlayerControllerClass {
	GObjectClass parent_class;
};

struct _TunerPlayerControllerPrivate {
	gboolean _play_error;
	GstPlayer* _player;
	TunerModelStation* _station;
	TunerModelMetadata* _metadata;
	TunerPlayerControllerIs _player_state;
	gchar* _player_state_name;
	guint _tape_counter_id;
};

static gint TunerPlayerController_private_offset;
static gpointer tuner_player_controller_parent_class = NULL;

VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_model_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelMetadata, g_object_unref)
VALA_EXTERN GType tuner_player_controller_is_get_type (void) G_GNUC_CONST ;
static void tuner_player_controller_set_play_state (TunerPlayerController* self,
                                             const gchar* state);
static gboolean ___lambda6_ (TunerPlayerController* self);
static void tuner_player_controller_set_player_state (TunerPlayerController* self,
                                               TunerPlayerControllerIs value);
static gboolean ____lambda6__gsource_func (gpointer self);
static gboolean ___lambda8_ (TunerPlayerController* self);
static gboolean ____lambda8__gsource_func (gpointer self);
VALA_EXTERN gboolean tuner_player_controller_get_play_error (TunerPlayerController* self);
static gboolean ____lambda9_ (TunerPlayerController* self);
static gboolean _____lambda9__gsource_func (gpointer self);
static gboolean ____lambda10_ (TunerPlayerController* self);
static gboolean _____lambda10__gsource_func (gpointer self);
VALA_EXTERN void tuner_player_controller_play_station (TunerPlayerController* self,
                                           TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_urlResolved (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
static void tuner_player_controller_set_play_error (TunerPlayerController* self,
                                             gboolean value);
static gboolean __lambda11_ (TunerPlayerController* self);
static gboolean ___lambda11__gsource_func (gpointer self);
VALA_EXTERN gboolean tuner_player_controller_can_play (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_play_pause (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_stop (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_shuffle (TunerPlayerController* self);
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
VALA_EXTERN TunerPlayerControllerIs tuner_player_controller_get_player_state (TunerPlayerController* self);
static gboolean _tuner_player_controller_player_state_____lambda7_ (TunerPlayerController* self);
static gboolean __tuner_player_controller_player_state_____lambda7__gsource_func (gpointer self);
VALA_EXTERN TunerModelStation* tuner_player_controller_get_station (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_station (TunerPlayerController* self,
                                          TunerModelStation* value);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_new (void);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_construct (GType object_type);
VALA_EXTERN gdouble tuner_player_controller_get_volume (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_volume (TunerPlayerController* self,
                                         gdouble value);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * tuner_player_controller_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _tuner_player_controller___lambda12_ (TunerPlayerController* self,
                                           GError* _error_);
static void __tuner_player_controller___lambda12__gst_player_error (GstPlayer* _sender,
                                                             GError* object,
                                                             gpointer self);
static void _tuner_player_controller___lambda13_ (TunerPlayerController* self,
                                           GstPlayerMediaInfo* obj);
VALA_EXTERN gboolean tuner_model_metadata_process_media_info_update (TunerModelMetadata* self,
                                                         GstPlayerMediaInfo* media_info);
static void __tuner_player_controller___lambda13__gst_player_media_info_updated (GstPlayer* _sender,
                                                                          GstPlayerMediaInfo* object,
                                                                          gpointer self);
static void _tuner_player_controller___lambda14_ (TunerPlayerController* self,
                                           GstPlayer* obj);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN GType tuner_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerSettings, g_object_unref)
VALA_EXTERN TunerSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN void tuner_settings_set_volume (TunerSettings* self,
                                gdouble value);
static void __tuner_player_controller___lambda14__gst_player_volume_changed (GstPlayer* _sender,
                                                                      gpointer self);
static void _tuner_player_controller___lambda15_ (TunerPlayerController* self,
                                           GstPlayerState state);
static void __tuner_player_controller___lambda15__gst_player_state_changed (GstPlayer* _sender,
                                                                     GstPlayerState object,
                                                                     gpointer self);
static void tuner_player_controller_finalize (GObject * obj);
static GType tuner_player_controller_get_type_once (void);
static void _vala_tuner_player_controller_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_tuner_player_controller_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
tuner_player_controller_get_instance_private (TunerPlayerController* self)
{
	return G_STRUCT_MEMBER_P (self, TunerPlayerController_private_offset);
}

/**
     * @brief the Tuner play state
     *
     * Using our own play state keeps gstreamer deps out of the rest of the code
     */
static GType
tuner_player_controller_is_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_PLAYER_CONTROLLER_IS_BUFFERING, "TUNER_PLAYER_CONTROLLER_IS_BUFFERING", "buffering"}, {TUNER_PLAYER_CONTROLLER_IS_PAUSED, "TUNER_PLAYER_CONTROLLER_IS_PAUSED", "paused"}, {TUNER_PLAYER_CONTROLLER_IS_PLAYING, "TUNER_PLAYER_CONTROLLER_IS_PLAYING", "playing"}, {TUNER_PLAYER_CONTROLLER_IS_STOPPED, "TUNER_PLAYER_CONTROLLER_IS_STOPPED", "stopped"}, {TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR, "TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR", "stopped-error"}, {0, NULL, NULL}};
	GType tuner_player_controller_is_type_id;
	tuner_player_controller_is_type_id = g_enum_register_static ("TunerPlayerControllerIs", values);
	return tuner_player_controller_is_type_id;
}

GType
tuner_player_controller_is_get_type (void)
{
	static volatile gsize tuner_player_controller_is_type_id__once = 0;
	if (g_once_init_enter (&tuner_player_controller_is_type_id__once)) {
		GType tuner_player_controller_is_type_id;
		tuner_player_controller_is_type_id = tuner_player_controller_is_get_type_once ();
		g_once_init_leave (&tuner_player_controller_is_type_id__once, tuner_player_controller_is_type_id);
	}
	return tuner_player_controller_is_type_id__once;
}

/** 
     * @brief Process the Player play state changes emited from gstreamer.
     * 
     * Actions are set in a seperate thread as attempting UI interaction 
     * on the gstreamer signal results in a seg fault
     */
static gboolean
___lambda6_ (TunerPlayerController* self)
{
	gboolean result;
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_PLAYING);
	result = FALSE;
	return result;
}

static gboolean
____lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda6_ ((TunerPlayerController*) self);
	return result;
}

static gboolean
___lambda8_ (TunerPlayerController* self)
{
	gboolean result;
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_BUFFERING);
	result = FALSE;
	return result;
}

static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ ((TunerPlayerController*) self);
	return result;
}

static gboolean
____lambda9_ (TunerPlayerController* self)
{
	gboolean result;
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR);
	result = FALSE;
	return result;
}

static gboolean
_____lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda9_ ((TunerPlayerController*) self);
	return result;
}

static gboolean
____lambda10_ (TunerPlayerController* self)
{
	gboolean result;
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_STOPPED);
	result = FALSE;
	return result;
}

static gboolean
_____lambda10__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda10_ ((TunerPlayerController*) self);
	return result;
}

static void
tuner_player_controller_set_play_state (TunerPlayerController* self,
                                        const gchar* state)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (state != NULL);
	_tmp0_ = state;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("playing")))) {
		switch (0) {
			default:
			{
				gdk_threads_add_idle (____lambda6__gsource_func, self);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("buffering")))) {
		switch (0) {
			default:
			{
				gdk_threads_add_idle (____lambda8__gsource_func, self);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gboolean _tmp3_;
				_tmp3_ = self->priv->_play_error;
				if (_tmp3_) {
					gdk_threads_add_idle (_____lambda9__gsource_func, self);
				} else {
					gdk_threads_add_idle (_____lambda10__gsource_func, self);
				}
				break;
			}
		}
	}
}

/**
    * @brief Plays the specified station.
    *
    * @param station The station to play.
    */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda11_ (TunerPlayerController* self)
{
	GstPlayer* _tmp0_;
	gboolean result;
	_tmp0_ = self->priv->_player;
	gst_player_play (_tmp0_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((TunerPlayerController*) self);
	return result;
}

void
tuner_player_controller_play_station (TunerPlayerController* self,
                                      TunerModelStation* station)
{
	GstPlayer* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	TunerModelStation* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GstPlayer* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = self->priv->_player;
	gst_player_stop (_tmp0_);
	_tmp1_ = _g_object_ref0 (station);
	_g_object_unref0 (self->priv->_station);
	self->priv->_station = _tmp1_;
	_tmp2_ = self->priv->_station;
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIG_SIGNAL], 0, _tmp2_);
	_tmp5_ = self->priv->_station;
	_tmp6_ = tuner_model_station_get_urlResolved (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_ != NULL) {
		TunerModelStation* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp8_ = self->priv->_station;
		_tmp9_ = tuner_model_station_get_urlResolved (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp4_ = g_strcmp0 (_tmp10_, "") != 0;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		TunerModelStation* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp11_ = self->priv->_station;
		_tmp12_ = tuner_model_station_get_urlResolved (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp3_ = _tmp13_;
	} else {
		TunerModelStation* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp14_ = self->priv->_station;
		_tmp15_ = tuner_model_station_get_url (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp3_ = _tmp16_;
	}
	_tmp17_ = self->priv->_player;
	gst_player_set_uri (_tmp17_, _tmp3_);
	tuner_player_controller_set_play_error (self, FALSE);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
}

/**
     * @brief Checks if the player has a station to play.
     *
     * @return True if a station is ready to be played
     */
gboolean
tuner_player_controller_can_play (TunerPlayerController* self)
{
	TunerModelStation* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_station;
	result = _tmp0_ != NULL;
	return result;
}

/**
     * @brief Toggles play/pause state of the player.
     */
void
tuner_player_controller_play_pause (TunerPlayerController* self)
{
	g_return_if_fail (self != NULL);
	switch (self->priv->_player_state) {
		case TUNER_PLAYER_CONTROLLER_IS_PLAYING:
		case TUNER_PLAYER_CONTROLLER_IS_BUFFERING:
		{
			GstPlayer* _tmp0_;
			_tmp0_ = self->priv->_player;
			gst_player_stop (_tmp0_);
			break;
		}
		default:
		{
			GstPlayer* _tmp1_;
			_tmp1_ = self->priv->_player;
			gst_player_play (_tmp1_);
			break;
		}
	}
}

/**
     * @brief Stops the player
     *
     */
void
tuner_player_controller_stop (TunerPlayerController* self)
{
	GstPlayer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_player;
	gst_player_stop (_tmp0_);
}

/**
     * Shuffles the current playlist.
     *
     * This method randomizes the order of the tracks in the current playlist.
     */
void
tuner_player_controller_shuffle (TunerPlayerController* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_SHUFFLE_REQUESTED_SIG_SIGNAL], 0);
}

TunerPlayerController*
tuner_player_controller_construct (GType object_type)
{
	TunerPlayerController * self = NULL;
	self = (TunerPlayerController*) g_object_new (object_type, NULL);
	return self;
}

TunerPlayerController*
tuner_player_controller_new (void)
{
	return tuner_player_controller_construct (TUNER_TYPE_PLAYER_CONTROLLER);
}

gboolean
tuner_player_controller_get_play_error (TunerPlayerController* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_play_error;
	return result;
}

static void
tuner_player_controller_set_play_error (TunerPlayerController* self,
                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_player_controller_get_play_error (self);
	if (old_value != value) {
		self->priv->_play_error = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY]);
	}
}

TunerPlayerControllerIs
tuner_player_controller_get_player_state (TunerPlayerController* self)
{
	TunerPlayerControllerIs result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_player_state;
	return result;
}

static gboolean
_tuner_player_controller_player_state_____lambda7_ (TunerPlayerController* self)
{
	TunerModelStation* _tmp0_;
	gboolean result;
	_tmp0_ = self->priv->_station;
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TAPE_COUNTER_SIG_SIGNAL], 0, _tmp0_);
	result = G_SOURCE_CONTINUE;
	return result;
}

static gboolean
__tuner_player_controller_player_state_____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = _tuner_player_controller_player_state_____lambda7_ ((TunerPlayerController*) self);
	return result;
}

static void
tuner_player_controller_set_player_state (TunerPlayerController* self,
                                          TunerPlayerControllerIs value)
{
	TunerModelStation* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	self->priv->_player_state = value;
	_tmp0_ = self->priv->_station;
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIG_SIGNAL], 0, _tmp0_, value);
	if (value == TUNER_PLAYER_CONTROLLER_IS_STOPPED) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = value == TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR;
	}
	if (_tmp1_) {
		if (self->priv->_tape_counter_id > ((guint) 0)) {
			g_source_remove (self->priv->_tape_counter_id);
			self->priv->_tape_counter_id = (guint) 0;
		}
	} else {
		if (value == TUNER_PLAYER_CONTROLLER_IS_PLAYING) {
			self->priv->_tape_counter_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, TUNER_PLAYER_CONTROLLER_TEN_MINUTES_IN_SECONDS, __tuner_player_controller_player_state_____lambda7__gsource_func, g_object_ref (self), g_object_unref);
		}
	}
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY]);
}

TunerModelStation*
tuner_player_controller_get_station (TunerPlayerController* self)
{
	TunerModelStation* result;
	TunerModelStation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_station;
	result = _tmp0_;
	return result;
}

void
tuner_player_controller_set_station (TunerPlayerController* self,
                                     TunerModelStation* value)
{
	gboolean _tmp0_ = FALSE;
	TunerModelStation* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_station;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		TunerModelStation* _tmp2_;
		_tmp2_ = self->priv->_station;
		_tmp0_ = _tmp2_ != value;
	}
	if (_tmp0_) {
		TunerModelMetadata* _tmp3_;
		TunerModelStation* _tmp4_;
		TunerModelStation* _tmp5_;
		_tmp3_ = tuner_model_metadata_new ();
		_g_object_unref0 (self->priv->_metadata);
		self->priv->_metadata = _tmp3_;
		_tmp4_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_station);
		self->priv->_station = _tmp4_;
		_tmp5_ = self->priv->_station;
		tuner_player_controller_play_station (self, _tmp5_);
	}
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY]);
}

gdouble
tuner_player_controller_get_volume (TunerPlayerController* self)
{
	gdouble result;
	GstPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_player;
	_tmp1_ = gst_player_get_volume (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
tuner_player_controller_set_volume (TunerPlayerController* self,
                                    gdouble value)
{
	GstPlayer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_player;
	gst_player_set_volume (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
_tuner_player_controller___lambda12_ (TunerPlayerController* self,
                                      GError* _error_)
{
	GstPlayer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_if_fail (_error_ != NULL);
	tuner_player_controller_set_play_error (self, TRUE);
	_tmp0_ = self->priv->_player;
	_tmp1_ = gst_player_get_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = _error_->message;
	_tmp6_ = string_to_string (_tmp5_);
	_tmp7_ = g_strconcat ("player error on url ", _tmp4_, ": ", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	g_info ("PlayerController.vala:75: %s", _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp3_);
}

static void
__tuner_player_controller___lambda12__gst_player_error (GstPlayer* _sender,
                                                        GError* object,
                                                        gpointer self)
{
	_tuner_player_controller___lambda12_ ((TunerPlayerController*) self, object);
}

static void
_tuner_player_controller___lambda13_ (TunerPlayerController* self,
                                      GstPlayerMediaInfo* obj)
{
	TunerModelMetadata* _tmp0_;
	g_return_if_fail (obj != NULL);
	_tmp0_ = self->priv->_metadata;
	if (tuner_model_metadata_process_media_info_update (_tmp0_, obj)) {
		TunerModelStation* _tmp1_;
		TunerModelMetadata* _tmp2_;
		_tmp1_ = self->priv->_station;
		_tmp2_ = self->priv->_metadata;
		g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_METADATA_CHANGED_SIG_SIGNAL], 0, _tmp1_, _tmp2_);
	}
}

static void
__tuner_player_controller___lambda13__gst_player_media_info_updated (GstPlayer* _sender,
                                                                     GstPlayerMediaInfo* object,
                                                                     gpointer self)
{
	_tuner_player_controller___lambda13_ ((TunerPlayerController*) self, object);
}

static void
_tuner_player_controller___lambda14_ (TunerPlayerController* self,
                                      GstPlayer* obj)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	TunerApplication* _tmp2_;
	TunerApplication* _tmp3_;
	TunerSettings* _tmp4_;
	TunerSettings* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	g_return_if_fail (obj != NULL);
	_tmp0_ = gst_player_get_volume (obj);
	_tmp1_ = _tmp0_;
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIG_SIGNAL], 0, _tmp1_);
	_tmp2_ = tuner_app ();
	_tmp3_ = _tmp2_;
	_tmp4_ = tuner_application_get_settings (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = gst_player_get_volume (obj);
	_tmp7_ = _tmp6_;
	tuner_settings_set_volume (_tmp5_, _tmp7_);
	_g_object_unref0 (_tmp3_);
}

static void
__tuner_player_controller___lambda14__gst_player_volume_changed (GstPlayer* _sender,
                                                                 gpointer self)
{
	_tuner_player_controller___lambda14_ ((TunerPlayerController*) self, _sender);
}

static void
_tuner_player_controller___lambda15_ (TunerPlayerController* self,
                                      GstPlayerState state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (state == GST_PLAYER_STATE_PLAYING) {
		_tmp1_ = state == GST_PLAYER_STATE_BUFFERING;
	} else {
		_tmp1_ = FALSE;
	}
	if (!_tmp1_) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = self->priv->_player_state_name;
		_tmp3_ = gst_player_state_get_name (state);
		_tmp0_ = g_strcmp0 (_tmp2_, _tmp3_) != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = gst_player_state_get_name (state);
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->_player_state_name);
		self->priv->_player_state_name = _tmp5_;
		_tmp6_ = gst_player_state_get_name (state);
		tuner_player_controller_set_play_state (self, _tmp6_);
	}
}

static void
__tuner_player_controller___lambda15__gst_player_state_changed (GstPlayer* _sender,
                                                                GstPlayerState object,
                                                                gpointer self)
{
	_tuner_player_controller___lambda15_ ((TunerPlayerController*) self, object);
}

static GObject *
tuner_player_controller_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerPlayerController * self;
	GstPlayer* _tmp0_;
	GstPlayer* _tmp1_;
	GstPlayer* _tmp2_;
	GstPlayer* _tmp3_;
	GstPlayer* _tmp4_;
	parent_class = G_OBJECT_CLASS (tuner_player_controller_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	_tmp0_ = gst_player_new (NULL, NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->_player);
	self->priv->_player = _tmp0_;
	_tmp1_ = self->priv->_player;
	g_signal_connect_object (_tmp1_, "error", (GCallback) __tuner_player_controller___lambda12__gst_player_error, self, 0);
	_tmp2_ = self->priv->_player;
	g_signal_connect_object (_tmp2_, "media-info-updated", (GCallback) __tuner_player_controller___lambda13__gst_player_media_info_updated, self, 0);
	_tmp3_ = self->priv->_player;
	g_signal_connect_object (_tmp3_, "volume-changed", (GCallback) __tuner_player_controller___lambda14__gst_player_volume_changed, self, 0);
	_tmp4_ = self->priv->_player;
	g_signal_connect_object (_tmp4_, "state-changed", (GCallback) __tuner_player_controller___lambda15__gst_player_state_changed, self, 0);
	return obj;
}

static void
tuner_player_controller_class_init (TunerPlayerControllerClass * klass,
                                    gpointer klass_data)
{
	tuner_player_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerPlayerController_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_player_controller_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_player_controller_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_player_controller_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_player_controller_finalize;
	/** The error received when playing, if any */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY] = g_param_spec_boolean ("play-error", "play-error", "play-error", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** 
	     * @brief Player State getter/setter
	     * 
	     * Set by player signal. Does the tape counter emit
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY] = g_param_spec_enum ("player-state", "player-state", "player-state", TUNER_PLAYER_CONTROLLER_TYPE_IS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** 
	     * @brief Station
	     * @return The current station being played.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_STATION_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY] = g_param_spec_object ("station", "station", "station", TUNER_MODEL_TYPE_STATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** 
	     * @brief Volume
	     * @return The current volume of the player.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** Signal emitted when the station changes. */
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIG_SIGNAL] = g_signal_new ("station-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNER_MODEL_TYPE_STATION);
	/** Signal emitted when the player state changes. */
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIG_SIGNAL] = g_signal_new ("state-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, TUNER_MODEL_TYPE_STATION, TUNER_PLAYER_CONTROLLER_TYPE_IS);
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_METADATA_CHANGED_SIG_SIGNAL] = g_signal_new ("metadata-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TUNER_MODEL_TYPE_STATION, TUNER_MODEL_TYPE_METADATA);
	/** Signal emitted when the volume changes. */
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIG_SIGNAL] = g_signal_new ("volume-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	/** Signal emitted every ten minutes that a station has been playing continuously. */
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TAPE_COUNTER_SIG_SIGNAL] = g_signal_new ("tape-counter-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNER_MODEL_TYPE_STATION);
	/** @brief Signal emitted when the shuffle is requested   */
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_SHUFFLE_REQUESTED_SIG_SIGNAL] = g_signal_new ("shuffle-requested-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
tuner_player_controller_instance_init (TunerPlayerController * self,
                                       gpointer klass)
{
	self->priv = tuner_player_controller_get_instance_private (self);
	self->priv->_tape_counter_id = (guint) 0;
}

static void
tuner_player_controller_finalize (GObject * obj)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	_g_object_unref0 (self->priv->_player);
	_g_object_unref0 (self->priv->_station);
	_g_object_unref0 (self->priv->_metadata);
	_g_free0 (self->priv->_player_state_name);
	G_OBJECT_CLASS (tuner_player_controller_parent_class)->finalize (obj);
}

/**
 * @class Tuner.PlayerController
 * @brief Manages the playback of radio stations.
 *
 * This class handles the player state, volume control, and metadata extraction
 * from the media stream. It emits signals when the station, state, title,
 * or volume changes.
 */
static GType
tuner_player_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerPlayerControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_player_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerPlayerController), 0, (GInstanceInitFunc) tuner_player_controller_instance_init, NULL };
	GType tuner_player_controller_type_id;
	tuner_player_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerPlayerController", &g_define_type_info, 0);
	TunerPlayerController_private_offset = g_type_add_instance_private (tuner_player_controller_type_id, sizeof (TunerPlayerControllerPrivate));
	return tuner_player_controller_type_id;
}

GType
tuner_player_controller_get_type (void)
{
	static volatile gsize tuner_player_controller_type_id__once = 0;
	if (g_once_init_enter (&tuner_player_controller_type_id__once)) {
		GType tuner_player_controller_type_id;
		tuner_player_controller_type_id = tuner_player_controller_get_type_once ();
		g_once_init_leave (&tuner_player_controller_type_id__once, tuner_player_controller_type_id);
	}
	return tuner_player_controller_type_id__once;
}

static void
_vala_tuner_player_controller_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	switch (property_id) {
		case TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY:
		g_value_set_boolean (value, tuner_player_controller_get_play_error (self));
		break;
		case TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY:
		g_value_set_enum (value, tuner_player_controller_get_player_state (self));
		break;
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
		g_value_set_object (value, tuner_player_controller_get_station (self));
		break;
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
		g_value_set_double (value, tuner_player_controller_get_volume (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_player_controller_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	switch (property_id) {
		case TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY:
		tuner_player_controller_set_play_error (self, g_value_get_boolean (value));
		break;
		case TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY:
		tuner_player_controller_set_player_state (self, g_value_get_enum (value));
		break;
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
		tuner_player_controller_set_station (self, g_value_get_object (value));
		break;
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
		tuner_player_controller_set_volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

