/* Favicon.c generated by valac 0.56.8, the Vala compiler
 * generated from Favicon.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file Favicon.vala
 *
 * @brief Favicon index, loading and caching
 * 
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>

#define TUNER_MODEL_FAVICON_FADE_MS 400
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;
typedef struct _TunerModelFaviconPrivate TunerModelFaviconPrivate;
enum  {
	TUNER_MODEL_FAVICON_0_PROPERTY,
	TUNER_MODEL_FAVICON_FAVICON_PROPERTY,
	TUNER_MODEL_FAVICON_NUM_PROPERTIES
};
static GParamSpec* tuner_model_favicon_properties[TUNER_MODEL_FAVICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TunerModelFaviconUpdateFaviconImageData TunerModelFaviconUpdateFaviconImageData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _TunerModelFaviconLoadFaviconAsyncData TunerModelFaviconLoadFaviconAsyncData;
enum  {
	TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL,
	TUNER_MODEL_FAVICON_NUM_SIGNALS
};
static guint tuner_model_favicon_signals[TUNER_MODEL_FAVICON_NUM_SIGNALS] = {0};

struct _TunerModelFavicon {
	GObject parent_instance;
	TunerModelFaviconPrivate * priv;
};

struct _TunerModelFaviconClass {
	GObjectClass parent_class;
	gchar* (*favicon_cache_file) (TunerModelFavicon* self);
};

struct _TunerModelFaviconPrivate {
	gchar* _favicon;
	GUri* _favicon_uri;
	gint _favicon_loaded;
	GdkPixbuf* _favicon_pixbuf;
};

struct _TunerModelFaviconUpdateFaviconImageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerModelFavicon* self;
	GtkImage* favicon_image;
	gboolean reload;
	gchar* defaulticon;
	gboolean result;
	gboolean reloading;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GdkPixbuf* _tmp2_;
	GeeSet* _tmp3_;
	const gchar* _tmp4_;
	GdkPixbuf* _tmp5_;
	gboolean _tmp6_;
	GeeSet* _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_;
};

struct _TunerModelFaviconLoadFaviconAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerModelFavicon* self;
	gboolean reload;
	gboolean _tmp0_;
	GUri* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeSet* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GdkPixbuf* pixbuf;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* _tmp14_;
	gint _tmp15_;
	GError* e;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GError* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GUri* _tmp23_;
	guint status_code;
	GInputStream* stream;
	GUri* _tmp24_;
	guint _tmp25_;
	GInputStream* _tmp26_;
	gboolean _tmp27_;
	GInputStream* _tmp28_;
	GdkPixbuf* _vala1_pixbuf;
	GInputStream* _tmp29_;
	GdkPixbuf* _tmp30_;
	GdkPixbuf* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GdkPixbuf* _tmp34_;
	GdkPixbuf* _tmp35_;
	gint _tmp36_;
	GError* _vala1_e;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	GUri* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	const gchar* _tmp42_;
	GError* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	GUri* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	GeeSet* _tmp58_;
	const gchar* _tmp59_;
	GError* _inner_error0_;
};

static gint TunerModelFavicon_private_offset;
static gpointer tuner_model_favicon_parent_class = NULL;
static GeeSet* tuner_model_favicon_FAILING_FAVICON;
static GeeSet* tuner_model_favicon_FAILING_FAVICON = NULL;

VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN gchar* tuner_model_favicon_favicon_cache_file (TunerModelFavicon* self);
static gchar* tuner_model_favicon_real_favicon_cache_file (TunerModelFavicon* self);
VALA_EXTERN gint tuner_model_favicon_favicon_loaded (TunerModelFavicon* self);
static void tuner_model_favicon_update_favicon_image_data_free (gpointer _data);
VALA_EXTERN void tuner_model_favicon_update_favicon_image (TunerModelFavicon* self,
                                               GtkImage* favicon_image,
                                               gboolean reload,
                                               const gchar* defaulticon,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
VALA_EXTERN gboolean tuner_model_favicon_update_favicon_image_finish (TunerModelFavicon* self,
                                                          GAsyncResult* _res_);
static gboolean tuner_model_favicon_update_favicon_image_co (TunerModelFaviconUpdateFaviconImageData* _data_);
VALA_EXTERN void tuner_fade (GtkImage* image,
                 guint duration_ms,
                 gboolean fading_in,
                 GAsyncReadyCallback _callback_,
                 gpointer _user_data_);
VALA_EXTERN void tuner_fade_finish (GAsyncResult* _res_);
static void tuner_model_favicon_update_favicon_image_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
VALA_EXTERN void tuner_model_favicon_load_favicon_async (TunerModelFavicon* self,
                                             gboolean reload,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void tuner_model_favicon_load_favicon_finish (TunerModelFavicon* self,
                                              GAsyncResult* _res_);
static void tuner_model_favicon_load_favicon_async_data_free (gpointer _data);
static gboolean tuner_model_favicon_load_favicon_async_co (TunerModelFaviconLoadFaviconAsyncData* _data_);
VALA_EXTERN void tuner_http_client_GETasync (GUri* uri,
                                 gint priority,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static void tuner_model_favicon_load_favicon_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
VALA_EXTERN TunerModelFavicon* tuner_model_favicon_construct (GType object_type);
VALA_EXTERN const gchar* tuner_model_favicon_get_favicon (TunerModelFavicon* self);
VALA_EXTERN void tuner_model_favicon_set_favicon (TunerModelFavicon* self,
                                      const gchar* value);
static void tuner_model_favicon_finalize (GObject * obj);
static GType tuner_model_favicon_get_type_once (void);
static void _vala_tuner_model_favicon_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_tuner_model_favicon_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
tuner_model_favicon_get_instance_private (TunerModelFavicon* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelFavicon_private_offset);
}

/**
     * @brief Abstract method to get the file path of the favicon cache.
     *
     * This method should be implemented by subclasses to provide the specific
     * file path where the favicon cache is stored.
     *
     * @return A string representing the file path of the favicon cache.
     */
static gchar*
tuner_model_favicon_real_favicon_cache_file (TunerModelFavicon* self)
{
	g_critical ("Type `%s' does not implement abstract method `tuner_model_favicon_favicon_cache_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gchar*
tuner_model_favicon_favicon_cache_file (TunerModelFavicon* self)
{
	TunerModelFaviconClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = TUNER_MODEL_FAVICON_GET_CLASS (self);
	if (_klass_->favicon_cache_file) {
		return _klass_->favicon_cache_file (self);
	}
	return NULL;
}

/**
     * @brief Has favicon been loaded.
     *
     * @return An integer indicating the status of the favicon loading process.
     */
gint
tuner_model_favicon_favicon_loaded (TunerModelFavicon* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_favicon_loaded;
	return result;
}

static void
tuner_model_favicon_update_favicon_image_data_free (gpointer _data)
{
	TunerModelFaviconUpdateFaviconImageData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->favicon_image);
	_g_free0 (_data_->defaulticon);
	_g_object_unref0 (_data_->self);
	g_slice_free (TunerModelFaviconUpdateFaviconImageData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_model_favicon_update_favicon_image (TunerModelFavicon* self,
                                          GtkImage* favicon_image,
                                          gboolean reload,
                                          const gchar* defaulticon,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	TunerModelFaviconUpdateFaviconImageData* _data_;
	TunerModelFavicon* _tmp0_;
	GtkImage* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (favicon_image != NULL);
	g_return_if_fail (defaulticon != NULL);
	_data_ = g_slice_new0 (TunerModelFaviconUpdateFaviconImageData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_model_favicon_update_favicon_image_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (favicon_image);
	_g_object_unref0 (_data_->favicon_image);
	_data_->favicon_image = _tmp1_;
	_data_->reload = reload;
	_tmp2_ = g_strdup (defaulticon);
	_g_free0 (_data_->defaulticon);
	_data_->defaulticon = _tmp2_;
	tuner_model_favicon_update_favicon_image_co (_data_);
}

gboolean
tuner_model_favicon_update_favicon_image_finish (TunerModelFavicon* self,
                                                 GAsyncResult* _res_)
{
	gboolean result;
	TunerModelFaviconUpdateFaviconImageData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

/**
     * @brief Asynchronously sets the given image to the station favicon, if available.
     *
     * Load the known icons first, and if reload, go around after trying the favicon url
     *
     * @param {Image} favicon_image - The favicon image to be updated.
     * @param {bool} reload - Whether to force reload the favicon from source.
     * @return {bool} True if the favicon was available and the image updated.
     */
static void
tuner_model_favicon_update_favicon_image_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	TunerModelFaviconUpdateFaviconImageData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_model_favicon_update_favicon_image_co (_data_);
}

static gboolean
tuner_model_favicon_update_favicon_image_co (TunerModelFaviconUpdateFaviconImageData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
		case 5:
		goto _state_5;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->reloading = FALSE;
	{
		_data_->_tmp0_ = TRUE;
		while (TRUE) {
			if (!_data_->_tmp0_) {
				if (!_data_->reloading) {
					break;
				}
			}
			_data_->_tmp0_ = FALSE;
			{
				_data_->_tmp2_ = _data_->self->priv->_favicon_pixbuf;
				if (_data_->_tmp2_ == NULL) {
					_data_->_tmp1_ = TRUE;
				} else {
					_data_->_tmp3_ = tuner_model_favicon_FAILING_FAVICON;
					_data_->_tmp4_ = _data_->self->priv->_favicon;
					_data_->_tmp1_ = gee_collection_contains ((GeeCollection*) _data_->_tmp3_, _data_->_tmp4_);
				}
				if (_data_->_tmp1_) {
					_data_->_state_ = 1;
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, FALSE, tuner_model_favicon_update_favicon_image_ready, _data_);
					return FALSE;
					_state_1:
					tuner_fade_finish (_data_->_res_);
					gtk_image_set_from_icon_name (_data_->favicon_image, _data_->defaulticon, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
					_data_->_state_ = 2;
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, TRUE, tuner_model_favicon_update_favicon_image_ready, _data_);
					return FALSE;
					_state_2:
					tuner_fade_finish (_data_->_res_);
				} else {
					_data_->_state_ = 3;
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, FALSE, tuner_model_favicon_update_favicon_image_ready, _data_);
					return FALSE;
					_state_3:
					tuner_fade_finish (_data_->_res_);
					_data_->_tmp5_ = _data_->self->priv->_favicon_pixbuf;
					gtk_image_set_from_pixbuf (_data_->favicon_image, _data_->_tmp5_);
					_data_->_state_ = 4;
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, TRUE, tuner_model_favicon_update_favicon_image_ready, _data_);
					return FALSE;
					_state_4:
					tuner_fade_finish (_data_->_res_);
				}
			}
			__finally0:
			{
				gtk_widget_set_opacity ((GtkWidget*) _data_->favicon_image, (gdouble) 1);
				_data_->reloading = FALSE;
			}
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
			if (_data_->reload) {
				_data_->_tmp6_ = _data_->self->priv->_favicon_loaded < 2;
			} else {
				_data_->_tmp6_ = FALSE;
			}
			if (_data_->_tmp6_) {
				_data_->_tmp7_ = tuner_model_favicon_FAILING_FAVICON;
				_data_->_tmp8_ = _data_->self->priv->_favicon;
				gee_collection_remove ((GeeCollection*) _data_->_tmp7_, _data_->_tmp8_);
				_data_->_state_ = 5;
				tuner_model_favicon_load_favicon_async (_data_->self, TRUE, tuner_model_favicon_update_favicon_image_ready, _data_);
				return FALSE;
				_state_5:
				tuner_model_favicon_load_favicon_finish (_data_->self, _data_->_res_);
				_data_->reloading = TRUE;
				_data_->reload = FALSE;
			}
		}
	}
	_data_->result = TRUE;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
tuner_model_favicon_load_favicon_async_data_free (gpointer _data)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (TunerModelFaviconLoadFaviconAsyncData, _data_);
}

void
tuner_model_favicon_load_favicon_async (TunerModelFavicon* self,
                                        gboolean reload,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
	TunerModelFavicon* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (TunerModelFaviconLoadFaviconAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_model_favicon_load_favicon_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->reload = reload;
	tuner_model_favicon_load_favicon_async_co (_data_);
}

void
tuner_model_favicon_load_favicon_finish (TunerModelFavicon* self,
                                         GAsyncResult* _res_)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

/**
     * @brief Asynchronously loads the favicon for the station.
     *
     * Loads from cache is not requesting reload and cache exists
     * Otherwise async calls to the website to download the favicon,
     * then stores it in the cache and replaces the Station favicon
     *
     * @param {bool} reload - Whether to force reload the favicon.
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
tuner_model_favicon_load_favicon_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_model_favicon_load_favicon_async_co (_data_);
}

static gboolean
tuner_model_favicon_load_favicon_async_co (TunerModelFaviconLoadFaviconAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = _data_->self->priv->_favicon_uri;
	if (_data_->_tmp1_ == NULL) {
		_data_->_tmp0_ = TRUE;
	} else {
		if (!_data_->reload) {
			_data_->_tmp2_ = _data_->self->priv->_favicon_loaded > 0;
		} else {
			_data_->_tmp2_ = FALSE;
		}
		_data_->_tmp0_ = _data_->_tmp2_;
	}
	if (_data_->_tmp0_) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (!_data_->reload) {
		_data_->_tmp4_ = TRUE;
	} else {
		_data_->_tmp5_ = tuner_model_favicon_FAILING_FAVICON;
		_data_->_tmp6_ = _data_->self->priv->_favicon;
		_data_->_tmp4_ = gee_collection_contains ((GeeCollection*) _data_->_tmp5_, _data_->_tmp6_);
	}
	if (_data_->_tmp4_) {
		_data_->_tmp7_ = tuner_model_favicon_favicon_cache_file (_data_->self);
		_data_->_tmp8_ = _data_->_tmp7_;
		_data_->_tmp3_ = g_file_test (_data_->_tmp8_, G_FILE_TEST_EXISTS);
		_g_free0 (_data_->_tmp8_);
	} else {
		_data_->_tmp3_ = FALSE;
	}
	if (_data_->_tmp3_) {
		{
			_data_->_tmp9_ = tuner_model_favicon_favicon_cache_file (_data_->self);
			_data_->_tmp10_ = _data_->_tmp9_;
			_data_->_tmp11_ = gdk_pixbuf_new_from_file_at_scale (_data_->_tmp10_, 48, 48, TRUE, &_data_->_inner_error0_);
			_data_->_tmp12_ = _data_->_tmp11_;
			_g_free0 (_data_->_tmp10_);
			_data_->pixbuf = _data_->_tmp12_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_data_->_tmp13_ = _data_->pixbuf;
			_data_->_tmp14_ = _g_object_ref0 (_data_->_tmp13_);
			_g_object_unref0 (_data_->self->priv->_favicon_pixbuf);
			_data_->self->priv->_favicon_pixbuf = _data_->_tmp14_;
			_data_->_tmp15_ = _data_->self->priv->_favicon_loaded;
			_data_->self->priv->_favicon_loaded = _data_->_tmp15_ + 1;
			g_signal_emit (_data_->self, tuner_model_favicon_signals[TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL], 0);
			_g_object_unref0 (_data_->pixbuf);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp16_ = _data_->self->priv->_favicon;
			_data_->_tmp17_ = string_to_string (_data_->_tmp16_);
			_data_->_tmp18_ = _data_->e;
			_data_->_tmp19_ = _data_->_tmp18_->message;
			_data_->_tmp20_ = string_to_string (_data_->_tmp19_);
			_data_->_tmp21_ = g_strconcat (_data_->_tmp17_, " - Failed to load cached favicon: ", _data_->_tmp20_, NULL);
			_data_->_tmp22_ = _data_->_tmp21_;
			g_info ("Favicon.vala:165: %s", _data_->_tmp22_);
			_g_free0 (_data_->_tmp22_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp23_ = _data_->self->priv->_favicon_uri;
	if (_data_->_tmp23_ == NULL) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp24_ = _data_->self->priv->_favicon_uri;
	_data_->_tmp25_ = 0U;
	_data_->_state_ = 1;
	tuner_http_client_GETasync (_data_->_tmp24_, G_PRIORITY_LOW, tuner_model_favicon_load_favicon_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp26_ = tuner_http_client_GETasync_finish (_data_->_res_, &_data_->_tmp25_);
	_data_->status_code = _data_->_tmp25_;
	_data_->stream = _data_->_tmp26_;
	_data_->_tmp28_ = _data_->stream;
	if (_data_->_tmp28_ != NULL) {
		_data_->_tmp27_ = _data_->status_code == ((guint) 200);
	} else {
		_data_->_tmp27_ = FALSE;
	}
	if (_data_->_tmp27_) {
		{
			_data_->_tmp29_ = _data_->stream;
			_data_->_state_ = 2;
			gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp29_, 48, 48, TRUE, NULL, tuner_model_favicon_load_favicon_async_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp30_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
			_data_->_vala1_pixbuf = _data_->_tmp30_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_data_->_tmp31_ = _data_->_vala1_pixbuf;
			_data_->_tmp32_ = tuner_model_favicon_favicon_cache_file (_data_->self);
			_data_->_tmp33_ = _data_->_tmp32_;
			gdk_pixbuf_save (_data_->_tmp31_, _data_->_tmp33_, "png", &_data_->_inner_error0_, NULL);
			_g_free0 (_data_->_tmp33_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_object_unref0 (_data_->_vala1_pixbuf);
				goto __catch1_g_error;
			}
			_data_->_tmp34_ = _data_->_vala1_pixbuf;
			_data_->_tmp35_ = _g_object_ref0 (_data_->_tmp34_);
			_g_object_unref0 (_data_->self->priv->_favicon_pixbuf);
			_data_->self->priv->_favicon_pixbuf = _data_->_tmp35_;
			_data_->_tmp36_ = _data_->self->priv->_favicon_loaded;
			_data_->self->priv->_favicon_loaded = _data_->_tmp36_ + 1;
			g_signal_emit (_data_->self, tuner_model_favicon_signals[TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL], 0);
			_g_object_unref0 (_data_->_vala1_pixbuf);
			_g_object_unref0 (_data_->stream);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1_e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp37_ = _data_->self->priv->_favicon;
			_data_->_tmp38_ = string_to_string (_data_->_tmp37_);
			_data_->_tmp39_ = _data_->self->priv->_favicon_uri;
			_data_->_tmp40_ = g_uri_to_string (_data_->_tmp39_);
			_data_->_tmp41_ = _data_->_tmp40_;
			_data_->_tmp42_ = string_to_string (_data_->_tmp41_);
			_data_->_tmp43_ = _data_->_vala1_e;
			_data_->_tmp44_ = _data_->_tmp43_->message;
			_data_->_tmp45_ = string_to_string (_data_->_tmp44_);
			_data_->_tmp46_ = g_strconcat (_data_->_tmp38_, " - Failed to process favicon ", _data_->_tmp42_, " - ", _data_->_tmp45_, NULL);
			_data_->_tmp47_ = _data_->_tmp46_;
			g_debug ("Favicon.vala:190: %s", _data_->_tmp47_);
			_g_free0 (_data_->_tmp47_);
			_g_free0 (_data_->_tmp41_);
			_g_error_free0 (_data_->_vala1_e);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->stream);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp48_ = _data_->self->priv->_favicon;
	_data_->_tmp49_ = string_to_string (_data_->_tmp48_);
	_data_->_tmp50_ = _data_->self->priv->_favicon_uri;
	_data_->_tmp51_ = g_uri_to_string (_data_->_tmp50_);
	_data_->_tmp52_ = _data_->_tmp51_;
	_data_->_tmp53_ = string_to_string (_data_->_tmp52_);
	_data_->_tmp54_ = g_strdup_printf ("%u", _data_->status_code);
	_data_->_tmp55_ = _data_->_tmp54_;
	_data_->_tmp56_ = g_strconcat (_data_->_tmp49_, " - Failed to load favicon ", _data_->_tmp53_, " - Status code: ", _data_->_tmp55_, NULL);
	_data_->_tmp57_ = _data_->_tmp56_;
	g_info ("Favicon.vala:193: %s", _data_->_tmp57_);
	_g_free0 (_data_->_tmp57_);
	_g_free0 (_data_->_tmp55_);
	_g_free0 (_data_->_tmp52_);
	_data_->_tmp58_ = tuner_model_favicon_FAILING_FAVICON;
	_data_->_tmp59_ = _data_->self->priv->_favicon;
	gee_collection_add ((GeeCollection*) _data_->_tmp58_, _data_->_tmp59_);
	_g_object_unref0 (_data_->stream);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

TunerModelFavicon*
tuner_model_favicon_construct (GType object_type)
{
	TunerModelFavicon * self = NULL;
	self = (TunerModelFavicon*) g_object_new (object_type, NULL);
	return self;
}

const gchar*
tuner_model_favicon_get_favicon (TunerModelFavicon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_favicon;
	result = _tmp0_;
	return result;
}

void
tuner_model_favicon_set_favicon (TunerModelFavicon* self,
                                 const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	if (value == NULL) {
		_tmp1_ = TRUE;
	} else {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = strlen (value);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_ == 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = self->priv->_favicon;
		_tmp0_ = g_strcmp0 (_tmp4_, value) == 0;
	}
	if (_tmp0_) {
		return;
	}
	_tmp5_ = g_strdup (value);
	_g_free0 (self->priv->_favicon);
	self->priv->_favicon = _tmp5_;
	{
		GUri* _tmp6_ = NULL;
		GUri* _tmp7_;
		GUri* _tmp8_;
		_tmp7_ = g_uri_parse (value, G_URI_FLAGS_NONE, &_inner_error0_);
		_tmp6_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_URI_ERROR) {
				goto __catch0_g_uri_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp8_ = _tmp6_;
		_tmp6_ = NULL;
		_g_uri_unref0 (self->priv->_favicon_uri);
		self->priv->_favicon_uri = _tmp8_;
		_g_uri_unref0 (_tmp6_);
	}
	goto __finally0;
	__catch0_g_uri_error:
	{
		GeeSet* _tmp9_;
		g_clear_error (&_inner_error0_);
		_tmp9_ = tuner_model_favicon_FAILING_FAVICON;
		gee_collection_add ((GeeCollection*) _tmp9_, value);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	g_object_notify_by_pspec ((GObject *) self, tuner_model_favicon_properties[TUNER_MODEL_FAVICON_FAVICON_PROPERTY]);
}

static void
tuner_model_favicon_class_init (TunerModelFaviconClass * klass,
                                gpointer klass_data)
{
	GeeHashSet* _tmp0_;
	tuner_model_favicon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerModelFavicon_private_offset);
	((TunerModelFaviconClass *) klass)->favicon_cache_file = (gchar* (*) (TunerModelFavicon*)) tuner_model_favicon_real_favicon_cache_file;
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_model_favicon_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_model_favicon_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_model_favicon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_FAVICON_FAVICON_PROPERTY, tuner_model_favicon_properties[TUNER_MODEL_FAVICON_FAVICON_PROPERTY] = g_param_spec_string ("favicon", "favicon", "favicon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	tuner_model_favicon_signals[TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL] = g_signal_new ("favicon-sig", TUNER_MODEL_TYPE_FAVICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	tuner_model_favicon_FAILING_FAVICON = (GeeSet*) _tmp0_;
}

static void
tuner_model_favicon_instance_init (TunerModelFavicon * self,
                                   gpointer klass)
{
	self->priv = tuner_model_favicon_get_instance_private (self);
	self->priv->_favicon_loaded = 0;
}

static void
tuner_model_favicon_finalize (GObject * obj)
{
	TunerModelFavicon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon);
	_g_free0 (self->priv->_favicon);
	_g_uri_unref0 (self->priv->_favicon_uri);
	_g_object_unref0 (self->priv->_favicon_pixbuf);
	G_OBJECT_CLASS (tuner_model_favicon_parent_class)->finalize (obj);
}

/**
 * @class Favicon
 * @brief Favicon location and loading.
 */
static GType
tuner_model_favicon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelFaviconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_favicon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelFavicon), 0, (GInstanceInitFunc) tuner_model_favicon_instance_init, NULL };
	GType tuner_model_favicon_type_id;
	tuner_model_favicon_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerModelFavicon", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	TunerModelFavicon_private_offset = g_type_add_instance_private (tuner_model_favicon_type_id, sizeof (TunerModelFaviconPrivate));
	return tuner_model_favicon_type_id;
}

GType
tuner_model_favicon_get_type (void)
{
	static volatile gsize tuner_model_favicon_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_favicon_type_id__once)) {
		GType tuner_model_favicon_type_id;
		tuner_model_favicon_type_id = tuner_model_favicon_get_type_once ();
		g_once_init_leave (&tuner_model_favicon_type_id__once, tuner_model_favicon_type_id);
	}
	return tuner_model_favicon_type_id__once;
}

static void
_vala_tuner_model_favicon_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelFavicon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon);
	switch (property_id) {
		case TUNER_MODEL_FAVICON_FAVICON_PROPERTY:
		g_value_set_string (value, tuner_model_favicon_get_favicon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_model_favicon_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelFavicon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon);
	switch (property_id) {
		case TUNER_MODEL_FAVICON_FAVICON_PROPERTY:
		tuner_model_favicon_set_favicon (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

