/* Station.c generated by valac 0.56.8, the Vala compiler
 * generated from Station.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file Station.vala
 *
 * @brief Station metadata and related cachable objects
 * 
 */
/** @property {string} favicon - Favicon URL of the station. */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <json-glib/json-glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;
typedef struct _TunerModelFaviconPrivate TunerModelFaviconPrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
typedef struct _TunerModelStationPrivate TunerModelStationPrivate;
enum  {
	TUNER_MODEL_STATION_0_PROPERTY,
	TUNER_MODEL_STATION_CHANGEUUID_PROPERTY,
	TUNER_MODEL_STATION_STATIONUUID_PROPERTY,
	TUNER_MODEL_STATION_NAME_PROPERTY,
	TUNER_MODEL_STATION_URL_PROPERTY,
	TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY,
	TUNER_MODEL_STATION_HOMEPAGE_PROPERTY,
	TUNER_MODEL_STATION_TAGS_PROPERTY,
	TUNER_MODEL_STATION_COUNTRY_PROPERTY,
	TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY,
	TUNER_MODEL_STATION_ISO_3166_2_PROPERTY,
	TUNER_MODEL_STATION_STATE_PROPERTY,
	TUNER_MODEL_STATION_LANGUAGE_PROPERTY,
	TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY,
	TUNER_MODEL_STATION_CODEC_PROPERTY,
	TUNER_MODEL_STATION_BITRATE_PROPERTY,
	TUNER_MODEL_STATION_HLS_PROPERTY,
	TUNER_MODEL_STATION_STARRED_PROPERTY,
	TUNER_MODEL_STATION_NUM_PROPERTIES
};
static GParamSpec* tuner_model_station_properties[TUNER_MODEL_STATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_STAR_STORE (tuner_star_store_get_type ())
#define TUNER_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STAR_STORE, TunerStarStore))
#define TUNER_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))
#define TUNER_IS_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STAR_STORE))
#define TUNER_IS_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STAR_STORE))
#define TUNER_STAR_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))

typedef struct _TunerStarStore TunerStarStore;
typedef struct _TunerStarStoreClass TunerStarStoreClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	TUNER_MODEL_STATION_STATION_STAR_CHANGED_SIG_SIGNAL,
	TUNER_MODEL_STATION_NUM_SIGNALS
};
static guint tuner_model_station_signals[TUNER_MODEL_STATION_NUM_SIGNALS] = {0};

struct _TunerModelFavicon {
	GObject parent_instance;
	TunerModelFaviconPrivate * priv;
};

struct _TunerModelFaviconClass {
	GObjectClass parent_class;
	gchar* (*favicon_cache_file) (TunerModelFavicon* self);
};

struct _TunerModelStation {
	TunerModelFavicon parent_instance;
	TunerModelStationPrivate * priv;
	gint votes;
	gchar* lastchangetime;
	gchar* lastchangetime_iso8601;
	gint lastcheckok;
	gchar* lastchecktime;
	gchar* lastchecktime_iso8601;
	gchar* lastcheckoktime;
	gchar* lastcheckoktime_iso8601;
	gchar* lastlocalchecktime;
	gchar* lastlocalchecktime_iso8601;
	gchar* clicktimestamp;
	gchar* clicktimestamp_iso8601;
	gint clickcount;
	gint clicktrend;
	gint ssl_error;
	gchar* geo_lat;
	gchar* geo_long;
	gboolean has_extended_info;
	gboolean is_in_index;
	gboolean is_up_to_date;
	gchar* up_to_date_difference;
};

struct _TunerModelStationClass {
	TunerModelFaviconClass parent_class;
};

struct _TunerModelStationPrivate {
	gchar* _changeuuid;
	gchar* _stationuuid;
	gchar* _name;
	gchar* _url;
	gchar* _urlResolved;
	gchar* _homepage;
	gchar* _tags;
	gchar* _country;
	gchar* _countrycode;
	gchar* _iso_3166_2;
	gchar* _state;
	gchar* _language;
	gchar* _languagecodes;
	gchar* _codec;
	gint _bitrate;
	gint _hls;
	gboolean _starred;
	gchar* _favicon_cache_file;
};

static gint TunerModelStation_private_offset;
static gpointer tuner_model_station_parent_class = NULL;
static GeeMap* tuner_model_station_STATIONS;
static GeeMap* tuner_model_station_STATIONS = NULL;

VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN gchar* tuner_model_favicon_favicon_cache_file (TunerModelFavicon* self);
VALA_EXTERN TunerModelStation* tuner_model_station_make (JsonNode* json_node);
VALA_EXTERN TunerModelStation* tuner_model_station_new_basic (JsonNode* json_node);
VALA_EXTERN TunerModelStation* tuner_model_station_construct_basic (GType object_type,
                                                        JsonNode* json_node);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN GType tuner_star_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStarStore, g_object_unref)
VALA_EXTERN TunerStarStore* tuner_application_get_stars (TunerApplication* self);
VALA_EXTERN gboolean tuner_star_store_contains (TunerStarStore* self,
                                    TunerModelStation* station);
VALA_EXTERN void tuner_model_station_set_starred (TunerModelStation* self,
                                      gboolean value);
VALA_EXTERN const gchar* tuner_model_station_get_stationuuid (TunerModelStation* self);
VALA_EXTERN void tuner_model_favicon_load_favicon_async (TunerModelFavicon* self,
                                             gboolean reload,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void tuner_model_favicon_load_favicon_finish (TunerModelFavicon* self,
                                              GAsyncResult* _res_);
static void __lambda32_ (TunerModelStation* self,
                  const gchar* log_domain,
                  GLogLevelFlags log_level,
                  const gchar* message);
static void ___lambda32__glog_func (const gchar* log_domain,
                             GLogLevelFlags log_levels,
                             const gchar* message,
                             gpointer self);
static void __lambda33_ (TunerModelStation* self,
                  const gchar* log_domain,
                  GLogLevelFlags log_level,
                  const gchar* message);
static void ___lambda33__glog_func (const gchar* log_domain,
                             GLogLevelFlags log_levels,
                             const gchar* message,
                             gpointer self);
static void tuner_model_station_set_changeuuid (TunerModelStation* self,
                                         const gchar* value);
static void tuner_model_station_set_stationuuid (TunerModelStation* self,
                                          const gchar* value);
static void tuner_model_station_set_name (TunerModelStation* self,
                                   const gchar* value);
static void tuner_model_station_set_url (TunerModelStation* self,
                                  const gchar* value);
static void tuner_model_station_set_urlResolved (TunerModelStation* self,
                                          const gchar* value);
static void tuner_model_station_set_homepage (TunerModelStation* self,
                                       const gchar* value);
VALA_EXTERN void tuner_model_favicon_set_favicon (TunerModelFavicon* self,
                                      const gchar* value);
static void tuner_model_station_set_tags (TunerModelStation* self,
                                   const gchar* value);
static void tuner_model_station_set_country (TunerModelStation* self,
                                      const gchar* value);
static void tuner_model_station_set_countrycode (TunerModelStation* self,
                                          const gchar* value);
static void tuner_model_station_set_iso_3166_2 (TunerModelStation* self,
                                         const gchar* value);
static void tuner_model_station_set_state (TunerModelStation* self,
                                    const gchar* value);
static void tuner_model_station_set_language (TunerModelStation* self,
                                       const gchar* value);
static void tuner_model_station_set_languagecodes (TunerModelStation* self,
                                            const gchar* value);
static void tuner_model_station_set_codec (TunerModelStation* self,
                                    const gchar* value);
static void tuner_model_station_set_bitrate (TunerModelStation* self,
                                      gint value);
static void tuner_model_station_set_hls (TunerModelStation* self,
                                  gint value);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
VALA_EXTERN const gchar* tuner_application_get_cache_dir (TunerApplication* self);
VALA_EXTERN gboolean tuner_model_station_toggle_starred (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
VALA_EXTERN gchar* tuner_model_station_popularity (TunerModelStation* self);
VALA_EXTERN gchar* tuner_model_station_to_string (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_name (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_set_up_to_date_with (TunerModelStation* self,
                                                  TunerModelStation* p);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
VALA_EXTERN gint tuner_model_station_get_bitrate (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_codec (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_urlResolved (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_favicon_get_favicon (TunerModelFavicon* self);
VALA_EXTERN const gchar* tuner_model_station_get_homepage (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_tags (TunerModelStation* self);
VALA_EXTERN TunerModelStation* tuner_model_station_updated (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_equals (TunerModelStation* self,
                                     TunerModelStation* other);
static gchar* tuner_model_station_real_favicon_cache_file (TunerModelFavicon* base);
VALA_EXTERN TunerModelStation* tuner_model_station_new (void);
VALA_EXTERN TunerModelStation* tuner_model_station_construct (GType object_type);
VALA_EXTERN TunerModelFavicon* tuner_model_favicon_construct (GType object_type);
VALA_EXTERN const gchar* tuner_model_station_get_changeuuid (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_country (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_countrycode (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_iso_3166_2 (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_state (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_language (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_languagecodes (TunerModelStation* self);
VALA_EXTERN gint tuner_model_station_get_hls (TunerModelStation* self);
static void tuner_model_station_finalize (GObject * obj);
static GType tuner_model_station_get_type_once (void);
static void _vala_tuner_model_station_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_tuner_model_station_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
tuner_model_station_get_instance_private (TunerModelStation* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelStation_private_offset);
}

/**
* @brief Returns a unique, initiated Station instance for a given JSON node.
*
* If station has already been initiated based on stationuuid, returns the existing Station
    * Checks with StarStore and sets stations starred status
*
* @param {Json.Node} json_node - The JSON node containing station data.
* @return {Station} The created Station instance.
*/
TunerModelStation*
tuner_model_station_make (JsonNode* json_node)
{
	TunerModelStation* station = NULL;
	TunerModelStation* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
	TunerModelStation* _tmp3_;
	gchar* _tmp4_;
	TunerModelStation* _tmp5_;
	TunerApplication* _tmp6_;
	TunerApplication* _tmp7_;
	TunerStarStore* _tmp8_;
	TunerStarStore* _tmp9_;
	TunerModelStation* _tmp10_;
	GeeMap* _tmp11_;
	TunerModelStation* _tmp12_;
	const gchar* _tmp13_;
	GeeMap* _tmp19_;
	TunerModelStation* _tmp20_;
	const gchar* _tmp21_;
	gpointer _tmp22_;
	TunerModelStation* result;
	g_return_val_if_fail (json_node != NULL, NULL);
	_tmp0_ = tuner_model_station_new_basic (json_node);
	station = _tmp0_;
	_tmp1_ = station;
	_tmp1_->is_in_index = TRUE;
	_tmp2_ = station;
	_tmp2_->is_up_to_date = TRUE;
	_tmp3_ = station;
	_tmp4_ = g_strdup ("");
	_g_free0 (_tmp3_->up_to_date_difference);
	_tmp3_->up_to_date_difference = _tmp4_;
	_tmp5_ = station;
	_tmp6_ = tuner_app ();
	_tmp7_ = _tmp6_;
	_tmp8_ = tuner_application_get_stars (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = station;
	tuner_model_station_set_starred (_tmp5_, tuner_star_store_contains (_tmp9_, _tmp10_));
	_g_object_unref0 (_tmp7_);
	_tmp11_ = tuner_model_station_STATIONS;
	_tmp12_ = station;
	_tmp13_ = _tmp12_->priv->_stationuuid;
	if (!gee_map_has_key (_tmp11_, _tmp13_)) {
		GeeMap* _tmp14_;
		TunerModelStation* _tmp15_;
		const gchar* _tmp16_;
		TunerModelStation* _tmp17_;
		TunerModelStation* _tmp18_;
		_tmp14_ = tuner_model_station_STATIONS;
		_tmp15_ = station;
		_tmp16_ = _tmp15_->priv->_stationuuid;
		_tmp17_ = station;
		gee_map_set (_tmp14_, _tmp16_, _tmp17_);
		_tmp18_ = station;
		tuner_model_favicon_load_favicon_async ((TunerModelFavicon*) _tmp18_, FALSE, NULL, NULL);
	}
	_tmp19_ = tuner_model_station_STATIONS;
	_tmp20_ = station;
	_tmp21_ = _tmp20_->priv->_stationuuid;
	_tmp22_ = gee_map_get (_tmp19_, _tmp21_);
	result = (TunerModelStation*) _tmp22_;
	_g_object_unref0 (station);
	return result;
}

/**
     * @brief Constructor a basic Station instance from a JSON node.
     *
     * @param {Json.Node} json_node - The JSON node containing station data.
     */
static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static void
__lambda32_ (TunerModelStation* self,
             const gchar* log_domain,
             GLogLevelFlags log_level,
             const gchar* message)
{
	g_return_if_fail (message != NULL);
}

static void
___lambda32__glog_func (const gchar* log_domain,
                        GLogLevelFlags log_levels,
                        const gchar* message,
                        gpointer self)
{
	__lambda32_ ((TunerModelStation*) self, log_domain, log_levels, message);
}

static void
__lambda33_ (TunerModelStation* self,
             const gchar* log_domain,
             GLogLevelFlags log_level,
             const gchar* message)
{
	g_return_if_fail (message != NULL);
}

static void
___lambda33__glog_func (const gchar* log_domain,
                        GLogLevelFlags log_levels,
                        const gchar* message,
                        gpointer self)
{
	__lambda33_ ((TunerModelStation*) self, log_domain, log_levels, message);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

TunerModelStation*
tuner_model_station_construct_basic (GType object_type,
                                     JsonNode* json_node)
{
	TunerModelStation * self = NULL;
	JsonObject* json_object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	guint log_handler_1 = 0U;
	guint log_handler_2 = 0U;
	TunerApplication* _tmp138_;
	TunerApplication* _tmp139_;
	const gchar* _tmp140_;
	const gchar* _tmp141_;
	const gchar* _tmp142_;
	gchar* _tmp143_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (json_node != NULL, NULL);
	self = (TunerModelStation*) g_object_new (object_type, NULL);
	if (json_node == NULL) {
		g_warning ("Station.vala:190: %s", "Station - no JSON");
		return self;
	}
	_tmp0_ = json_node_get_object (json_node);
	_tmp1_ = _json_object_ref0 (_tmp0_);
	json_object = _tmp1_;
	log_handler_1 = g_log_set_handler ("Json", G_LOG_LEVEL_CRITICAL, ___lambda32__glog_func, self);
	log_handler_2 = g_log_set_handler (NULL, G_LOG_LEVEL_CRITICAL, ___lambda33__glog_func, self);
	{
		JsonObject* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		JsonObject* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		JsonObject* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		JsonObject* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		JsonObject* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		JsonObject* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		JsonObject* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		JsonObject* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		JsonObject* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		JsonObject* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		JsonObject* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		JsonObject* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		JsonObject* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		JsonObject* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		JsonObject* _tmp58_;
		JsonObject* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		JsonObject* _tmp62_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
		JsonObject* _tmp65_;
		const gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		JsonObject* _tmp69_;
		JsonObject* _tmp70_;
		JsonObject* _tmp71_;
		JsonObject* _tmp72_;
		const gchar* _tmp73_;
		gchar* _tmp74_;
		JsonObject* _tmp75_;
		const gchar* _tmp76_;
		gchar* _tmp77_;
		JsonObject* _tmp78_;
		const gchar* _tmp79_;
		gchar* _tmp80_;
		JsonObject* _tmp81_;
		const gchar* _tmp82_;
		gchar* _tmp83_;
		JsonObject* _tmp84_;
		const gchar* _tmp85_;
		gchar* _tmp86_;
		JsonObject* _tmp87_;
		const gchar* _tmp88_;
		gchar* _tmp89_;
		JsonObject* _tmp90_;
		const gchar* _tmp91_;
		gchar* _tmp92_;
		JsonObject* _tmp93_;
		const gchar* _tmp94_;
		gchar* _tmp95_;
		JsonObject* _tmp96_;
		const gchar* _tmp97_;
		gchar* _tmp98_;
		JsonObject* _tmp99_;
		JsonObject* _tmp100_;
		JsonObject* _tmp101_;
		JsonObject* _tmp102_;
		const gchar* _tmp103_;
		gchar* _tmp104_;
		JsonObject* _tmp105_;
		const gchar* _tmp106_;
		gchar* _tmp107_;
		JsonObject* _tmp108_;
		gchar* go_serial_fudge = NULL;
		JsonObject* _tmp109_;
		const gchar* _tmp110_;
		gchar* _tmp111_;
		gboolean _tmp112_ = FALSE;
		const gchar* _tmp113_;
		JsonObject* _tmp116_;
		JsonObject* _tmp118_;
		JsonObject* _tmp123_;
		JsonObject* _tmp128_;
		JsonObject* _tmp133_;
		_tmp2_ = json_object;
		_tmp3_ = json_object_get_string_member (_tmp2_, "changeuuid");
		_tmp4_ = string_strip (_tmp3_);
		_tmp5_ = _tmp4_;
		tuner_model_station_set_changeuuid (self, _tmp5_);
		_g_free0 (_tmp5_);
		_tmp6_ = json_object;
		_tmp7_ = json_object_get_string_member (_tmp6_, "stationuuid");
		_tmp8_ = string_strip (_tmp7_);
		_tmp9_ = _tmp8_;
		tuner_model_station_set_stationuuid (self, _tmp9_);
		_g_free0 (_tmp9_);
		_tmp10_ = json_object;
		_tmp11_ = json_object_get_string_member (_tmp10_, "name");
		_tmp12_ = string_strip (_tmp11_);
		_tmp13_ = _tmp12_;
		tuner_model_station_set_name (self, _tmp13_);
		_g_free0 (_tmp13_);
		_tmp14_ = json_object;
		_tmp15_ = json_object_get_string_member (_tmp14_, "url");
		_tmp16_ = string_strip (_tmp15_);
		_tmp17_ = _tmp16_;
		tuner_model_station_set_url (self, _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = json_object;
		_tmp19_ = json_object_get_string_member (_tmp18_, "url_resolved");
		_tmp20_ = string_strip (_tmp19_);
		_tmp21_ = _tmp20_;
		tuner_model_station_set_urlResolved (self, _tmp21_);
		_g_free0 (_tmp21_);
		_tmp22_ = json_object;
		_tmp23_ = json_object_get_string_member (_tmp22_, "homepage");
		_tmp24_ = string_strip (_tmp23_);
		_tmp25_ = _tmp24_;
		tuner_model_station_set_homepage (self, _tmp25_);
		_g_free0 (_tmp25_);
		_tmp26_ = json_object;
		_tmp27_ = json_object_get_string_member (_tmp26_, "favicon");
		_tmp28_ = string_strip (_tmp27_);
		_tmp29_ = _tmp28_;
		tuner_model_favicon_set_favicon ((TunerModelFavicon*) self, _tmp29_);
		_g_free0 (_tmp29_);
		_tmp30_ = json_object;
		_tmp31_ = json_object_get_string_member (_tmp30_, "tags");
		_tmp32_ = string_strip (_tmp31_);
		_tmp33_ = _tmp32_;
		tuner_model_station_set_tags (self, _tmp33_);
		_g_free0 (_tmp33_);
		_tmp34_ = json_object;
		_tmp35_ = json_object_get_string_member (_tmp34_, "country");
		_tmp36_ = string_strip (_tmp35_);
		_tmp37_ = _tmp36_;
		tuner_model_station_set_country (self, _tmp37_);
		_g_free0 (_tmp37_);
		_tmp38_ = json_object;
		_tmp39_ = json_object_get_string_member (_tmp38_, "countrycode");
		_tmp40_ = string_strip (_tmp39_);
		_tmp41_ = _tmp40_;
		tuner_model_station_set_countrycode (self, _tmp41_);
		_g_free0 (_tmp41_);
		_tmp42_ = json_object;
		_tmp43_ = json_object_get_string_member (_tmp42_, "iso_3166_2");
		_tmp44_ = string_strip (_tmp43_);
		_tmp45_ = _tmp44_;
		tuner_model_station_set_iso_3166_2 (self, _tmp45_);
		_g_free0 (_tmp45_);
		_tmp46_ = json_object;
		_tmp47_ = json_object_get_string_member (_tmp46_, "state");
		_tmp48_ = string_strip (_tmp47_);
		_tmp49_ = _tmp48_;
		tuner_model_station_set_state (self, _tmp49_);
		_g_free0 (_tmp49_);
		_tmp50_ = json_object;
		_tmp51_ = json_object_get_string_member (_tmp50_, "language");
		_tmp52_ = string_strip (_tmp51_);
		_tmp53_ = _tmp52_;
		tuner_model_station_set_language (self, _tmp53_);
		_g_free0 (_tmp53_);
		_tmp54_ = json_object;
		_tmp55_ = json_object_get_string_member (_tmp54_, "languagecodes");
		_tmp56_ = string_strip (_tmp55_);
		_tmp57_ = _tmp56_;
		tuner_model_station_set_languagecodes (self, _tmp57_);
		_g_free0 (_tmp57_);
		_tmp58_ = json_object;
		self->votes = (gint) json_object_get_int_member (_tmp58_, "votes");
		_tmp59_ = json_object;
		_tmp60_ = json_object_get_string_member (_tmp59_, "lastchangetime");
		_tmp61_ = string_strip (_tmp60_);
		_g_free0 (self->lastchangetime);
		self->lastchangetime = _tmp61_;
		_tmp62_ = json_object;
		_tmp63_ = json_object_get_string_member (_tmp62_, "lastchangetime_iso8601");
		_tmp64_ = string_strip (_tmp63_);
		_g_free0 (self->lastchangetime_iso8601);
		self->lastchangetime_iso8601 = _tmp64_;
		_tmp65_ = json_object;
		_tmp66_ = json_object_get_string_member (_tmp65_, "codec");
		_tmp67_ = string_strip (_tmp66_);
		_tmp68_ = _tmp67_;
		tuner_model_station_set_codec (self, _tmp68_);
		_g_free0 (_tmp68_);
		_tmp69_ = json_object;
		tuner_model_station_set_bitrate (self, (gint) json_object_get_int_member (_tmp69_, "bitrate"));
		_tmp70_ = json_object;
		tuner_model_station_set_hls (self, (gint) json_object_get_int_member (_tmp70_, "hls"));
		_tmp71_ = json_object;
		self->lastcheckok = (gint) json_object_get_int_member (_tmp71_, "lastcheckok");
		_tmp72_ = json_object;
		_tmp73_ = json_object_get_string_member (_tmp72_, "lastchecktime");
		_tmp74_ = string_strip (_tmp73_);
		_g_free0 (self->lastchecktime);
		self->lastchecktime = _tmp74_;
		_tmp75_ = json_object;
		_tmp76_ = json_object_get_string_member (_tmp75_, "lastchecktime_iso8601");
		_tmp77_ = string_strip (_tmp76_);
		_g_free0 (self->lastchecktime_iso8601);
		self->lastchecktime_iso8601 = _tmp77_;
		_tmp78_ = json_object;
		_tmp79_ = json_object_get_string_member (_tmp78_, "lastcheckoktime");
		_tmp80_ = string_strip (_tmp79_);
		_g_free0 (self->lastcheckoktime);
		self->lastcheckoktime = _tmp80_;
		_tmp81_ = json_object;
		_tmp82_ = json_object_get_string_member (_tmp81_, "lastcheckoktime_iso8601");
		_tmp83_ = string_strip (_tmp82_);
		_g_free0 (self->lastcheckoktime_iso8601);
		self->lastcheckoktime_iso8601 = _tmp83_;
		_tmp84_ = json_object;
		_tmp85_ = json_object_get_string_member (_tmp84_, "lastlocalchecktime");
		_tmp86_ = string_strip (_tmp85_);
		_g_free0 (self->lastlocalchecktime);
		self->lastlocalchecktime = _tmp86_;
		_tmp87_ = json_object;
		_tmp88_ = json_object_get_string_member (_tmp87_, "lastlocalchecktime_iso8601");
		_tmp89_ = string_strip (_tmp88_);
		_g_free0 (self->lastlocalchecktime_iso8601);
		self->lastlocalchecktime_iso8601 = _tmp89_;
		_tmp90_ = json_object;
		_tmp91_ = json_object_get_string_member (_tmp90_, "has_extended_info");
		_tmp92_ = string_strip (_tmp91_);
		_g_free0 (self->lastlocalchecktime_iso8601);
		self->lastlocalchecktime_iso8601 = _tmp92_;
		_tmp93_ = json_object;
		_tmp94_ = json_object_get_string_member (_tmp93_, "clicktimestamp");
		_tmp95_ = string_strip (_tmp94_);
		_g_free0 (self->clicktimestamp);
		self->clicktimestamp = _tmp95_;
		_tmp96_ = json_object;
		_tmp97_ = json_object_get_string_member (_tmp96_, "clicktimestamp_iso8601");
		_tmp98_ = string_strip (_tmp97_);
		_g_free0 (self->clicktimestamp_iso8601);
		self->clicktimestamp_iso8601 = _tmp98_;
		_tmp99_ = json_object;
		self->clickcount = (gint) json_object_get_int_member (_tmp99_, "clickcount");
		_tmp100_ = json_object;
		self->clicktrend = (gint) json_object_get_int_member (_tmp100_, "clicktrend");
		_tmp101_ = json_object;
		self->ssl_error = (gint) json_object_get_int_member (_tmp101_, "ssl_error");
		_tmp102_ = json_object;
		_tmp103_ = json_object_get_string_member (_tmp102_, "geo_lat");
		_tmp104_ = string_strip (_tmp103_);
		_g_free0 (self->geo_lat);
		self->geo_lat = _tmp104_;
		_tmp105_ = json_object;
		_tmp106_ = json_object_get_string_member (_tmp105_, "geo_long");
		_tmp107_ = string_strip (_tmp106_);
		_g_free0 (self->geo_long);
		self->geo_long = _tmp107_;
		_tmp108_ = json_object;
		self->has_extended_info = json_object_get_boolean_member (_tmp108_, "has_extended_info");
		_tmp109_ = json_object;
		_tmp110_ = json_object_get_string_member (_tmp109_, "urlResolved");
		_tmp111_ = string_strip (_tmp110_);
		go_serial_fudge = _tmp111_;
		_tmp113_ = go_serial_fudge;
		if (_tmp113_ != NULL) {
			const gchar* _tmp114_;
			_tmp114_ = go_serial_fudge;
			_tmp112_ = g_strcmp0 (_tmp114_, "") != 0;
		} else {
			_tmp112_ = FALSE;
		}
		if (_tmp112_) {
			const gchar* _tmp115_;
			_tmp115_ = go_serial_fudge;
			tuner_model_station_set_urlResolved (self, _tmp115_);
		}
		_tmp116_ = json_object;
		if (json_object_has_member (_tmp116_, "starred")) {
			JsonObject* _tmp117_;
			_tmp117_ = json_object;
			self->priv->_starred = json_object_get_boolean_member (_tmp117_, "starred");
		}
		_tmp118_ = json_object;
		if (json_object_has_member (_tmp118_, "id")) {
			JsonObject* _tmp119_;
			const gchar* _tmp120_;
			gchar* _tmp121_;
			gchar* _tmp122_;
			_tmp119_ = json_object;
			_tmp120_ = json_object_get_string_member (_tmp119_, "id");
			_tmp121_ = string_strip (_tmp120_);
			_tmp122_ = _tmp121_;
			tuner_model_station_set_stationuuid (self, _tmp122_);
			_g_free0 (_tmp122_);
		}
		_tmp123_ = json_object;
		if (json_object_has_member (_tmp123_, "favicon-url")) {
			JsonObject* _tmp124_;
			const gchar* _tmp125_;
			gchar* _tmp126_;
			gchar* _tmp127_;
			_tmp124_ = json_object;
			_tmp125_ = json_object_get_string_member (_tmp124_, "favicon-url");
			_tmp126_ = string_strip (_tmp125_);
			_tmp127_ = _tmp126_;
			tuner_model_favicon_set_favicon ((TunerModelFavicon*) self, _tmp127_);
			_g_free0 (_tmp127_);
		}
		_tmp128_ = json_object;
		if (json_object_has_member (_tmp128_, "location")) {
			JsonObject* _tmp129_;
			const gchar* _tmp130_;
			gchar* _tmp131_;
			gchar* _tmp132_;
			_tmp129_ = json_object;
			_tmp130_ = json_object_get_string_member (_tmp129_, "location");
			_tmp131_ = string_strip (_tmp130_);
			_tmp132_ = _tmp131_;
			tuner_model_station_set_country (self, _tmp132_);
			_g_free0 (_tmp132_);
		}
		_tmp133_ = json_object;
		if (json_object_has_member (_tmp133_, "title")) {
			JsonObject* _tmp134_;
			const gchar* _tmp135_;
			gchar* _tmp136_;
			gchar* _tmp137_;
			_tmp134_ = json_object;
			_tmp135_ = json_object_get_string_member (_tmp134_, "title");
			_tmp136_ = string_strip (_tmp135_);
			_tmp137_ = _tmp136_;
			tuner_model_station_set_name (self, _tmp137_);
			_g_free0 (_tmp137_);
		}
		_g_free0 (go_serial_fudge);
	}
	__finally0:
	{
		g_log_remove_handler (NULL, log_handler_2);
		g_log_remove_handler ("Json", log_handler_1);
	}
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_json_object_unref0 (json_object);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	self->is_in_index = FALSE;
	self->is_up_to_date = FALSE;
	_tmp138_ = tuner_application_get_instance ();
	_tmp139_ = _tmp138_;
	_tmp140_ = tuner_application_get_cache_dir (_tmp139_);
	_tmp141_ = _tmp140_;
	_tmp142_ = self->priv->_stationuuid;
	_tmp143_ = g_build_filename (_tmp141_, _tmp142_, NULL);
	_g_free0 (self->priv->_favicon_cache_file);
	self->priv->_favicon_cache_file = _tmp143_;
	tuner_model_favicon_load_favicon_async ((TunerModelFavicon*) self, FALSE, NULL, NULL);
	_json_object_unref0 (json_object);
	return self;
}

TunerModelStation*
tuner_model_station_new_basic (JsonNode* json_node)
{
	return tuner_model_station_construct_basic (TUNER_MODEL_TYPE_STATION, json_node);
}

/**
     * @brief Toggles the Starred status of the station
     * @return {bool} True if Station is Starred.
     */
gboolean
tuner_model_station_toggle_starred (TunerModelStation* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = tuner_model_station_get_starred (self);
	_tmp1_ = _tmp0_;
	tuner_model_station_set_starred (self, !_tmp1_);
	result = self->priv->_starred;
	return result;
}

/**
     * @brief Returns a string representation of the station.
     * @return {string} A string in the format "[id] title".
     */
gchar*
tuner_model_station_popularity (TunerModelStation* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%i", self->votes);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("%i", self->clickcount);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf ("%i", self->clicktrend);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat ("Votes: ", _tmp1_, "\t Clicks: ", _tmp3_, "\t Trend: ", _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup (_ (_tmp7_));
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp9_;
	return result;
}

/**
     * @brief Returns a string representation of the station.
     * @return {string} A string in the format "[id] title".
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

gchar*
tuner_model_station_to_string (TunerModelStation* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stationuuid;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = self->priv->_name;
	_tmp3_ = string_to_string (_tmp2_);
	_tmp4_ = g_strconcat ("[", _tmp1_, "] ", _tmp3_, NULL);
	result = _tmp4_;
	return result;
}

/**
     * @brief Sets the station up-to-date status based on the given station.
     *
     * @param {Station} p - The station to compare with.
     * @return {bool} True if the station is up-to-date with the given station.
     */
gboolean
tuner_model_station_set_up_to_date_with (TunerModelStation* self,
                                         TunerModelStation* p)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (p == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = self->priv->_stationuuid;
		_tmp2_ = p->priv->_stationuuid;
		_tmp0_ = g_strcmp0 (_tmp1_, _tmp2_) != 0;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = self->priv->_url;
	_tmp6_ = p->priv->_url;
	if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = self->priv->_bitrate;
		_tmp8_ = p->priv->_bitrate;
		_tmp4_ = _tmp7_ == _tmp8_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = self->priv->_codec;
		_tmp10_ = p->priv->_codec;
		_tmp3_ = g_strcmp0 (_tmp9_, _tmp10_) == 0;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gchar* _tmp11_;
		self->is_up_to_date = TRUE;
		_tmp11_ = g_strdup ("");
		_g_free0 (self->up_to_date_difference);
		self->up_to_date_difference = _tmp11_;
	} else {
		GString* sb = NULL;
		GString* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp30_;
		gint _tmp31_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		GString* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		_tmp12_ = g_string_new (_ ("Changes:"));
		sb = _tmp12_;
		_tmp13_ = self->priv->_url;
		_tmp14_ = p->priv->_url;
		if (g_strcmp0 (_tmp13_, _tmp14_) != 0) {
			GString* _tmp15_;
			_tmp15_ = sb;
			g_string_append (_tmp15_, _ ("\n\tStream Url"));
		}
		_tmp16_ = self->priv->_urlResolved;
		_tmp17_ = p->priv->_urlResolved;
		if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
			GString* _tmp18_;
			_tmp18_ = sb;
			g_string_append (_tmp18_, _ ("\n\tStream Resolved Url"));
		}
		_tmp19_ = tuner_model_favicon_get_favicon ((TunerModelFavicon*) self);
		_tmp20_ = _tmp19_;
		_tmp21_ = tuner_model_favicon_get_favicon ((TunerModelFavicon*) p);
		_tmp22_ = _tmp21_;
		if (g_strcmp0 (_tmp20_, _tmp22_) != 0) {
			GString* _tmp23_;
			_tmp23_ = sb;
			g_string_append (_tmp23_, _ ("\n\tFavicon address"));
		}
		_tmp24_ = self->priv->_homepage;
		_tmp25_ = p->priv->_homepage;
		if (g_strcmp0 (_tmp24_, _tmp25_) != 0) {
			GString* _tmp26_;
			_tmp26_ = sb;
			g_string_append (_tmp26_, _ ("\n\tHomepage address"));
		}
		_tmp27_ = self->priv->_tags;
		_tmp28_ = p->priv->_tags;
		if (g_strcmp0 (_tmp27_, _tmp28_) != 0) {
			GString* _tmp29_;
			_tmp29_ = sb;
			g_string_append (_tmp29_, _ ("\n\tStation tags"));
		}
		_tmp30_ = self->priv->_bitrate;
		_tmp31_ = p->priv->_bitrate;
		if (_tmp30_ != _tmp31_) {
			GString* _tmp32_;
			_tmp32_ = sb;
			g_string_append (_tmp32_, _ ("\n\tBitrate: $(this.bitrate) > $(p.bitrate)"));
		}
		_tmp33_ = self->priv->_codec;
		_tmp34_ = p->priv->_codec;
		if (g_strcmp0 (_tmp33_, _tmp34_) != 0) {
			GString* _tmp35_;
			_tmp35_ = sb;
			g_string_append (_tmp35_, _ ("\n\todec: $(this.codec) > $(p.codec)"));
		}
		_tmp36_ = sb;
		_tmp37_ = _tmp36_->str;
		_tmp38_ = g_strdup (_tmp37_);
		_g_free0 (self->up_to_date_difference);
		self->up_to_date_difference = _tmp38_;
		self->is_up_to_date = FALSE;
		_g_string_free0 (sb);
	}
	result = TRUE;
	return result;
}

/**
     * Returns a copy of the current station from the Provider.
     * 
     * @return A new {@link Station} instance with the current properties
     */
TunerModelStation*
tuner_model_station_updated (TunerModelStation* self)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	TunerModelStation* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = tuner_model_station_STATIONS;
	_tmp1_ = self->priv->_stationuuid;
	_tmp2_ = gee_map_get (_tmp0_, _tmp1_);
	result = (TunerModelStation*) _tmp2_;
	return result;
}

/**
     * @brief Compares this station with another station.
     * @param other The station to compare with.
     * @return {bool} True if stations are equal.
     */
gboolean
tuner_model_station_equals (TunerModelStation* self,
                            TunerModelStation* other)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = self->priv->_stationuuid;
	_tmp1_ = other->priv->_stationuuid;
	result = g_strcmp0 (_tmp0_, _tmp1_) == 0;
	return result;
}

static gchar*
tuner_model_station_real_favicon_cache_file (TunerModelFavicon* base)
{
	TunerModelStation * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	self = (TunerModelStation*) base;
	_tmp0_ = self->priv->_favicon_cache_file;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

TunerModelStation*
tuner_model_station_construct (GType object_type)
{
	TunerModelStation * self = NULL;
	self = (TunerModelStation*) tuner_model_favicon_construct (object_type);
	return self;
}

TunerModelStation*
tuner_model_station_new (void)
{
	return tuner_model_station_construct (TUNER_MODEL_TYPE_STATION);
}

const gchar*
tuner_model_station_get_changeuuid (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_changeuuid;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_changeuuid (TunerModelStation* self,
                                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_changeuuid (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_changeuuid);
		self->priv->_changeuuid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_CHANGEUUID_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_stationuuid (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stationuuid;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_stationuuid (TunerModelStation* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_stationuuid (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_stationuuid);
		self->priv->_stationuuid = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_STATIONUUID_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_name (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_name (TunerModelStation* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_NAME_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_url (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_url;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_url (TunerModelStation* self,
                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_url (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_url);
		self->priv->_url = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_URL_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_urlResolved (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_urlResolved;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_urlResolved (TunerModelStation* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_urlResolved (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_urlResolved);
		self->priv->_urlResolved = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_homepage (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_homepage;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_homepage (TunerModelStation* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_homepage (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_homepage);
		self->priv->_homepage = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_HOMEPAGE_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_tags (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tags;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_tags (TunerModelStation* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_tags (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_tags);
		self->priv->_tags = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_TAGS_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_country (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_country;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_country (TunerModelStation* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_country (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_country);
		self->priv->_country = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRY_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_countrycode (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_countrycode;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_countrycode (TunerModelStation* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_countrycode (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_countrycode);
		self->priv->_countrycode = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_iso_3166_2 (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_iso_3166_2;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_iso_3166_2 (TunerModelStation* self,
                                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_iso_3166_2 (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_iso_3166_2);
		self->priv->_iso_3166_2 = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_ISO_3166_2_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_state (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_state (TunerModelStation* self,
                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_state (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_state);
		self->priv->_state = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_STATE_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_language (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_language;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_language (TunerModelStation* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_language (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_language);
		self->priv->_language = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGE_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_languagecodes (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_languagecodes;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_languagecodes (TunerModelStation* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_languagecodes (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_languagecodes);
		self->priv->_languagecodes = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY]);
	}
}

const gchar*
tuner_model_station_get_codec (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_codec;
	result = _tmp0_;
	return result;
}

static void
tuner_model_station_set_codec (TunerModelStation* self,
                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_codec (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_codec);
		self->priv->_codec = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_CODEC_PROPERTY]);
	}
}

gint
tuner_model_station_get_bitrate (TunerModelStation* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_bitrate;
	return result;
}

static void
tuner_model_station_set_bitrate (TunerModelStation* self,
                                 gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_bitrate (self);
	if (old_value != value) {
		self->priv->_bitrate = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_BITRATE_PROPERTY]);
	}
}

gint
tuner_model_station_get_hls (TunerModelStation* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_hls;
	return result;
}

static void
tuner_model_station_set_hls (TunerModelStation* self,
                             gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_station_get_hls (self);
	if (old_value != value) {
		self->priv->_hls = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_HLS_PROPERTY]);
	}
}

gboolean
tuner_model_station_get_starred (TunerModelStation* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_starred;
	return result;
}

void
tuner_model_station_set_starred (TunerModelStation* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_starred == value) {
		return;
	}
	self->priv->_starred = value;
	g_signal_emit (self, tuner_model_station_signals[TUNER_MODEL_STATION_STATION_STAR_CHANGED_SIG_SIGNAL], 0, self->priv->_starred);
	g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_STARRED_PROPERTY]);
}

static void
tuner_model_station_class_init (TunerModelStationClass * klass,
                                gpointer klass_data)
{
	GeeHashMap* _tmp0_;
	tuner_model_station_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerModelStation_private_offset);
	((TunerModelFaviconClass *) klass)->favicon_cache_file = (gchar* (*) (TunerModelFavicon*)) tuner_model_station_real_favicon_cache_file;
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_model_station_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_model_station_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_model_station_finalize;
	/** @property {string} changeuuid - Unique identifier for the change. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_CHANGEUUID_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_CHANGEUUID_PROPERTY] = g_param_spec_string ("changeuuid", "changeuuid", "changeuuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} stationuuid - Unique identifier for the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_STATIONUUID_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_STATIONUUID_PROPERTY] = g_param_spec_string ("stationuuid", "stationuuid", "stationuuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} name - Name of the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_NAME_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} url - URL of the station stream. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_URL_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} url_resolved - Resolved URL of the station stream. Camel case so goobject serialize is OK*/
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY] = g_param_spec_string ("urlResolved", "urlResolved", "urlResolved", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} homepage - Homepage of the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_HOMEPAGE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_HOMEPAGE_PROPERTY] = g_param_spec_string ("homepage", "homepage", "homepage", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} tags - Tags associated with the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_TAGS_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_TAGS_PROPERTY] = g_param_spec_string ("tags", "tags", "tags", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} country - Country where the station is located. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_COUNTRY_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRY_PROPERTY] = g_param_spec_string ("country", "country", "country", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} countrycode - Country code of the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY] = g_param_spec_string ("countrycode", "countrycode", "countrycode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} iso_3166_2 - ISO 3166-2 code for the station's location. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_ISO_3166_2_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_ISO_3166_2_PROPERTY] = g_param_spec_string ("iso-3166-2", "iso-3166-2", "iso-3166-2", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} state - State where the station is located. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_STATE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_STATE_PROPERTY] = g_param_spec_string ("state", "state", "state", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} language - Language of the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_LANGUAGE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGE_PROPERTY] = g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} languagecodes - Language codes associated with the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY] = g_param_spec_string ("languagecodes", "languagecodes", "languagecodes", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {string} codec - Audio codec used by the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_CODEC_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_CODEC_PROPERTY] = g_param_spec_string ("codec", "codec", "codec", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {int} bitrate - Bitrate of the station stream. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_BITRATE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_BITRATE_PROPERTY] = g_param_spec_int ("bitrate", "bitrate", "bitrate", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {int} hls - HLS status of the station. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_HLS_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_HLS_PROPERTY] = g_param_spec_int ("hls", "hls", "hls", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** @property {bool} starred - Indicates if the station is starred. Only set by Favorites*/
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_STARRED_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_STARRED_PROPERTY] = g_param_spec_boolean ("starred", "starred", "starred", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	tuner_model_station_signals[TUNER_MODEL_STATION_STATION_STAR_CHANGED_SIG_SIGNAL] = g_signal_new ("station-star-changed-sig", TUNER_MODEL_TYPE_STATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	tuner_model_station_STATIONS = (GeeMap*) _tmp0_;
}

static void
tuner_model_station_instance_init (TunerModelStation * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	self->priv = tuner_model_station_get_instance_private (self);
	_tmp0_ = g_strdup (_ ("Station no longer in the index"));
	self->up_to_date_difference = _tmp0_;
}

static void
tuner_model_station_finalize (GObject * obj)
{
	TunerModelStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_STATION, TunerModelStation);
	_g_free0 (self->priv->_changeuuid);
	_g_free0 (self->priv->_stationuuid);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_url);
	_g_free0 (self->priv->_urlResolved);
	_g_free0 (self->priv->_homepage);
	_g_free0 (self->priv->_tags);
	_g_free0 (self->priv->_country);
	_g_free0 (self->priv->_countrycode);
	_g_free0 (self->priv->_iso_3166_2);
	_g_free0 (self->priv->_state);
	_g_free0 (self->priv->_language);
	_g_free0 (self->priv->_languagecodes);
	_g_free0 (self->priv->_codec);
	_g_free0 (self->lastchangetime);
	_g_free0 (self->lastchangetime_iso8601);
	_g_free0 (self->lastchecktime);
	_g_free0 (self->lastchecktime_iso8601);
	_g_free0 (self->lastcheckoktime);
	_g_free0 (self->lastcheckoktime_iso8601);
	_g_free0 (self->lastlocalchecktime);
	_g_free0 (self->lastlocalchecktime_iso8601);
	_g_free0 (self->clicktimestamp);
	_g_free0 (self->clicktimestamp_iso8601);
	_g_free0 (self->geo_lat);
	_g_free0 (self->geo_long);
	_g_free0 (self->up_to_date_difference);
	_g_free0 (self->priv->_favicon_cache_file);
	G_OBJECT_CLASS (tuner_model_station_parent_class)->finalize (obj);
}

/**
 * @class Station
 * @brief Represents a radio station with various properties.
 */
static GType
tuner_model_station_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelStationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_station_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelStation), 0, (GInstanceInitFunc) tuner_model_station_instance_init, NULL };
	GType tuner_model_station_type_id;
	tuner_model_station_type_id = g_type_register_static (TUNER_MODEL_TYPE_FAVICON, "TunerModelStation", &g_define_type_info, 0);
	TunerModelStation_private_offset = g_type_add_instance_private (tuner_model_station_type_id, sizeof (TunerModelStationPrivate));
	return tuner_model_station_type_id;
}

GType
tuner_model_station_get_type (void)
{
	static volatile gsize tuner_model_station_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_station_type_id__once)) {
		GType tuner_model_station_type_id;
		tuner_model_station_type_id = tuner_model_station_get_type_once ();
		g_once_init_leave (&tuner_model_station_type_id__once, tuner_model_station_type_id);
	}
	return tuner_model_station_type_id__once;
}

static void
_vala_tuner_model_station_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_STATION, TunerModelStation);
	switch (property_id) {
		case TUNER_MODEL_STATION_CHANGEUUID_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_changeuuid (self));
		break;
		case TUNER_MODEL_STATION_STATIONUUID_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_stationuuid (self));
		break;
		case TUNER_MODEL_STATION_NAME_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_name (self));
		break;
		case TUNER_MODEL_STATION_URL_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_url (self));
		break;
		case TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_urlResolved (self));
		break;
		case TUNER_MODEL_STATION_HOMEPAGE_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_homepage (self));
		break;
		case TUNER_MODEL_STATION_TAGS_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_tags (self));
		break;
		case TUNER_MODEL_STATION_COUNTRY_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_country (self));
		break;
		case TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_countrycode (self));
		break;
		case TUNER_MODEL_STATION_ISO_3166_2_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_iso_3166_2 (self));
		break;
		case TUNER_MODEL_STATION_STATE_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_state (self));
		break;
		case TUNER_MODEL_STATION_LANGUAGE_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_language (self));
		break;
		case TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_languagecodes (self));
		break;
		case TUNER_MODEL_STATION_CODEC_PROPERTY:
		g_value_set_string (value, tuner_model_station_get_codec (self));
		break;
		case TUNER_MODEL_STATION_BITRATE_PROPERTY:
		g_value_set_int (value, tuner_model_station_get_bitrate (self));
		break;
		case TUNER_MODEL_STATION_HLS_PROPERTY:
		g_value_set_int (value, tuner_model_station_get_hls (self));
		break;
		case TUNER_MODEL_STATION_STARRED_PROPERTY:
		g_value_set_boolean (value, tuner_model_station_get_starred (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_model_station_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_STATION, TunerModelStation);
	switch (property_id) {
		case TUNER_MODEL_STATION_CHANGEUUID_PROPERTY:
		tuner_model_station_set_changeuuid (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_STATIONUUID_PROPERTY:
		tuner_model_station_set_stationuuid (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_NAME_PROPERTY:
		tuner_model_station_set_name (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_URL_PROPERTY:
		tuner_model_station_set_url (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY:
		tuner_model_station_set_urlResolved (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_HOMEPAGE_PROPERTY:
		tuner_model_station_set_homepage (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_TAGS_PROPERTY:
		tuner_model_station_set_tags (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_COUNTRY_PROPERTY:
		tuner_model_station_set_country (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY:
		tuner_model_station_set_countrycode (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_ISO_3166_2_PROPERTY:
		tuner_model_station_set_iso_3166_2 (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_STATE_PROPERTY:
		tuner_model_station_set_state (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_LANGUAGE_PROPERTY:
		tuner_model_station_set_language (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY:
		tuner_model_station_set_languagecodes (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_CODEC_PROPERTY:
		tuner_model_station_set_codec (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_STATION_BITRATE_PROPERTY:
		tuner_model_station_set_bitrate (self, g_value_get_int (value));
		break;
		case TUNER_MODEL_STATION_HLS_PROPERTY:
		tuner_model_station_set_hls (self, g_value_get_int (value));
		break;
		case TUNER_MODEL_STATION_STARRED_PROPERTY:
		tuner_model_station_set_starred (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

