/* StreamMetadata.c generated by valac 0.56.8, the Vala compiler
 * generated from StreamMetadata.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file PlayerController.vala
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gst/player/player.h>
#include <gst/gst.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_METADATA (tuner_model_metadata_get_type ())
#define TUNER_MODEL_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadata))
#define TUNER_MODEL_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))
#define TUNER_MODEL_IS_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_IS_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))

typedef struct _TunerModelMetadata TunerModelMetadata;
typedef struct _TunerModelMetadataClass TunerModelMetadataClass;
typedef struct _TunerModelMetadataPrivate TunerModelMetadataPrivate;
enum  {
	TUNER_MODEL_METADATA_0_PROPERTY,
	TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY,
	TUNER_MODEL_METADATA_TITLE_PROPERTY,
	TUNER_MODEL_METADATA_ARTIST_PROPERTY,
	TUNER_MODEL_METADATA_IMAGE_PROPERTY,
	TUNER_MODEL_METADATA_GENRE_PROPERTY,
	TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY,
	TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY,
	TUNER_MODEL_METADATA_ORG_LOC_PROPERTY,
	TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY,
	TUNER_MODEL_METADATA_NUM_PROPERTIES
};
static GParamSpec* tuner_model_metadata_properties[TUNER_MODEL_METADATA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _TunerModelMetadata {
	GObject parent_instance;
	TunerModelMetadataPrivate * priv;
};

struct _TunerModelMetadataClass {
	GObjectClass parent_class;
};

struct _TunerModelMetadataPrivate {
	gchar* _all_tags;
	gchar* _title;
	gchar* _artist;
	gchar* _image;
	gchar* _genre;
	gchar* _homepage;
	gchar* _audio_info;
	gchar* _org_loc;
	gchar* _pretty_print;
	GeeMap* _metadata_values;
};

struct _Block3Data {
	int _ref_count_;
	TunerModelMetadata* self;
	gchar* s;
	gboolean b;
	guint u;
};

static gint TunerModelMetadata_private_offset;
static gpointer tuner_model_metadata_parent_class = NULL;
static gchar** tuner_model_metadata_METADATA_TITLES;
static gint tuner_model_metadata_METADATA_TITLES_length1;
static gint tuner_model_metadata_METADATA_TITLES_length2;
static gchar** tuner_model_metadata_METADATA_TITLES = NULL;
static gint tuner_model_metadata_METADATA_TITLES_length1 = 0;
static gint tuner_model_metadata_METADATA_TITLES_length2 = 0;
static GeeList* tuner_model_metadata_METADATA_TAGS;
static GeeList* tuner_model_metadata_METADATA_TAGS = NULL;

VALA_EXTERN GType tuner_model_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelMetadata, g_object_unref)
VALA_EXTERN gboolean tuner_model_metadata_process_media_info_update (TunerModelMetadata* self,
                                                         GstPlayerMediaInfo* media_info);
static void tuner_model_metadata_set_title (TunerModelMetadata* self,
                                     const gchar* value);
static void tuner_model_metadata_set_artist (TunerModelMetadata* self,
                                      const gchar* value);
static void tuner_model_metadata_set_image (TunerModelMetadata* self,
                                     const gchar* value);
static void tuner_model_metadata_set_genre (TunerModelMetadata* self,
                                     const gchar* value);
static void tuner_model_metadata_set_homepage (TunerModelMetadata* self,
                                        const gchar* value);
static void tuner_model_metadata_set_audio_info (TunerModelMetadata* self,
                                          const gchar* value);
static void tuner_model_metadata_set_org_loc (TunerModelMetadata* self,
                                       const gchar* value);
static void tuner_model_metadata_set_pretty_print (TunerModelMetadata* self,
                                            const gchar* value);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN const gchar* tuner_model_metadata_get_all_tags (TunerModelMetadata* self);
static void tuner_model_metadata_set_all_tags (TunerModelMetadata* self,
                                        const gchar* value);
static void ____lambda5_ (Block3Data* _data3_,
                   GstTagList* list,
                   const gchar* tag);
static void _____lambda5__gst_tag_foreach_func (GstTagList* list,
                                         const gchar* tag,
                                         gpointer self);
VALA_EXTERN const gchar* tuner_safestrip (const gchar* text);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_new (void);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_construct (GType object_type);
VALA_EXTERN const gchar* tuner_model_metadata_get_title (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_artist (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_image (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_genre (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_homepage (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_audio_info (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_org_loc (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_pretty_print (TunerModelMetadata* self);
static void tuner_model_metadata_finalize (GObject * obj);
static GType tuner_model_metadata_get_type_once (void);
static void _vala_tuner_model_metadata_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_tuner_model_metadata_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
tuner_model_metadata_get_instance_private (TunerModelMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelMetadata_private_offset);
}

/**
    * Extracts the metadata from the media stream.
    *
    * @param media_info The media information stream
    * @return true if the metadata has changed
    */
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		TunerModelMetadata* self;
		self = _data3_->self;
		_g_free0 (_data3_->s);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_gst_tag_list_ref0 (gpointer self)
{
	return self ? gst_tag_list_ref (self) : NULL;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static void
____lambda5_ (Block3Data* _data3_,
              GstTagList* list,
              const gchar* tag)
{
	TunerModelMetadata* self;
	gint index = 0;
	GeeList* _tmp0_;
	GType type = 0UL;
	GValue _tmp4_;
	self = _data3_->self;
	g_return_if_fail (list != NULL);
	g_return_if_fail (tag != NULL);
	_tmp0_ = tuner_model_metadata_METADATA_TAGS;
	index = gee_list_index_of (_tmp0_, tag);
	if (index == -1) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = string_to_string (tag);
		_tmp2_ = g_strconcat ("New meta tag: ", _tmp1_, NULL);
		_tmp3_ = _tmp2_;
		g_warning ("StreamMetadata.vala:117: %s", _tmp3_);
		_g_free0 (_tmp3_);
		return;
	}
	_tmp4_ = *gst_tag_list_get_value_index (list, tag, (guint) 0);
	type = G_VALUE_TYPE (&_tmp4_);
	switch (type) {
		case G_TYPE_STRING:
		{
			gchar* _tmp5_ = NULL;
			GeeMap* _tmp6_;
			const gchar* _tmp7_;
			gst_tag_list_get_string (list, tag, &_tmp5_);
			_g_free0 (_data3_->s);
			_data3_->s = _tmp5_;
			_tmp6_ = self->priv->_metadata_values;
			_tmp7_ = _data3_->s;
			gee_map_set (_tmp6_, tag, _tmp7_);
			break;
		}
		case G_TYPE_UINT:
		{
			guint _tmp8_ = 0U;
			gst_tag_list_get_uint (list, tag, &_tmp8_);
			_data3_->u = _tmp8_;
			if (_data3_->u > ((guint) 1000)) {
				GeeMap* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				_tmp9_ = self->priv->_metadata_values;
				_tmp10_ = g_strdup_printf ("%u", _data3_->u / 1000);
				_tmp11_ = _tmp10_;
				_tmp12_ = g_strconcat (_tmp11_, "K", NULL);
				_tmp13_ = _tmp12_;
				gee_map_set (_tmp9_, tag, _tmp13_);
				_g_free0 (_tmp13_);
				_g_free0 (_tmp11_);
			} else {
				GeeMap* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp14_ = self->priv->_metadata_values;
				_tmp15_ = g_strdup_printf ("%u", _data3_->u);
				_tmp16_ = _tmp15_;
				gee_map_set (_tmp14_, tag, _tmp16_);
				_g_free0 (_tmp16_);
			}
			break;
		}
		case G_TYPE_BOOLEAN:
		{
			gboolean _tmp17_ = FALSE;
			GeeMap* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gst_tag_list_get_boolean (list, tag, &_tmp17_);
			_data3_->b = _tmp17_;
			_tmp18_ = self->priv->_metadata_values;
			_tmp19_ = bool_to_string (_data3_->b);
			_tmp20_ = _tmp19_;
			gee_map_set (_tmp18_, tag, _tmp20_);
			_g_free0 (_tmp20_);
			break;
		}
		default:
		{
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			_tmp21_ = g_type_name (type);
			_tmp22_ = string_to_string (_tmp21_);
			_tmp23_ = g_strconcat ("New Tag type: ", _tmp22_, NULL);
			_tmp24_ = _tmp23_;
			g_warning ("StreamMetadata.vala:141: %s", _tmp24_);
			_g_free0 (_tmp24_);
			break;
		}
	}
}

static void
_____lambda5__gst_tag_foreach_func (GstTagList* list,
                                    const gchar* tag,
                                    gpointer self)
{
	____lambda5_ (self, list, tag);
}

gboolean
tuner_model_metadata_process_media_info_update (TunerModelMetadata* self,
                                                GstPlayerMediaInfo* media_info)
{
	GList* streamlist = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (media_info != NULL, FALSE);
	_tmp0_ = gst_player_media_info_get_stream_list (media_info);
	_tmp1_ = g_list_copy (_tmp0_);
	streamlist = _tmp1_;
	tuner_model_metadata_set_title (self, "");
	tuner_model_metadata_set_artist (self, "");
	tuner_model_metadata_set_image (self, "");
	tuner_model_metadata_set_genre (self, "");
	tuner_model_metadata_set_homepage (self, "");
	tuner_model_metadata_set_audio_info (self, "");
	tuner_model_metadata_set_org_loc (self, "");
	tuner_model_metadata_set_pretty_print (self, "");
	_tmp2_ = streamlist;
	{
		GList* stream_collection = NULL;
		GList* stream_it = NULL;
		stream_collection = _tmp2_;
		for (stream_it = stream_collection; stream_it != NULL; stream_it = stream_it->next) {
			GstPlayerStreamInfo* stream = NULL;
			stream = (GstPlayerStreamInfo*) stream_it->data;
			{
				Block3Data* _data3_;
				GstTagList* tags = NULL;
				GstPlayerStreamInfo* _tmp3_;
				GstTagList* _tmp4_;
				GstTagList* _tmp5_;
				GstTagList* _tmp6_;
				const gchar* _tmp7_;
				GstTagList* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gboolean _tmp11_;
				GstTagList* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				GstTagList* _tmp19_;
				GeeMap* _tmp20_;
				GeeMap* _tmp23_;
				GeeMap* _tmp26_;
				GeeMap* _tmp29_;
				GeeMap* _tmp32_;
				GeeMap* _tmp35_;
				GeeMap* _tmp38_;
				GeeMap* _tmp44_;
				gboolean _tmp50_ = FALSE;
				const gchar* _tmp51_;
				GeeMap* _tmp58_;
				GeeMap* _tmp61_;
				gboolean _tmp67_ = FALSE;
				const gchar* _tmp68_;
				GString* sb = NULL;
				GString* _tmp74_;
				GString* _tmp97_;
				GString* _tmp98_;
				GString* _tmp99_;
				const gchar* _tmp100_;
				_data3_ = g_slice_new0 (Block3Data);
				_data3_->_ref_count_ = 1;
				_data3_->self = g_object_ref (self);
				_tmp3_ = stream;
				_tmp4_ = gst_player_stream_info_get_tags (_tmp3_);
				_tmp5_ = _gst_tag_list_ref0 (_tmp4_);
				tags = _tmp5_;
				_tmp6_ = tags;
				if (_tmp6_ == NULL) {
					_gst_tag_list_unref0 (tags);
					block3_data_unref (_data3_);
					_data3_ = NULL;
					break;
				}
				_tmp7_ = self->priv->_all_tags;
				_tmp8_ = tags;
				_tmp9_ = gst_tag_list_to_string (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = g_strcmp0 (_tmp7_, _tmp10_) == 0;
				_g_free0 (_tmp10_);
				if (_tmp11_) {
					result = FALSE;
					_gst_tag_list_unref0 (tags);
					block3_data_unref (_data3_);
					_data3_ = NULL;
					(streamlist == NULL) ? NULL : (streamlist = (g_list_free (streamlist), NULL));
					return result;
				}
				_tmp12_ = tags;
				_tmp13_ = gst_tag_list_to_string (_tmp12_);
				_tmp14_ = _tmp13_;
				tuner_model_metadata_set_all_tags (self, _tmp14_);
				_g_free0 (_tmp14_);
				_tmp15_ = self->priv->_all_tags;
				_tmp16_ = string_to_string (_tmp15_);
				_tmp17_ = g_strconcat ("All Tags: ", _tmp16_, NULL);
				_tmp18_ = _tmp17_;
				g_debug ("StreamMetadata.vala:105: %s", _tmp18_);
				_g_free0 (_tmp18_);
				_data3_->s = NULL;
				_data3_->b = FALSE;
				_data3_->u = (guint) 0;
				_tmp19_ = tags;
				gst_tag_list_foreach (_tmp19_, _____lambda5__gst_tag_foreach_func, _data3_);
				_tmp20_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp20_, "title")) {
					GeeMap* _tmp21_;
					gpointer _tmp22_;
					_tmp21_ = self->priv->_metadata_values;
					_tmp22_ = gee_map_get (_tmp21_, "title");
					_g_free0 (self->priv->_title);
					self->priv->_title = (gchar*) _tmp22_;
				}
				_tmp23_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp23_, "artist")) {
					GeeMap* _tmp24_;
					gpointer _tmp25_;
					_tmp24_ = self->priv->_metadata_values;
					_tmp25_ = gee_map_get (_tmp24_, "artist");
					_g_free0 (self->priv->_artist);
					self->priv->_artist = (gchar*) _tmp25_;
				}
				_tmp26_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp26_, "image")) {
					GeeMap* _tmp27_;
					gpointer _tmp28_;
					_tmp27_ = self->priv->_metadata_values;
					_tmp28_ = gee_map_get (_tmp27_, "image");
					_g_free0 (self->priv->_image);
					self->priv->_image = (gchar*) _tmp28_;
				}
				_tmp29_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp29_, "genre")) {
					GeeMap* _tmp30_;
					gpointer _tmp31_;
					_tmp30_ = self->priv->_metadata_values;
					_tmp31_ = gee_map_get (_tmp30_, "genre");
					_g_free0 (self->priv->_genre);
					self->priv->_genre = (gchar*) _tmp31_;
				}
				_tmp32_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp32_, "homepage")) {
					GeeMap* _tmp33_;
					gpointer _tmp34_;
					_tmp33_ = self->priv->_metadata_values;
					_tmp34_ = gee_map_get (_tmp33_, "homepage");
					_g_free0 (self->priv->_homepage);
					self->priv->_homepage = (gchar*) _tmp34_;
				}
				_tmp35_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp35_, "audio_codec")) {
					GeeMap* _tmp36_;
					gpointer _tmp37_;
					_tmp36_ = self->priv->_metadata_values;
					_tmp37_ = gee_map_get (_tmp36_, "audio_codec ");
					_g_free0 (self->priv->_audio_info);
					self->priv->_audio_info = (gchar*) _tmp37_;
				}
				_tmp38_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp38_, "bitrate")) {
					const gchar* _tmp39_;
					GeeMap* _tmp40_;
					gpointer _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					_tmp39_ = self->priv->_audio_info;
					_tmp40_ = self->priv->_metadata_values;
					_tmp41_ = gee_map_get (_tmp40_, "bitrate ");
					_tmp42_ = (gchar*) _tmp41_;
					_tmp43_ = g_strconcat (_tmp39_, _tmp42_, NULL);
					_g_free0 (self->priv->_audio_info);
					self->priv->_audio_info = _tmp43_;
					_g_free0 (_tmp42_);
				}
				_tmp44_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp44_, "channel_mode")) {
					const gchar* _tmp45_;
					GeeMap* _tmp46_;
					gpointer _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
					_tmp45_ = self->priv->_audio_info;
					_tmp46_ = self->priv->_metadata_values;
					_tmp47_ = gee_map_get (_tmp46_, "channel_mode");
					_tmp48_ = (gchar*) _tmp47_;
					_tmp49_ = g_strconcat (_tmp45_, _tmp48_, NULL);
					_g_free0 (self->priv->_audio_info);
					self->priv->_audio_info = _tmp49_;
					_g_free0 (_tmp48_);
				}
				_tmp51_ = self->priv->_audio_info;
				if (_tmp51_ != NULL) {
					const gchar* _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
					_tmp52_ = self->priv->_audio_info;
					_tmp53_ = strlen (_tmp52_);
					_tmp54_ = _tmp53_;
					_tmp50_ = _tmp54_ > 0;
				} else {
					_tmp50_ = FALSE;
				}
				if (_tmp50_) {
					const gchar* _tmp55_;
					const gchar* _tmp56_;
					gchar* _tmp57_;
					_tmp55_ = self->priv->_audio_info;
					_tmp56_ = tuner_safestrip (_tmp55_);
					_tmp57_ = g_strdup (_tmp56_);
					_g_free0 (self->priv->_audio_info);
					self->priv->_audio_info = _tmp57_;
				}
				_tmp58_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp58_, "organization")) {
					GeeMap* _tmp59_;
					gpointer _tmp60_;
					_tmp59_ = self->priv->_metadata_values;
					_tmp60_ = gee_map_get (_tmp59_, "organization ");
					_g_free0 (self->priv->_org_loc);
					self->priv->_org_loc = (gchar*) _tmp60_;
				}
				_tmp61_ = self->priv->_metadata_values;
				if (gee_map_has_key (_tmp61_, "location")) {
					const gchar* _tmp62_;
					GeeMap* _tmp63_;
					gpointer _tmp64_;
					gchar* _tmp65_;
					gchar* _tmp66_;
					_tmp62_ = self->priv->_org_loc;
					_tmp63_ = self->priv->_metadata_values;
					_tmp64_ = gee_map_get (_tmp63_, "location");
					_tmp65_ = (gchar*) _tmp64_;
					_tmp66_ = g_strconcat (_tmp62_, _tmp65_, NULL);
					_g_free0 (self->priv->_org_loc);
					self->priv->_org_loc = _tmp66_;
					_g_free0 (_tmp65_);
				}
				_tmp68_ = self->priv->_org_loc;
				if (_tmp68_ != NULL) {
					const gchar* _tmp69_;
					gint _tmp70_;
					gint _tmp71_;
					_tmp69_ = self->priv->_org_loc;
					_tmp70_ = strlen (_tmp69_);
					_tmp71_ = _tmp70_;
					_tmp67_ = _tmp71_ > 0;
				} else {
					_tmp67_ = FALSE;
				}
				if (_tmp67_) {
					const gchar* _tmp72_;
					const gchar* _tmp73_;
					_tmp72_ = self->priv->_org_loc;
					_tmp73_ = tuner_safestrip (_tmp72_);
					tuner_model_metadata_set_org_loc (self, _tmp73_);
				}
				_tmp74_ = g_string_new ("");
				sb = _tmp74_;
				{
					GeeList* _tag_list = NULL;
					GeeList* _tmp75_;
					gint _tag_size = 0;
					GeeList* _tmp76_;
					gint _tmp77_;
					gint _tmp78_;
					gint _tag_index = 0;
					_tmp75_ = tuner_model_metadata_METADATA_TAGS;
					_tag_list = _tmp75_;
					_tmp76_ = _tag_list;
					_tmp77_ = gee_collection_get_size ((GeeCollection*) _tmp76_);
					_tmp78_ = _tmp77_;
					_tag_size = _tmp78_;
					_tag_index = -1;
					while (TRUE) {
						gint _tmp79_;
						gint _tmp80_;
						gchar* tag = NULL;
						GeeList* _tmp81_;
						gpointer _tmp82_;
						GeeMap* _tmp83_;
						const gchar* _tmp84_;
						_tag_index = _tag_index + 1;
						_tmp79_ = _tag_index;
						_tmp80_ = _tag_size;
						if (!(_tmp79_ < _tmp80_)) {
							break;
						}
						_tmp81_ = _tag_list;
						_tmp82_ = gee_list_get (_tmp81_, _tag_index);
						tag = (gchar*) _tmp82_;
						_tmp83_ = self->priv->_metadata_values;
						_tmp84_ = tag;
						if (gee_map_has_key (_tmp83_, _tmp84_)) {
							GString* _tmp85_;
							gchar** _tmp86_;
							gint _tmp86__length1;
							gint _tmp86__length2;
							GeeList* _tmp87_;
							const gchar* _tmp88_;
							const gchar* _tmp89_;
							GString* _tmp90_;
							GString* _tmp91_;
							GeeMap* _tmp92_;
							const gchar* _tmp93_;
							gpointer _tmp94_;
							gchar* _tmp95_;
							GString* _tmp96_;
							_tmp85_ = sb;
							_tmp86_ = tuner_model_metadata_METADATA_TITLES;
							_tmp86__length1 = tuner_model_metadata_METADATA_TITLES_length1;
							_tmp86__length2 = tuner_model_metadata_METADATA_TITLES_length2;
							_tmp87_ = tuner_model_metadata_METADATA_TAGS;
							_tmp88_ = tag;
							_tmp89_ = _tmp86_[(gee_list_index_of (_tmp87_, _tmp88_) * _tmp86__length2) + 1];
							_tmp90_ = g_string_append (_tmp85_, _tmp89_);
							_tmp91_ = g_string_append (_tmp90_, " : ");
							_tmp92_ = self->priv->_metadata_values;
							_tmp93_ = tag;
							_tmp94_ = gee_map_get (_tmp92_, _tmp93_);
							_tmp95_ = (gchar*) _tmp94_;
							_tmp96_ = g_string_append (_tmp91_, _tmp95_);
							g_string_append (_tmp96_, "\n");
							_g_free0 (_tmp95_);
						}
						_g_free0 (tag);
					}
				}
				_tmp97_ = sb;
				_tmp98_ = sb;
				_tmp99_ = g_string_truncate (_tmp97_, (gsize) (_tmp98_->len - 1));
				_tmp100_ = _tmp99_->str;
				tuner_model_metadata_set_pretty_print (self, _tmp100_);
				_g_string_free0 (sb);
				_gst_tag_list_unref0 (tags);
				block3_data_unref (_data3_);
				_data3_ = NULL;
			}
		}
	}
	result = TRUE;
	(streamlist == NULL) ? NULL : (streamlist = (g_list_free (streamlist), NULL));
	return result;
}

TunerModelMetadata*
tuner_model_metadata_construct (GType object_type)
{
	TunerModelMetadata * self = NULL;
	self = (TunerModelMetadata*) g_object_new (object_type, NULL);
	return self;
}

TunerModelMetadata*
tuner_model_metadata_new (void)
{
	return tuner_model_metadata_construct (TUNER_MODEL_TYPE_METADATA);
}

const gchar*
tuner_model_metadata_get_all_tags (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_all_tags;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_all_tags (TunerModelMetadata* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_all_tags (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_all_tags);
		self->priv->_all_tags = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_title (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_title (TunerModelMetadata* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_TITLE_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_artist (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_artist;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_artist (TunerModelMetadata* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_artist (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_artist);
		self->priv->_artist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ARTIST_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_image (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_image (TunerModelMetadata* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_image (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_image);
		self->priv->_image = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_IMAGE_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_genre (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_genre;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_genre (TunerModelMetadata* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_genre (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_genre);
		self->priv->_genre = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_GENRE_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_homepage (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_homepage;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_homepage (TunerModelMetadata* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_homepage (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_homepage);
		self->priv->_homepage = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_audio_info (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_audio_info;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_audio_info (TunerModelMetadata* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_audio_info (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_audio_info);
		self->priv->_audio_info = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_org_loc (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_org_loc;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_org_loc (TunerModelMetadata* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_org_loc (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_org_loc);
		self->priv->_org_loc = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ORG_LOC_PROPERTY]);
	}
}

const gchar*
tuner_model_metadata_get_pretty_print (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pretty_print;
	result = _tmp0_;
	return result;
}

static void
tuner_model_metadata_set_pretty_print (TunerModelMetadata* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_model_metadata_get_pretty_print (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_pretty_print);
		self->priv->_pretty_print = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY]);
	}
}

static void
tuner_model_metadata_class_init (TunerModelMetadataClass * klass,
                                 gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar** _tmp48_;
	GeeArrayList* _tmp49_;
	guint8 tag_index = 0U;
	gchar** _tmp50_;
	gint _tmp50__length1;
	gint _tmp50__length2;
	tuner_model_metadata_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerModelMetadata_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_model_metadata_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_model_metadata_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_model_metadata_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY] = g_param_spec_string ("all-tags", "all-tags", "all-tags", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_TITLE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_ARTIST_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_IMAGE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_IMAGE_PROPERTY] = g_param_spec_string ("image", "image", "image", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_GENRE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY] = g_param_spec_string ("homepage", "homepage", "homepage", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY] = g_param_spec_string ("audio-info", "audio-info", "audio-info", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_ORG_LOC_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ORG_LOC_PROPERTY] = g_param_spec_string ("org-loc", "org-loc", "org-loc", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY] = g_param_spec_string ("pretty-print", "pretty-print", "pretty-print", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = g_strdup ("title");
	_tmp1_ = g_strdup (_ ("Title"));
	_tmp2_ = g_strdup ("artist");
	_tmp3_ = g_strdup (_ ("Artist"));
	_tmp4_ = g_strdup ("album");
	_tmp5_ = g_strdup (_ ("Album"));
	_tmp6_ = g_strdup ("image");
	_tmp7_ = g_strdup (_ ("Image"));
	_tmp8_ = g_strdup ("genre");
	_tmp9_ = g_strdup (_ ("Genre"));
	_tmp10_ = g_strdup ("homepage");
	_tmp11_ = g_strdup (_ ("Homepage"));
	_tmp12_ = g_strdup ("organization");
	_tmp13_ = g_strdup (_ ("Organization"));
	_tmp14_ = g_strdup ("location");
	_tmp15_ = g_strdup (_ ("Location"));
	_tmp16_ = g_strdup ("extended-comment");
	_tmp17_ = g_strdup (_ ("Extended Comment"));
	_tmp18_ = g_strdup ("bitrate");
	_tmp19_ = g_strdup (_ ("Bitrate"));
	_tmp20_ = g_strdup ("audio-codec");
	_tmp21_ = g_strdup (_ ("Audio Codec"));
	_tmp22_ = g_strdup ("channel-mode");
	_tmp23_ = g_strdup (_ ("Channel Mode"));
	_tmp24_ = g_strdup ("track-number");
	_tmp25_ = g_strdup (_ ("Track Number"));
	_tmp26_ = g_strdup ("track-count");
	_tmp27_ = g_strdup (_ ("Track Count"));
	_tmp28_ = g_strdup ("nominal-bitrate");
	_tmp29_ = g_strdup (_ ("Nominal Bitrate"));
	_tmp30_ = g_strdup ("minimum-bitrate");
	_tmp31_ = g_strdup (_ ("Minimum Bitrate"));
	_tmp32_ = g_strdup ("maximum-bitrate");
	_tmp33_ = g_strdup (_ ("Maximim Bitrate"));
	_tmp34_ = g_strdup ("container-format");
	_tmp35_ = g_strdup ("Container Format");
	_tmp36_ = g_strdup ("application-name");
	_tmp37_ = g_strdup (_ ("Application Name"));
	_tmp38_ = g_strdup ("encoder");
	_tmp39_ = g_strdup (_ ("Encoder"));
	_tmp40_ = g_strdup ("encoder-version");
	_tmp41_ = g_strdup (_ ("Encoder Version"));
	_tmp42_ = g_strdup ("datetime");
	_tmp43_ = g_strdup (_ ("Date Time"));
	_tmp44_ = g_strdup ("private-data");
	_tmp45_ = g_strdup (_ ("Private Data"));
	_tmp46_ = g_strdup ("has-crc");
	_tmp47_ = g_strdup (_ ("Has CRC"));
	_tmp48_ = g_new0 (gchar*, (24 * 2) + 1);
	_tmp48_[0] = _tmp0_;
	_tmp48_[1] = _tmp1_;
	_tmp48_[2] = _tmp2_;
	_tmp48_[3] = _tmp3_;
	_tmp48_[4] = _tmp4_;
	_tmp48_[5] = _tmp5_;
	_tmp48_[6] = _tmp6_;
	_tmp48_[7] = _tmp7_;
	_tmp48_[8] = _tmp8_;
	_tmp48_[9] = _tmp9_;
	_tmp48_[10] = _tmp10_;
	_tmp48_[11] = _tmp11_;
	_tmp48_[12] = _tmp12_;
	_tmp48_[13] = _tmp13_;
	_tmp48_[14] = _tmp14_;
	_tmp48_[15] = _tmp15_;
	_tmp48_[16] = _tmp16_;
	_tmp48_[17] = _tmp17_;
	_tmp48_[18] = _tmp18_;
	_tmp48_[19] = _tmp19_;
	_tmp48_[20] = _tmp20_;
	_tmp48_[21] = _tmp21_;
	_tmp48_[22] = _tmp22_;
	_tmp48_[23] = _tmp23_;
	_tmp48_[24] = _tmp24_;
	_tmp48_[25] = _tmp25_;
	_tmp48_[26] = _tmp26_;
	_tmp48_[27] = _tmp27_;
	_tmp48_[28] = _tmp28_;
	_tmp48_[29] = _tmp29_;
	_tmp48_[30] = _tmp30_;
	_tmp48_[31] = _tmp31_;
	_tmp48_[32] = _tmp32_;
	_tmp48_[33] = _tmp33_;
	_tmp48_[34] = _tmp34_;
	_tmp48_[35] = _tmp35_;
	_tmp48_[36] = _tmp36_;
	_tmp48_[37] = _tmp37_;
	_tmp48_[38] = _tmp38_;
	_tmp48_[39] = _tmp39_;
	_tmp48_[40] = _tmp40_;
	_tmp48_[41] = _tmp41_;
	_tmp48_[42] = _tmp42_;
	_tmp48_[43] = _tmp43_;
	_tmp48_[44] = _tmp44_;
	_tmp48_[45] = _tmp45_;
	_tmp48_[46] = _tmp46_;
	_tmp48_[47] = _tmp47_;
	tuner_model_metadata_METADATA_TITLES = _tmp48_;
	tuner_model_metadata_METADATA_TITLES_length1 = 24;
	tuner_model_metadata_METADATA_TITLES_length2 = 2;
	_tmp49_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	tuner_model_metadata_METADATA_TAGS = (GeeList*) _tmp49_;
	tag_index = (guint8) 0;
	_tmp50_ = tuner_model_metadata_METADATA_TITLES;
	_tmp50__length1 = tuner_model_metadata_METADATA_TITLES_length1;
	_tmp50__length2 = tuner_model_metadata_METADATA_TITLES_length2;
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint tag_collection_length2 = 0;
		gint tag_it = 0;
		tag_collection = _tmp50_;
		tag_collection_length1 = _tmp50__length1 * _tmp50__length2;
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
			gchar* _tmp51_;
			gchar* tag = NULL;
			_tmp51_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp51_;
			{
				guint8 _tmp52_;
				_tmp52_ = tag_index;
				tag_index = _tmp52_ + 1;
				if ((_tmp52_ % 2) == 0) {
					GeeList* _tmp53_;
					const gchar* _tmp54_;
					_tmp53_ = tuner_model_metadata_METADATA_TAGS;
					_tmp54_ = tag;
					gee_list_insert (_tmp53_, tag_index / 2, _tmp54_);
				}
				_g_free0 (tag);
			}
		}
	}
}

static void
tuner_model_metadata_instance_init (TunerModelMetadata * self,
                                    gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GeeHashMap* _tmp9_;
	self->priv = tuner_model_metadata_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->_all_tags = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_title = _tmp1_;
	_tmp2_ = g_strdup ("");
	self->priv->_artist = _tmp2_;
	_tmp3_ = g_strdup ("");
	self->priv->_image = _tmp3_;
	_tmp4_ = g_strdup ("");
	self->priv->_genre = _tmp4_;
	_tmp5_ = g_strdup ("");
	self->priv->_homepage = _tmp5_;
	_tmp6_ = g_strdup ("");
	self->priv->_audio_info = _tmp6_;
	_tmp7_ = g_strdup ("");
	self->priv->_org_loc = _tmp7_;
	_tmp8_ = g_strdup ("");
	self->priv->_pretty_print = _tmp8_;
	_tmp9_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_metadata_values = (GeeMap*) _tmp9_;
}

static void
tuner_model_metadata_finalize (GObject * obj)
{
	TunerModelMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_METADATA, TunerModelMetadata);
	_g_free0 (self->priv->_all_tags);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_image);
	_g_free0 (self->priv->_genre);
	_g_free0 (self->priv->_homepage);
	_g_free0 (self->priv->_audio_info);
	_g_free0 (self->priv->_org_loc);
	_g_free0 (self->priv->_pretty_print);
	_g_object_unref0 (self->priv->_metadata_values);
	G_OBJECT_CLASS (tuner_model_metadata_parent_class)->finalize (obj);
}

/**
 * @class Metadata
 *
 * @brief Stream Metadata transform
 *
 */
static GType
tuner_model_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelMetadata), 0, (GInstanceInitFunc) tuner_model_metadata_instance_init, NULL };
	GType tuner_model_metadata_type_id;
	tuner_model_metadata_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerModelMetadata", &g_define_type_info, 0);
	TunerModelMetadata_private_offset = g_type_add_instance_private (tuner_model_metadata_type_id, sizeof (TunerModelMetadataPrivate));
	return tuner_model_metadata_type_id;
}

GType
tuner_model_metadata_get_type (void)
{
	static volatile gsize tuner_model_metadata_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_metadata_type_id__once)) {
		GType tuner_model_metadata_type_id;
		tuner_model_metadata_type_id = tuner_model_metadata_get_type_once ();
		g_once_init_leave (&tuner_model_metadata_type_id__once, tuner_model_metadata_type_id);
	}
	return tuner_model_metadata_type_id__once;
}

static void
_vala_tuner_model_metadata_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	TunerModelMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_METADATA, TunerModelMetadata);
	switch (property_id) {
		case TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_all_tags (self));
		break;
		case TUNER_MODEL_METADATA_TITLE_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_title (self));
		break;
		case TUNER_MODEL_METADATA_ARTIST_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_artist (self));
		break;
		case TUNER_MODEL_METADATA_IMAGE_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_image (self));
		break;
		case TUNER_MODEL_METADATA_GENRE_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_genre (self));
		break;
		case TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_homepage (self));
		break;
		case TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_audio_info (self));
		break;
		case TUNER_MODEL_METADATA_ORG_LOC_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_org_loc (self));
		break;
		case TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY:
		g_value_set_string (value, tuner_model_metadata_get_pretty_print (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_model_metadata_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	TunerModelMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_METADATA, TunerModelMetadata);
	switch (property_id) {
		case TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY:
		tuner_model_metadata_set_all_tags (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_TITLE_PROPERTY:
		tuner_model_metadata_set_title (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_ARTIST_PROPERTY:
		tuner_model_metadata_set_artist (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_IMAGE_PROPERTY:
		tuner_model_metadata_set_image (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_GENRE_PROPERTY:
		tuner_model_metadata_set_genre (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY:
		tuner_model_metadata_set_homepage (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY:
		tuner_model_metadata_set_audio_info (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_ORG_LOC_PROPERTY:
		tuner_model_metadata_set_org_loc (self, g_value_get_string (value));
		break;
		case TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY:
		tuner_model_metadata_set_pretty_print (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

