/* RadioBrowser.c generated by valac 0.56.8, the Vala compiler
 * generated from RadioBrowser.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file RadioBrowser.vala
 *
 * @brief Interface to radio-browser.info API and servers
 * 
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <json-glib/json-glib.h>

#define TUNER_DATA_PROVIDER_SRV_SERVICE "api"
#define TUNER_DATA_PROVIDER_SRV_PROTOCOL "tcp"
#define TUNER_DATA_PROVIDER_SRV_DOMAIN "radio-browser.info"
#define TUNER_DATA_PROVIDER_RBI_ALL_API "all.api.radio-browser.info"
#define TUNER_DATA_PROVIDER_RBI_STATS "/json/stats"
#define TUNER_DATA_PROVIDER_RBI_SERVERS "/json/servers"
#define TUNER_DATA_PROVIDER_RBI_STATION "/json/url/$stationuuid"
#define TUNER_DATA_PROVIDER_RBI_SEARCH "/json/stations/search"
#define TUNER_DATA_PROVIDER_RBI_VOTE "/json/vote/$stationuuid"
#define TUNER_DATA_PROVIDER_RBI_UUID "/json/stations/byuuid"
#define TUNER_DATA_PROVIDER_RBI_URL "/json/stations/byurl"
#define TUNER_DATA_PROVIDER_RBI_TAGS "/json/tags"
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL 100
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_COST 7
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_DATA_PROVIDER_TYPE_API (tuner_data_provider_api_get_type ())
#define TUNER_DATA_PROVIDER_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPI))
#define TUNER_DATA_PROVIDER_IS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_API))
#define TUNER_DATA_PROVIDER_API_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPIIface))

typedef struct _TunerDataProviderAPI TunerDataProviderAPI;
typedef struct _TunerDataProviderAPIIface TunerDataProviderAPIIface;

#define TUNER_DATA_PROVIDER_TYPE_TAG (tuner_data_provider_tag_get_type ())
#define TUNER_DATA_PROVIDER_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag))
#define TUNER_DATA_PROVIDER_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))
#define TUNER_DATA_PROVIDER_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))

typedef struct _TunerDataProviderTag TunerDataProviderTag;
typedef struct _TunerDataProviderTagClass TunerDataProviderTagClass;

#define TUNER_DATA_PROVIDER_TYPE_DATA_ERROR (tuner_data_provider_data_error_get_type ())

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_DATA_PROVIDER_TYPE_SEARCH_PARAMS (tuner_data_provider_search_params_get_type ())
typedef struct _TunerDataProviderSearchParams TunerDataProviderSearchParams;
typedef enum  {
	TUNER_DATA_PROVIDER_SORT_ORDER_NAME,
	TUNER_DATA_PROVIDER_SORT_ORDER_URL,
	TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON,
	TUNER_DATA_PROVIDER_SORT_ORDER_TAGS,
	TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY,
	TUNER_DATA_PROVIDER_SORT_ORDER_STATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_VOTES,
	TUNER_DATA_PROVIDER_SORT_ORDER_CODEC,
	TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND,
	TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM
} TunerDataProviderSortOrder;

#define TUNER_DATA_PROVIDER_TYPE_SORT_ORDER (tuner_data_provider_sort_order_get_type ())
typedef enum  {
	TUNER_DATA_PROVIDER_API_STATUS_OK,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED,
	TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE,
	TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR
} TunerDataProviderAPIStatus;

#define TUNER_DATA_PROVIDER_API_TYPE_STATUS (tuner_data_provider_api_status_get_type ())

#define TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER (tuner_data_provider_radio_browser_get_type ())
#define TUNER_DATA_PROVIDER_RADIO_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser))
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowserClass))
#define TUNER_DATA_PROVIDER_IS_RADIO_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER))
#define TUNER_DATA_PROVIDER_IS_RADIO_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER))
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowserClass))

typedef struct _TunerDataProviderRadioBrowser TunerDataProviderRadioBrowser;
typedef struct _TunerDataProviderRadioBrowserClass TunerDataProviderRadioBrowserClass;
typedef struct _TunerDataProviderRadioBrowserPrivate TunerDataProviderRadioBrowserPrivate;
enum  {
	TUNER_DATA_PROVIDER_RADIO_BROWSER_0_PROPERTY,
	TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY,
	TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY,
	TUNER_DATA_PROVIDER_RADIO_BROWSER_NUM_PROPERTIES
};
static GParamSpec* tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _TunerDataProviderRadioBrowserSearchAsyncData TunerDataProviderRadioBrowserSearchAsyncData;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
typedef struct _TunerDataProviderRadioBrowserStationQueryAsyncData TunerDataProviderRadioBrowserStationQueryAsyncData;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define __vala_GSrvTarget_free0(var) ((var == NULL) ? NULL : (var = (_vala_GSrvTarget_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA,
	TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION
} TunerDataProviderDataError;
#define TUNER_DATA_PROVIDER_DATA_ERROR tuner_data_provider_data_error_quark ()

struct _TunerDataProviderSearchParams {
	gchar* text;
	GeeSet* tags;
	GeeSet* uuids;
	gchar* countrycode;
	TunerDataProviderSortOrder order;
	gboolean reverse;
};

struct _TunerDataProviderAPIIface {
	GTypeInterface parent_iface;
	void (*clear_last_error) (TunerDataProviderAPI* self);
	gchar* (*name) (TunerDataProviderAPI* self);
	gint (*available_stations) (TunerDataProviderAPI* self);
	gint (*available_tags) (TunerDataProviderAPI* self);
	gboolean (*initialize) (TunerDataProviderAPI* self);
	void (*click) (TunerDataProviderAPI* self, const gchar* stationuuid);
	void (*vote) (TunerDataProviderAPI* self, const gchar* stationuuid);
	GeeSet* (*get_tags) (TunerDataProviderAPI* self, gint offset, gint limit, GError** error);
	GeeSet* (*by_uuid) (TunerDataProviderAPI* self, const gchar* uuids, GError** error);
	GeeSet* (*by_uuids) (TunerDataProviderAPI* self, GeeCollection* uuids, GError** error);
	GeeSet* (*search) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GError** error);
	void (*search_async) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeSet* (*search_finish) (TunerDataProviderAPI* self, GAsyncResult* _res_, GError** error);
	GError* (*get_last_data_error) (TunerDataProviderAPI* self);
	void (*set_last_data_error) (TunerDataProviderAPI* self, GError* value);
	TunerDataProviderAPIStatus (*get_status) (TunerDataProviderAPI* self);
	void (*set_status) (TunerDataProviderAPI* self, TunerDataProviderAPIStatus value);
};

struct _TunerDataProviderRadioBrowser {
	GObject parent_instance;
	TunerDataProviderRadioBrowserPrivate * priv;
};

struct _TunerDataProviderRadioBrowserClass {
	GObjectClass parent_class;
};

struct _TunerDataProviderRadioBrowserPrivate {
	gchar* _optionalservers;
	GeeArrayList* _servers;
	gchar* _current_server;
	gint _degrade;
	gint _available_stations;
	gint _available_tags;
	TunerDataProviderAPIStatus _status;
	GError* _last_data_error;
};

struct _TunerDataProviderRadioBrowserSearchAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerDataProviderRadioBrowser* self;
	TunerDataProviderSearchParams params;
	guint rowcount;
	guint offset;
	GeeSet* result;
	TunerDataProviderSearchParams _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	gchar* query;
	TunerDataProviderSearchParams _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GeeSet* _tmp13_;
	const gchar* _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	GError* _inner_error0_;
};

struct _TunerDataProviderRadioBrowserStationQueryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerDataProviderRadioBrowser* self;
	gchar* path;
	gchar* query;
	GeeSet* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint status_code;
	GUri* uri;
	GUri* _tmp4_;
	GUri* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GInputStream* stream;
	GUri* _tmp11_;
	guint _tmp12_;
	GInputStream* _tmp13_;
	gboolean _tmp14_;
	GInputStream* _tmp15_;
	GeeSet* stations;
	GInputStream* _tmp16_;
	GeeSet* _tmp17_;
	GError* e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GUri* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GUri* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GeeHashSet* _tmp34_;
	GError* _inner_error0_;
};

struct _Block4Data {
	int _ref_count_;
	TunerDataProviderRadioBrowser* self;
	GeeHashSet* stations;
};

struct _Block5Data {
	int _ref_count_;
	TunerDataProviderRadioBrowser* self;
	GeeHashSet* tags;
};

struct _Block6Data {
	int _ref_count_;
	TunerDataProviderRadioBrowser* self;
	GeeArrayList* results;
};

static gint TunerDataProviderRadioBrowser_private_offset;
static gpointer tuner_data_provider_radio_browser_parent_class = NULL;
static TunerDataProviderAPIIface * tuner_data_provider_radio_browser_tuner_data_provider_api_parent_iface = NULL;

VALA_EXTERN GType tuner_data_provider_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderTag, g_object_unref)
VALA_EXTERN GQuark tuner_data_provider_data_error_quark (void);
GType tuner_data_provider_data_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_data_provider_search_params_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_sort_order_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TunerDataProviderSearchParams* tuner_data_provider_search_params_dup (const TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_free (TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_copy (const TunerDataProviderSearchParams* self,
                                             TunerDataProviderSearchParams* dest);
VALA_EXTERN void tuner_data_provider_search_params_destroy (TunerDataProviderSearchParams* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TunerDataProviderSearchParams, tuner_data_provider_search_params_destroy)
VALA_EXTERN GType tuner_data_provider_api_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_api_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderAPI, g_object_unref)
VALA_EXTERN GType tuner_data_provider_radio_browser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderRadioBrowser, g_object_unref)
static gchar* tuner_data_provider_radio_browser_real_name (TunerDataProviderAPI* base);
static gint tuner_data_provider_radio_browser_real_available_stations (TunerDataProviderAPI* base);
static gint tuner_data_provider_radio_browser_real_available_tags (TunerDataProviderAPI* base);
VALA_EXTERN TunerDataProviderRadioBrowser* tuner_data_provider_radio_browser_new (const gchar* optionalservers);
VALA_EXTERN TunerDataProviderRadioBrowser* tuner_data_provider_radio_browser_construct (GType object_type,
                                                                            const gchar* optionalservers);
VALA_EXTERN void tuner_data_provider_api_set_status (TunerDataProviderAPI* self,
                                         TunerDataProviderAPIStatus value);
static GUri* tuner_data_provider_radio_browser_build_uri (TunerDataProviderRadioBrowser* self,
                                                   const gchar* path,
                                                   const gchar* query);
static gboolean tuner_data_provider_radio_browser_real_initialize (TunerDataProviderAPI* base);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN gboolean tuner_application_get_is_offline (TunerApplication* self);
static GeeArrayList* tuner_data_provider_radio_browser_get_srv_api_servers (TunerDataProviderRadioBrowser* self,
                                                                     GError** error);
VALA_EXTERN void tuner_data_provider_api_set_last_data_error (TunerDataProviderAPI* self,
                                                  GError* value);
static void tuner_data_provider_radio_browser_choose_server (TunerDataProviderRadioBrowser* self);
VALA_EXTERN void tuner_data_provider_api_clear_last_error (TunerDataProviderAPI* self);
static void tuner_data_provider_radio_browser_stats (TunerDataProviderRadioBrowser* self);
static void tuner_data_provider_radio_browser_real_click (TunerDataProviderAPI* base,
                                                   const gchar* stationuuid);
VALA_EXTERN GInputStream* tuner_http_client_GET (GUri* uri,
                                     guint* status_code);
static void tuner_data_provider_radio_browser_real_vote (TunerDataProviderAPI* base,
                                                  const gchar* stationuuid);
static GeeSet* tuner_data_provider_radio_browser_real_get_tags (TunerDataProviderAPI* base,
                                                         gint offset,
                                                         gint limit,
                                                         GError** error);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static GeeSet* tuner_data_provider_radio_browser_jarray_to_tags (TunerDataProviderRadioBrowser* self,
                                                          JsonArray* data);
static GeeSet* tuner_data_provider_radio_browser_real_by_uuid (TunerDataProviderAPI* base,
                                                        const gchar* uuid,
                                                        GError** error);
VALA_EXTERN const gchar* tuner_safestrip (const gchar* text);
static GeeSet* tuner_data_provider_radio_browser_station_query (TunerDataProviderRadioBrowser* self,
                                                         const gchar* path,
                                                         const gchar* query,
                                                         GError** error);
static GeeSet* tuner_data_provider_radio_browser_real_by_uuids (TunerDataProviderAPI* base,
                                                         GeeCollection* uuids,
                                                         GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuid (TunerDataProviderAPI* self,
                                         const gchar* uuids,
                                         GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_radio_browser_by_url (TunerDataProviderRadioBrowser* self,
                                                  const gchar* url,
                                                  GError** error);
static GeeSet* tuner_data_provider_radio_browser_real_search (TunerDataProviderAPI* base,
                                                       TunerDataProviderSearchParams* params,
                                                       guint rowcount,
                                                       guint offset,
                                                       GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuids (TunerDataProviderAPI* self,
                                          GeeCollection* uuids,
                                          GError** error);
static gchar* tuner_data_provider_radio_browser_get_search_query_params (TunerDataProviderRadioBrowser* self,
                                                                  TunerDataProviderSearchParams* params,
                                                                  guint rowcount,
                                                                  guint offset);
static void tuner_data_provider_radio_browser_real_search_async_data_free (gpointer _data);
static void tuner_data_provider_radio_browser_real_search_async (TunerDataProviderAPI* base,
                                                          TunerDataProviderSearchParams* params,
                                                          guint rowcount,
                                                          guint offset,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static gboolean tuner_data_provider_radio_browser_real_search_async_co (TunerDataProviderRadioBrowserSearchAsyncData* _data_);
static void tuner_data_provider_radio_browser_station_query_async (TunerDataProviderRadioBrowser* self,
                                                            const gchar* path,
                                                            const gchar* query,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
static GeeSet* tuner_data_provider_radio_browser_station_query_finish (TunerDataProviderRadioBrowser* self,
                                                                GAsyncResult* _res_,
                                                                GError** error);
static void tuner_data_provider_radio_browser_search_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void tuner_data_provider_radio_browser_degrade (TunerDataProviderRadioBrowser* self,
                                                gboolean degraded);
static GeeSet* tuner_data_provider_radio_browser_parse_json_response (TunerDataProviderRadioBrowser* self,
                                                               GInputStream* stream,
                                                               GError** error);
static void tuner_data_provider_radio_browser_station_query_async_data_free (gpointer _data);
static gboolean tuner_data_provider_radio_browser_station_query_async_co (TunerDataProviderRadioBrowserStationQueryAsyncData* _data_);
VALA_EXTERN void tuner_http_client_GETasync (GUri* uri,
                                 gint priority,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static void tuner_data_provider_radio_browser_station_query_async_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
VALA_EXTERN gchar* tuner_data_provider_sort_order_to_string (TunerDataProviderSortOrder self);
static gchar* tuner_data_provider_radio_browser_encode_text (const gchar* tag);
static GeeSet* tuner_data_provider_radio_browser_jarray_to_stations (TunerDataProviderRadioBrowser* self,
                                                              JsonArray* data);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda101_ (Block4Data* _data4_,
                    JsonArray* array,
                    guint index,
                    JsonNode* element);
VALA_EXTERN TunerModelStation* tuner_model_station_make (JsonNode* json_node);
static void ____lambda101__json_array_foreach (JsonArray* array,
                                        guint index_,
                                        JsonNode* element_node,
                                        gpointer self);
static TunerDataProviderTag* tuner_data_provider_radio_browser_jnode_to_tag (TunerDataProviderRadioBrowser* self,
                                                                      JsonNode* node);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda100_ (Block5Data* _data5_,
                    JsonArray* array,
                    guint index,
                    JsonNode* element);
static void ____lambda100__json_array_foreach (JsonArray* array,
                                        guint index_,
                                        JsonNode* element_node,
                                        gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static GSrvTarget* _vala_GSrvTarget_copy (GSrvTarget* self);
static void _vala_GSrvTarget_free (GSrvTarget* self);
static void __vala_GSrvTarget_free0_ (gpointer var);
static inline void _g_list_free___vala_GSrvTarget_free0_ (GList* self);
static void ______lambda99_ (Block6Data* _data6_,
                      JsonArray* array,
                      guint index_,
                      JsonNode* element_node);
static void _______lambda99__json_array_foreach (JsonArray* array,
                                          guint index_,
                                          JsonNode* element_node,
                                          gpointer self);
VALA_EXTERN gchar* tuner_data_provider_api_name (TunerDataProviderAPI* self);
VALA_EXTERN gint tuner_data_provider_api_available_stations (TunerDataProviderAPI* self);
VALA_EXTERN gint tuner_data_provider_api_available_tags (TunerDataProviderAPI* self);
VALA_EXTERN gboolean tuner_data_provider_api_initialize (TunerDataProviderAPI* self);
VALA_EXTERN void tuner_data_provider_api_click (TunerDataProviderAPI* self,
                                    const gchar* stationuuid);
VALA_EXTERN void tuner_data_provider_api_vote (TunerDataProviderAPI* self,
                                   const gchar* stationuuid);
VALA_EXTERN GeeSet* tuner_data_provider_api_get_tags (TunerDataProviderAPI* self,
                                          gint offset,
                                          gint limit,
                                          GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_search (TunerDataProviderAPI* self,
                                        TunerDataProviderSearchParams* params,
                                        guint rowcount,
                                        guint offset,
                                        GError** error);
VALA_EXTERN void tuner_data_provider_api_search_async (TunerDataProviderAPI* self,
                                           TunerDataProviderSearchParams* params,
                                           guint rowcount,
                                           guint offset,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN GeeSet* tuner_data_provider_api_search_finish (TunerDataProviderAPI* self,
                                               GAsyncResult* _res_,
                                               GError** error);
VALA_EXTERN TunerDataProviderAPIStatus tuner_data_provider_api_get_status (TunerDataProviderAPI* self);
VALA_EXTERN GError* tuner_data_provider_api_get_last_data_error (TunerDataProviderAPI* self);
static void tuner_data_provider_radio_browser_finalize (GObject * obj);
static GType tuner_data_provider_radio_browser_get_type_once (void);
static void _vala_tuner_data_provider_radio_browser_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_tuner_data_provider_radio_browser_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
tuner_data_provider_radio_browser_get_instance_private (TunerDataProviderRadioBrowser* self)
{
	return G_STRUCT_MEMBER_P (self, TunerDataProviderRadioBrowser_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
tuner_data_provider_radio_browser_real_name (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
	self = (TunerDataProviderRadioBrowser*) base;
	_tmp0_ = self->priv->_current_server;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("RadioBrowser 2.0\n\nServer: ", _tmp1_, NULL);
	result = _tmp2_;
	return result;
}

static gint
tuner_data_provider_radio_browser_real_available_stations (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	gint result;
	self = (TunerDataProviderRadioBrowser*) base;
	result = self->priv->_available_stations;
	return result;
}

static gint
tuner_data_provider_radio_browser_real_available_tags (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	gint result;
	self = (TunerDataProviderRadioBrowser*) base;
	result = self->priv->_available_tags;
	return result;
}

/**
        * @brief Constructor for RadioBrowser Client
        *
        * @throw DataError if unable to initialize the client
        */
TunerDataProviderRadioBrowser*
tuner_data_provider_radio_browser_construct (GType object_type,
                                             const gchar* optionalservers)
{
	TunerDataProviderRadioBrowser * self = NULL;
	gchar* _tmp0_;
	self = (TunerDataProviderRadioBrowser*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (optionalservers);
	_g_free0 (self->priv->_optionalservers);
	self->priv->_optionalservers = _tmp0_;
	tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE);
	return self;
}

TunerDataProviderRadioBrowser*
tuner_data_provider_radio_browser_new (const gchar* optionalservers)
{
	return tuner_data_provider_radio_browser_construct (TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, optionalservers);
}

/**
         * @brief Builds a Glib Uri from path and query
         *
         * Uses Glib Uri Parse with encoding to correctly check and encode the query
         *
         * @return the Uri if successful
         */
static GUri*
tuner_data_provider_radio_browser_build_uri (TunerDataProviderRadioBrowser* self,
                                             const gchar* path,
                                             const gchar* query)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	GUri* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (query != NULL, NULL);
	_tmp0_ = self->priv->_current_server;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = string_to_string (path);
	_tmp3_ = string_to_string (query);
	_tmp4_ = g_strconcat ("http://", _tmp1_, _tmp2_, "?", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	g_debug ("RadioBrowser.vala:112: %s", _tmp5_);
	_g_free0 (_tmp5_);
	{
		if (g_strcmp0 (query, "") == 0) {
			GUri* _tmp6_ = NULL;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GUri* _tmp12_;
			GUri* _tmp13_;
			GUri* _tmp14_;
			_tmp7_ = self->priv->_current_server;
			_tmp8_ = string_to_string (_tmp7_);
			_tmp9_ = string_to_string (path);
			_tmp10_ = g_strconcat ("http://", _tmp8_, _tmp9_, NULL);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_uri_parse (_tmp11_, G_URI_FLAGS_ENCODED, &_inner_error0_);
			_tmp13_ = _tmp12_;
			_g_free0 (_tmp11_);
			_tmp6_ = _tmp13_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_URI_ERROR) {
					goto __catch0_g_uri_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp14_ = _tmp6_;
			_tmp6_ = NULL;
			result = _tmp14_;
			_g_uri_unref0 (_tmp6_);
			return result;
		} else {
			GUri* _tmp15_ = NULL;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			GUri* _tmp22_;
			GUri* _tmp23_;
			GUri* _tmp24_;
			_tmp16_ = self->priv->_current_server;
			_tmp17_ = string_to_string (_tmp16_);
			_tmp18_ = string_to_string (path);
			_tmp19_ = string_to_string (query);
			_tmp20_ = g_strconcat ("http://", _tmp17_, _tmp18_, "?", _tmp19_, NULL);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_uri_parse (_tmp21_, G_URI_FLAGS_ENCODED, &_inner_error0_);
			_tmp23_ = _tmp22_;
			_g_free0 (_tmp21_);
			_tmp15_ = _tmp23_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_URI_ERROR) {
					goto __catch0_g_uri_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp24_ = _tmp15_;
			_tmp15_ = NULL;
			result = _tmp24_;
			_g_uri_unref0 (_tmp15_);
			return result;
		}
	}
	goto __finally0;
	__catch0_g_uri_error:
	{
		GError* e = NULL;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		GError* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp25_ = self->priv->_current_server;
		_tmp26_ = string_to_string (_tmp25_);
		_tmp27_ = string_to_string (path);
		_tmp28_ = string_to_string (query);
		_tmp29_ = e;
		_tmp30_ = _tmp29_->message;
		_tmp31_ = string_to_string (_tmp30_);
		_tmp32_ = g_strconcat ("Server: ", _tmp26_, "  Path: ", _tmp27_, "  Query: ", _tmp28_, "  Error: ", _tmp31_, NULL);
		_tmp33_ = _tmp32_;
		g_warning ("RadioBrowser.vala:124: %s", _tmp33_);
		_g_free0 (_tmp33_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	return result;
}

/**
         * @brief Initialize the DataProvider implementation
         *
         * @return true if initialization successful
        */
static gboolean
tuner_data_provider_radio_browser_real_initialize (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	GeeArrayList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (TunerDataProviderRadioBrowser*) base;
	_tmp0_ = tuner_app ();
	_tmp1_ = _tmp0_;
	_tmp2_ = tuner_application_get_is_offline (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = self->priv->_optionalservers;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		GeeArrayList* _tmp9_;
		_tmp6_ = self->priv->_optionalservers;
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 0);
		_tmp9_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp8_, _vala_array_length (_tmp7_), NULL, NULL, NULL);
		_g_object_unref0 (self->priv->_servers);
		self->priv->_servers = _tmp9_;
	} else {
		{
			GeeArrayList* _tmp10_ = NULL;
			GeeArrayList* _tmp11_;
			GeeArrayList* _tmp13_;
			_tmp11_ = tuner_data_provider_radio_browser_get_srv_api_servers (self, &_inner_error0_);
			_tmp10_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp12_ = FALSE;
				if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
					goto __catch0_tuner_data_provider_data_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp12_;
			}
			_tmp13_ = _tmp10_;
			_tmp10_ = NULL;
			_g_object_unref0 (self->priv->_servers);
			self->priv->_servers = _tmp13_;
			_g_object_unref0 (_tmp10_);
		}
		goto __finally0;
		__catch0_tuner_data_provider_data_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GError* _tmp19_;
			GError* _tmp20_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp14_ = e;
			_tmp15_ = _tmp14_->message;
			_tmp16_ = string_to_string (_tmp15_);
			_tmp17_ = g_strconcat ("Failed to retrieve API servers: ", _tmp16_, NULL);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION, _tmp18_);
			_tmp20_ = _tmp19_;
			tuner_data_provider_api_set_last_data_error ((TunerDataProviderAPI*) self, _tmp20_);
			_g_error_free0 (_tmp20_);
			_g_free0 (_tmp18_);
			tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST);
			result = FALSE;
			_g_error_free0 (e);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp21_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp21_;
		}
	}
	_tmp22_ = self->priv->_servers;
	_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_ == 0) {
		GError* _tmp25_;
		GError* _tmp26_;
		_tmp25_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION, "Unable to resolve API servers for radio-browser.info");
		_tmp26_ = _tmp25_;
		tuner_data_provider_api_set_last_data_error ((TunerDataProviderAPI*) self, _tmp26_);
		_g_error_free0 (_tmp26_);
		tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED);
		result = FALSE;
		return result;
	}
	tuner_data_provider_radio_browser_choose_server (self);
	tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_OK);
	tuner_data_provider_api_clear_last_error ((TunerDataProviderAPI*) self);
	tuner_data_provider_radio_browser_stats (self);
	result = TRUE;
	return result;
}

/**
         * @brief Track a station listen event
         *
         * @param stationuuid UUID of the station being listened to
         */
static void
tuner_data_provider_radio_browser_real_click (TunerDataProviderAPI* base,
                                              const gchar* stationuuid)
{
	TunerDataProviderRadioBrowser * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint status_code = 0U;
	GUri* _tmp3_;
	GUri* _tmp4_;
	guint _tmp5_ = 0U;
	GInputStream* _tmp6_;
	GInputStream* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	self = (TunerDataProviderRadioBrowser*) base;
	g_return_if_fail (stationuuid != NULL);
	_tmp0_ = string_to_string (stationuuid);
	_tmp1_ = g_strconcat ("sending listening event for station ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("RadioBrowser.vala:176: %s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_STATION, stationuuid);
	_tmp4_ = _tmp3_;
	_tmp6_ = tuner_http_client_GET (_tmp4_, &_tmp5_);
	status_code = _tmp5_;
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp7_);
	_g_uri_unref0 (_tmp4_);
	_tmp8_ = g_strdup_printf ("%u", status_code);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat ("response: ", _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	g_debug ("RadioBrowser.vala:179: %s", _tmp11_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
}

/**
         * @brief Vote for a station
         * @param stationuuid UUID of the station being voted for
         */
static void
tuner_data_provider_radio_browser_real_vote (TunerDataProviderAPI* base,
                                             const gchar* stationuuid)
{
	TunerDataProviderRadioBrowser * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint status_code = 0U;
	GUri* _tmp3_;
	GUri* _tmp4_;
	guint _tmp5_ = 0U;
	GInputStream* _tmp6_;
	GInputStream* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	self = (TunerDataProviderRadioBrowser*) base;
	g_return_if_fail (stationuuid != NULL);
	_tmp0_ = string_to_string (stationuuid);
	_tmp1_ = g_strconcat ("sending vote event for station ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	g_debug ("RadioBrowser.vala:188: %s", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_VOTE, stationuuid);
	_tmp4_ = _tmp3_;
	_tmp6_ = tuner_http_client_GET (_tmp4_, &_tmp5_);
	status_code = _tmp5_;
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp7_);
	_g_uri_unref0 (_tmp4_);
	_tmp8_ = g_strdup_printf ("%u", status_code);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat ("response: ", _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	g_debug ("RadioBrowser.vala:194: %s", _tmp11_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
}

/**
         * @brief Get all available tags
         *
         * @return ArrayList of Tag objects
         * @throw DataError if unable to retrieve or parse tag data
         */
static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static gpointer
_json_array_ref0 (gpointer self)
{
	return self ? json_array_ref (self) : NULL;
}

static GeeSet*
tuner_data_provider_radio_browser_real_get_tags (TunerDataProviderAPI* base,
                                                 gint offset,
                                                 gint limit,
                                                 GError** error)
{
	TunerDataProviderRadioBrowser * self;
	JsonNode* rootnode = NULL;
	GeeHashSet* _tmp33_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	self = (TunerDataProviderRadioBrowser*) base;
	{
		guint status_code = 0U;
		gchar* query = NULL;
		gchar* _tmp0_;
		GUri* uri = NULL;
		const gchar* _tmp9_;
		GUri* _tmp10_;
		GInputStream* stream = NULL;
		GUri* _tmp11_;
		guint _tmp12_ = 0U;
		GInputStream* _tmp13_;
		gboolean _tmp14_ = FALSE;
		_tmp0_ = g_strdup ("");
		query = _tmp0_;
		if (offset > 0) {
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = g_strdup_printf ("%i", offset);
			_tmp2_ = _tmp1_;
			_tmp3_ = g_strconcat ("offset=", _tmp2_, NULL);
			_g_free0 (query);
			query = _tmp3_;
			_g_free0 (_tmp2_);
		}
		if (limit > 0) {
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			_tmp4_ = query;
			_tmp5_ = string_to_string (_tmp4_);
			_tmp6_ = g_strdup_printf ("%i", limit);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strconcat (_tmp5_, "&limit=", _tmp7_, NULL);
			_g_free0 (query);
			query = _tmp8_;
			_g_free0 (_tmp7_);
		}
		_tmp9_ = query;
		_tmp10_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_TAGS, _tmp9_);
		uri = _tmp10_;
		_tmp11_ = uri;
		_tmp13_ = tuner_http_client_GET (_tmp11_, &_tmp12_);
		status_code = _tmp12_;
		stream = _tmp13_;
		if (status_code != ((guint) 0)) {
			GInputStream* _tmp15_;
			_tmp15_ = stream;
			_tmp14_ = _tmp15_ != NULL;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			JsonArray* rootarray = NULL;
			JsonArray* _tmp29_;
			JsonArray* _tmp30_;
			GeeSet* tags = NULL;
			JsonArray* _tmp31_;
			GeeSet* _tmp32_;
			{
				JsonParser* parser = NULL;
				JsonParser* _tmp16_;
				JsonParser* _tmp17_;
				GInputStream* _tmp18_;
				JsonParser* _tmp19_;
				JsonNode* _tmp20_;
				JsonNode* _tmp21_;
				_tmp16_ = json_parser_new ();
				parser = _tmp16_;
				_tmp17_ = parser;
				_tmp18_ = stream;
				json_parser_load_from_stream (_tmp17_, _tmp18_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (parser);
					goto __catch1_g_error;
				}
				_tmp19_ = parser;
				_tmp20_ = json_parser_get_root (_tmp19_);
				_tmp21_ = __vala_JsonNode_copy0 (_tmp20_);
				__vala_JsonNode_free0 (rootnode);
				rootnode = _tmp21_;
				_g_object_unref0 (parser);
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				GError* _tmp27_;
				GError* _tmp28_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp22_ = e;
				_tmp23_ = _tmp22_->message;
				_tmp24_ = string_to_string (_tmp23_);
				_tmp25_ = g_strconcat ("unable to parse JSON response: ", _tmp24_, NULL);
				_tmp26_ = _tmp25_;
				_tmp27_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA, _tmp26_);
				_tmp28_ = _tmp27_;
				_g_free0 (_tmp26_);
				_inner_error0_ = _tmp28_;
				_g_error_free0 (e);
				goto __finally1;
			}
			__finally1:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (stream);
				_g_uri_unref0 (uri);
				_g_free0 (query);
				goto __catch0_g_error;
			}
			_tmp29_ = json_node_get_array (rootnode);
			_tmp30_ = _json_array_ref0 (_tmp29_);
			rootarray = _tmp30_;
			_tmp31_ = rootarray;
			_tmp32_ = tuner_data_provider_radio_browser_jarray_to_tags (self, _tmp31_);
			tags = _tmp32_;
			result = tags;
			_json_array_unref0 (rootarray);
			_g_object_unref0 (stream);
			_g_uri_unref0 (uri);
			_g_free0 (query);
			__vala_JsonNode_free0 (rootnode);
			return result;
		}
		_g_object_unref0 (stream);
		_g_uri_unref0 (uri);
		_g_free0 (query);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_debug ("RadioBrowser.vala:229: cannot get_tags()");
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			__vala_JsonNode_free0 (rootnode);
			return NULL;
		} else {
			__vala_JsonNode_free0 (rootnode);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp33_ = gee_hash_set_new (TUNER_DATA_PROVIDER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	result = (GeeSet*) _tmp33_;
	__vala_JsonNode_free0 (rootnode);
	return result;
}

/**
         * @brief Get a station or stations by UUID
         *
         * @param uuids comma seperated lists of the stations to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */
static GeeSet*
tuner_data_provider_radio_browser_real_by_uuid (TunerDataProviderAPI* base,
                                                const gchar* uuid,
                                                GError** error)
{
	TunerDataProviderRadioBrowser * self;
	gboolean _tmp0_ = FALSE;
	TunerApplication* _tmp1_;
	TunerApplication* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GeeSet* _result_ = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GeeSet* _tmp13_;
	GeeSet* _tmp14_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	self = (TunerDataProviderRadioBrowser*) base;
	g_return_val_if_fail (uuid != NULL, NULL);
	_tmp1_ = tuner_app ();
	_tmp2_ = _tmp1_;
	_tmp3_ = tuner_application_get_is_offline (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp2_);
	if (_tmp5_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		_tmp6_ = tuner_safestrip (uuid);
		_tmp7_ = strlen (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_ == 0;
	}
	if (_tmp0_) {
		GeeHashSet* _tmp9_;
		_tmp9_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
		result = (GeeSet*) _tmp9_;
		return result;
	}
	_tmp10_ = string_to_string (uuid);
	_tmp11_ = g_strconcat ("uuids=", _tmp10_, NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = tuner_data_provider_radio_browser_station_query (self, TUNER_DATA_PROVIDER_RBI_UUID, _tmp12_, &_inner_error0_);
	_tmp14_ = _tmp13_;
	_g_free0 (_tmp12_);
	_result_ = _tmp14_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = _result_;
	return result;
}

/**
         * @brief Get a station or stations by UUIDs
         *
         * @param a collection of uuids of the stations to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */
static GeeSet*
tuner_data_provider_radio_browser_real_by_uuids (TunerDataProviderAPI* base,
                                                 GeeCollection* uuids,
                                                 GError** error)
{
	TunerDataProviderRadioBrowser * self;
	GString* sb = NULL;
	GString* _tmp0_;
	GeeSet* _tmp8_ = NULL;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GeeSet* _tmp11_;
	GeeSet* _tmp12_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	self = (TunerDataProviderRadioBrowser*) base;
	g_return_val_if_fail (uuids != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	{
		GeeIterator* _uuid_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) uuids);
		_uuid_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			gchar* uuid = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GString* _tmp5_;
			const gchar* _tmp6_;
			GString* _tmp7_;
			_tmp2_ = _uuid_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _uuid_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			uuid = (gchar*) _tmp4_;
			_tmp5_ = sb;
			_tmp6_ = uuid;
			_tmp7_ = g_string_append (_tmp5_, _tmp6_);
			g_string_append (_tmp7_, ",");
			_g_free0 (uuid);
		}
		_g_object_unref0 (_uuid_it);
	}
	_tmp9_ = sb;
	_tmp10_ = _tmp9_->str;
	_tmp11_ = tuner_data_provider_api_by_uuid ((TunerDataProviderAPI*) self, _tmp10_, &_inner_error0_);
	_tmp8_ = _tmp11_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_string_free0 (sb);
			return NULL;
		} else {
			_g_string_free0 (sb);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp12_ = _tmp8_;
	_tmp8_ = NULL;
	result = _tmp12_;
	_g_object_unref0 (_tmp8_);
	_g_string_free0 (sb);
	return result;
}

/**
            Not implemented
        */
GeeSet*
tuner_data_provider_radio_browser_by_url (TunerDataProviderRadioBrowser* self,
                                          const gchar* url,
                                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	TunerApplication* _tmp1_;
	TunerApplication* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GeeSet* _result_ = NULL;
	const gchar* _tmp10_;
	GeeSet* _tmp11_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp1_ = tuner_app ();
	_tmp2_ = _tmp1_;
	_tmp3_ = tuner_application_get_is_offline (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp2_);
	if (_tmp5_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		_tmp6_ = tuner_safestrip (url);
		_tmp7_ = strlen (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_ == 0;
	}
	if (_tmp0_) {
		GeeHashSet* _tmp9_;
		_tmp9_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
		result = (GeeSet*) _tmp9_;
		return result;
	}
	_tmp10_ = string_to_string (url);
	_tmp11_ = tuner_data_provider_radio_browser_station_query (self, TUNER_DATA_PROVIDER_RBI_URL, _tmp10_, &_inner_error0_);
	_result_ = _tmp11_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = _result_;
	return result;
}

/**
        * @brief Search for stations based on given parameters
        *
        * @param params Search parameters
        * @param rowcount Maximum number of results to return
        * @param offset Offset for pagination
        * @return ArrayList of Station objects matching the search criteria
        * @throw DataError if unable to retrieve or parse station data
        */
static GeeSet*
tuner_data_provider_radio_browser_real_search (TunerDataProviderAPI* base,
                                               TunerDataProviderSearchParams* params,
                                               guint rowcount,
                                               guint offset,
                                               GError** error)
{
	TunerDataProviderRadioBrowser * self;
	TunerDataProviderSearchParams _tmp0_;
	GeeSet* _tmp1_;
	gchar* query = NULL;
	TunerDataProviderSearchParams _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GeeSet* _tmp13_ = NULL;
	const gchar* _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	self = (TunerDataProviderRadioBrowser*) base;
	g_return_val_if_fail (params != NULL, NULL);
	_tmp0_ = *params;
	_tmp1_ = _tmp0_.uuids;
	if (_tmp1_ != NULL) {
		GeeSet* _tmp2_ = NULL;
		TunerDataProviderSearchParams _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		_tmp3_ = *params;
		_tmp4_ = _tmp3_.uuids;
		_tmp5_ = tuner_data_provider_api_by_uuids ((TunerDataProviderAPI*) self, (GeeCollection*) _tmp4_, &_inner_error0_);
		_tmp2_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp6_ = _tmp2_;
		_tmp2_ = NULL;
		result = _tmp6_;
		_g_object_unref0 (_tmp2_);
		return result;
	}
	_tmp7_ = *params;
	_tmp8_ = tuner_data_provider_radio_browser_get_search_query_params (self, &_tmp7_, rowcount, offset);
	query = _tmp8_;
	_tmp9_ = query;
	_tmp10_ = string_to_string (_tmp9_);
	_tmp11_ = g_strconcat ("Search: ", _tmp10_, NULL);
	_tmp12_ = _tmp11_;
	g_debug ("RadioBrowser.vala:295: %s", _tmp12_);
	_g_free0 (_tmp12_);
	_tmp14_ = query;
	_tmp15_ = tuner_data_provider_radio_browser_station_query (self, TUNER_DATA_PROVIDER_RBI_SEARCH, _tmp14_, &_inner_error0_);
	_tmp13_ = _tmp15_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (query);
			return NULL;
		} else {
			_g_free0 (query);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp16_ = _tmp13_;
	_tmp13_ = NULL;
	result = _tmp16_;
	_g_object_unref0 (_tmp13_);
	_g_free0 (query);
	return result;
}

static void
tuner_data_provider_radio_browser_real_search_async_data_free (gpointer _data)
{
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
	_data_ = _data;
	tuner_data_provider_search_params_destroy (&_data_->params);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (TunerDataProviderRadioBrowserSearchAsyncData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
tuner_data_provider_radio_browser_real_search_async (TunerDataProviderAPI* base,
                                                     TunerDataProviderSearchParams* params,
                                                     guint rowcount,
                                                     guint offset,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	TunerDataProviderRadioBrowser * self;
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
	TunerDataProviderRadioBrowser* _tmp0_;
	TunerDataProviderSearchParams _tmp1_;
	TunerDataProviderSearchParams _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	g_return_if_fail (params != NULL);
	self = (TunerDataProviderRadioBrowser*) base;
	_data_ = g_slice_new0 (TunerDataProviderRadioBrowserSearchAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_data_provider_radio_browser_real_search_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = *params;
	_tmp2_ = _tmp1_;
	tuner_data_provider_search_params_copy (&_tmp2_, &_tmp3_);
	tuner_data_provider_search_params_destroy (&_data_->params);
	_data_->params = _tmp3_;
	_data_->rowcount = rowcount;
	_data_->offset = offset;
	tuner_data_provider_radio_browser_real_search_async_co (_data_);
}

static GeeSet*
tuner_data_provider_radio_browser_search_finish (TunerDataProviderAPI* base,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GeeSet* result;
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
        * @brief Search for stations based on given parameters
        *
        * @param params Search parameters
        * @param rowcount Maximum number of results to return
        * @param offset Offset for pagination
        * @return ArrayList of Station objects matching the search criteria
        * @throw DataError if unable to retrieve or parse station data
        */
static void
tuner_data_provider_radio_browser_search_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_data_provider_radio_browser_real_search_async_co (_data_);
}

static gboolean
tuner_data_provider_radio_browser_real_search_async_co (TunerDataProviderRadioBrowserSearchAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->params;
	_data_->_tmp1_ = _data_->_tmp0_.uuids;
	if (_data_->_tmp1_ != NULL) {
		_data_->_tmp3_ = _data_->params;
		_data_->_tmp4_ = _data_->_tmp3_.uuids;
		_data_->_tmp5_ = tuner_data_provider_api_by_uuids ((TunerDataProviderAPI*) _data_->self, (GeeCollection*) _data_->_tmp4_, &_data_->_inner_error0_);
		_data_->_tmp2_ = _data_->_tmp5_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
		_data_->_tmp6_ = _data_->_tmp2_;
		_data_->_tmp2_ = NULL;
		_data_->result = _data_->_tmp6_;
		_g_object_unref0 (_data_->_tmp2_);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp7_ = _data_->params;
	_data_->_tmp8_ = tuner_data_provider_radio_browser_get_search_query_params (_data_->self, &_data_->_tmp7_, _data_->rowcount, _data_->offset);
	_data_->query = _data_->_tmp8_;
	_data_->_tmp9_ = _data_->query;
	_data_->_tmp10_ = string_to_string (_data_->_tmp9_);
	_data_->_tmp11_ = g_strconcat ("Search: ", _data_->_tmp10_, NULL);
	_data_->_tmp12_ = _data_->_tmp11_;
	g_debug ("RadioBrowser.vala:322: %s", _data_->_tmp12_);
	_g_free0 (_data_->_tmp12_);
	_data_->_tmp14_ = _data_->query;
	_data_->_state_ = 1;
	tuner_data_provider_radio_browser_station_query_async (_data_->self, TUNER_DATA_PROVIDER_RBI_SEARCH, _data_->_tmp14_, tuner_data_provider_radio_browser_search_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp15_ = tuner_data_provider_radio_browser_station_query_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
	_data_->_tmp13_ = _data_->_tmp15_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_free0 (_data_->query);
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			_g_free0 (_data_->query);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp16_ = _data_->_tmp13_;
	_data_->_tmp13_ = NULL;
	_data_->result = _data_->_tmp16_;
	_g_object_unref0 (_data_->_tmp13_);
	_g_free0 (_data_->query);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

/**
         * @brief Get all available tags
         *
         * @return ArrayList of Tag objects
         * @throw DataError if unable to retrieve or parse tag data
         */
static void
tuner_data_provider_radio_browser_choose_server (TunerDataProviderRadioBrowser* self)
{
	gint32 random_server = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_servers;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	random_server = g_random_int_range ((gint32) 0, (gint32) _tmp2_);
	{
		gint a = 0;
		a = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				GeeArrayList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				guint status = 0U;
				gint32 server = 0;
				GeeArrayList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				GeeArrayList* _tmp11_;
				gpointer _tmp12_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = a;
					a = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = self->priv->_servers;
				_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
				_tmp7_ = _tmp6_;
				if (!(a < _tmp7_)) {
					break;
				}
				status = (guint) 0;
				_tmp8_ = self->priv->_servers;
				_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
				_tmp10_ = _tmp9_;
				server = (random_server + a) % _tmp10_;
				_tmp11_ = self->priv->_servers;
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, (gint) server);
				_g_free0 (self->priv->_current_server);
				self->priv->_current_server = (gchar*) _tmp12_;
				{
					GUri* uri = NULL;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					GUri* _tmp17_;
					GUri* _tmp18_;
					GUri* _tmp19_;
					guint _tmp20_ = 0U;
					GInputStream* _tmp21_;
					GInputStream* _tmp22_;
					_tmp13_ = self->priv->_current_server;
					_tmp14_ = string_to_string (_tmp13_);
					_tmp15_ = g_strconcat ("http://", _tmp14_, "/json/stats", NULL);
					_tmp16_ = _tmp15_;
					_tmp17_ = g_uri_parse (_tmp16_, G_URI_FLAGS_NONE, &_inner_error0_);
					_tmp18_ = _tmp17_;
					_g_free0 (_tmp16_);
					uri = _tmp18_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == G_URI_ERROR) {
							goto __catch0_g_uri_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp19_ = uri;
					_tmp21_ = tuner_http_client_GET (_tmp19_, &_tmp20_);
					status = _tmp20_;
					_tmp22_ = _tmp21_;
					_g_object_unref0 (_tmp22_);
					_g_uri_unref0 (uri);
				}
				goto __finally0;
				__catch0_g_uri_error:
				{
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					g_clear_error (&_inner_error0_);
					_tmp23_ = self->priv->_current_server;
					_tmp24_ = string_to_string (_tmp23_);
					_tmp25_ = g_strconcat ("Server - bad Uri from ", _tmp24_, NULL);
					_tmp26_ = _tmp25_;
					g_debug ("RadioBrowser.vala:354: %s", _tmp26_);
					_g_free0 (_tmp26_);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				if (status == ((guint) 200)) {
					break;
				}
			}
		}
	}
	_tmp27_ = self->priv->_current_server;
	_tmp28_ = string_to_string (_tmp27_);
	_tmp29_ = g_strconcat ("RadioBrowser Client - Chosen radio-browser.info server: ", _tmp28_, NULL);
	_tmp30_ = _tmp29_;
	g_debug ("RadioBrowser.vala:358: %s", _tmp30_);
	_g_free0 (_tmp30_);
}

/**
         * @brief Manages tracking server degradation and new server selection
         *
         * Tracks degraded server responses and at a certain level will choose 
         * a new server if possible 
         */
static void
tuner_data_provider_radio_browser_degrade (TunerDataProviderRadioBrowser* self,
                                           gboolean degraded)
{
	g_return_if_fail (self != NULL);
	if (!degraded) {
		gint _tmp0_ = 0;
		if (self->priv->_degrade > TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL) {
			_tmp0_ = 0;
		} else {
			_tmp0_ = 1;
		}
		self->priv->_degrade = self->priv->_degrade + _tmp0_;
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp1_ = self->priv->_current_server;
		_tmp2_ = string_to_string (_tmp1_);
		_tmp3_ = g_strconcat ("RadioBrowser degrading server: ", _tmp2_, NULL);
		_tmp4_ = _tmp3_;
		g_warning ("RadioBrowser.vala:378: %s", _tmp4_);
		_g_free0 (_tmp4_);
		self->priv->_degrade = -TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_COST;
		if (self->priv->_degrade < 0) {
			tuner_data_provider_radio_browser_choose_server (self);
			self->priv->_degrade = TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL;
		}
	}
}

/**
         * @brief Retrieve server stats
         *
         */
static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static void
tuner_data_provider_radio_browser_stats (TunerDataProviderRadioBrowser* self)
{
	guint status_code = 0U;
	JsonNode* rootnode = NULL;
	GInputStream* stream = NULL;
	GUri* _tmp0_;
	GUri* _tmp1_;
	guint _tmp2_ = 0U;
	GInputStream* _tmp3_;
	GInputStream* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_STATS, "");
	_tmp1_ = _tmp0_;
	_tmp3_ = tuner_http_client_GET (_tmp1_, &_tmp2_);
	status_code = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_uri_unref0 (_tmp1_);
	stream = _tmp4_;
	if (status_code != ((guint) 0)) {
		GInputStream* _tmp6_;
		_tmp6_ = stream;
		_tmp5_ = _tmp6_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		{
			JsonParser* parser = NULL;
			JsonParser* _tmp7_;
			JsonParser* _tmp8_;
			GInputStream* _tmp9_;
			JsonParser* _tmp10_;
			JsonNode* _tmp11_;
			JsonNode* _tmp12_;
			JsonObject* json_object = NULL;
			JsonNode* _tmp13_;
			JsonObject* _tmp14_;
			JsonObject* _tmp15_;
			JsonObject* _tmp16_;
			JsonObject* _tmp17_;
			_tmp7_ = json_parser_new ();
			parser = _tmp7_;
			_tmp8_ = parser;
			_tmp9_ = stream;
			json_parser_load_from_stream (_tmp8_, _tmp9_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (parser);
				goto __catch0_g_error;
			}
			_tmp10_ = parser;
			_tmp11_ = json_parser_get_root (_tmp10_);
			_tmp12_ = __vala_JsonNode_copy0 (_tmp11_);
			__vala_JsonNode_free0 (rootnode);
			rootnode = _tmp12_;
			_tmp13_ = rootnode;
			_tmp14_ = json_node_get_object (_tmp13_);
			_tmp15_ = _json_object_ref0 (_tmp14_);
			json_object = _tmp15_;
			_tmp16_ = json_object;
			self->priv->_available_stations = (gint) json_object_get_int_member (_tmp16_, "stations");
			_tmp17_ = json_object;
			self->priv->_available_tags = (gint) json_object_get_int_member (_tmp17_, "tags");
			_json_object_unref0 (json_object);
			_g_object_unref0 (parser);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp18_ = e;
			_tmp19_ = _tmp18_->message;
			_tmp20_ = string_to_string (_tmp19_);
			_tmp21_ = g_strconcat ("Could not get server stats: ", _tmp20_, NULL);
			_tmp22_ = _tmp21_;
			g_warning ("RadioBrowser.vala:412: %s", _tmp22_);
			_g_free0 (_tmp22_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (stream);
			__vala_JsonNode_free0 (rootnode);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp23_ = g_strdup_printf ("%u", status_code);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_strdup_printf ("%i", self->priv->_available_stations);
	_tmp26_ = _tmp25_;
	_tmp27_ = g_strdup_printf ("%i", self->priv->_available_tags);
	_tmp28_ = _tmp27_;
	_tmp29_ = g_strconcat ("response: ", _tmp24_, " - Stations: ", _tmp26_, " Tags: ", _tmp28_, NULL);
	_tmp30_ = _tmp29_;
	g_debug ("RadioBrowser.vala:415: %s", _tmp30_);
	_g_free0 (_tmp30_);
	_g_free0 (_tmp28_);
	_g_free0 (_tmp26_);
	_g_free0 (_tmp24_);
	_g_object_unref0 (stream);
	__vala_JsonNode_free0 (rootnode);
}

/**
         * @brief Get stations by querying the API
         *
         * @param query the API query
         * @return ArrayList of Station objects
         * @throw DataError if unable to retrieve or parse station data
         */
static GeeSet*
tuner_data_provider_radio_browser_station_query (TunerDataProviderRadioBrowser* self,
                                                 const gchar* path,
                                                 const gchar* query,
                                                 GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint status_code = 0U;
	GUri* uri = NULL;
	GUri* _tmp4_;
	GUri* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GInputStream* stream = NULL;
	GUri* _tmp11_;
	guint _tmp12_ = 0U;
	GInputStream* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GeeHashSet* _tmp34_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	g_return_val_if_fail (query != NULL, NULL);
	_tmp0_ = string_to_string (path);
	_tmp1_ = string_to_string (query);
	_tmp2_ = g_strconcat ("station_query - ", _tmp0_, " ", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	g_debug ("RadioBrowser.vala:429: %s", _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = tuner_data_provider_radio_browser_build_uri (self, path, query);
	uri = _tmp4_;
	_tmp5_ = uri;
	_tmp6_ = g_uri_to_string (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = string_to_string (_tmp7_);
	_tmp9_ = g_strconcat ("station_query - ", _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	g_debug ("RadioBrowser.vala:433: %s", _tmp10_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp7_);
	_tmp11_ = uri;
	_tmp13_ = tuner_http_client_GET (_tmp11_, &_tmp12_);
	status_code = _tmp12_;
	stream = _tmp13_;
	if (status_code == ((guint) 200)) {
		GInputStream* _tmp15_;
		_tmp15_ = stream;
		_tmp14_ = _tmp15_ != NULL;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		tuner_data_provider_radio_browser_degrade (self, FALSE);
		{
			GeeSet* stations = NULL;
			GInputStream* _tmp16_;
			GeeSet* _tmp17_;
			_tmp16_ = stream;
			_tmp17_ = tuner_data_provider_radio_browser_parse_json_response (self, _tmp16_, &_inner_error0_);
			stations = _tmp17_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			result = stations;
			_g_object_unref0 (stream);
			_g_uri_unref0 (uri);
			return result;
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			GUri* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp18_ = e;
			_tmp19_ = _tmp18_->message;
			_tmp20_ = string_to_string (_tmp19_);
			_tmp21_ = uri;
			_tmp22_ = g_uri_to_string (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_strconcat ("JSON error \"", _tmp20_, "\" for uri ", _tmp23_, NULL);
			_tmp25_ = _tmp24_;
			g_debug ("RadioBrowser.vala:446: %s", _tmp25_);
			_g_free0 (_tmp25_);
			_g_free0 (_tmp23_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (stream);
				_g_uri_unref0 (uri);
				return NULL;
			} else {
				_g_object_unref0 (stream);
				_g_uri_unref0 (uri);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	} else {
		gchar* _tmp26_;
		gchar* _tmp27_;
		GUri* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		_tmp26_ = g_strdup_printf ("%u", status_code);
		_tmp27_ = _tmp26_;
		_tmp28_ = uri;
		_tmp29_ = g_uri_to_string (_tmp28_);
		_tmp30_ = _tmp29_;
		_tmp31_ = string_to_string (_tmp30_);
		_tmp32_ = g_strconcat ("Response from 'radio-browser.info': ", _tmp27_, " for url: ", _tmp31_, NULL);
		_tmp33_ = _tmp32_;
		g_warning ("RadioBrowser.vala:451: %s", _tmp33_);
		_g_free0 (_tmp33_);
		_g_free0 (_tmp30_);
		_g_free0 (_tmp27_);
		tuner_data_provider_radio_browser_degrade (self, TRUE);
	}
	_tmp34_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	result = (GeeSet*) _tmp34_;
	_g_object_unref0 (stream);
	_g_uri_unref0 (uri);
	return result;
}

static void
tuner_data_provider_radio_browser_station_query_async_data_free (gpointer _data)
{
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->path);
	_g_free0 (_data_->query);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (TunerDataProviderRadioBrowserStationQueryAsyncData, _data_);
}

static void
tuner_data_provider_radio_browser_station_query_async (TunerDataProviderRadioBrowser* self,
                                                       const gchar* path,
                                                       const gchar* query,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
	TunerDataProviderRadioBrowser* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	g_return_if_fail (query != NULL);
	_data_ = g_slice_new0 (TunerDataProviderRadioBrowserStationQueryAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_data_provider_radio_browser_station_query_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (path);
	_g_free0 (_data_->path);
	_data_->path = _tmp1_;
	_tmp2_ = g_strdup (query);
	_g_free0 (_data_->query);
	_data_->query = _tmp2_;
	tuner_data_provider_radio_browser_station_query_async_co (_data_);
}

static GeeSet*
tuner_data_provider_radio_browser_station_query_finish (TunerDataProviderRadioBrowser* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	GeeSet* result;
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
        * @brief Get stations by querying the API
        *
        * @param query the API query
        * @return ArrayList of Station objects
        * @throw DataError if unable to retrieve or parse station data
        */
static void
tuner_data_provider_radio_browser_station_query_async_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_data_provider_radio_browser_station_query_async_co (_data_);
}

static gboolean
tuner_data_provider_radio_browser_station_query_async_co (TunerDataProviderRadioBrowserStationQueryAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = string_to_string (_data_->path);
	_data_->_tmp1_ = string_to_string (_data_->query);
	_data_->_tmp2_ = g_strconcat ("station_query - ", _data_->_tmp0_, " ", _data_->_tmp1_, NULL);
	_data_->_tmp3_ = _data_->_tmp2_;
	g_debug ("RadioBrowser.vala:467: %s", _data_->_tmp3_);
	_g_free0 (_data_->_tmp3_);
	_data_->_tmp4_ = tuner_data_provider_radio_browser_build_uri (_data_->self, _data_->path, _data_->query);
	_data_->uri = _data_->_tmp4_;
	_data_->_tmp5_ = _data_->uri;
	_data_->_tmp6_ = g_uri_to_string (_data_->_tmp5_);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = string_to_string (_data_->_tmp7_);
	_data_->_tmp9_ = g_strconcat ("station_query - ", _data_->_tmp8_, NULL);
	_data_->_tmp10_ = _data_->_tmp9_;
	g_debug ("RadioBrowser.vala:471: %s", _data_->_tmp10_);
	_g_free0 (_data_->_tmp10_);
	_g_free0 (_data_->_tmp7_);
	_data_->_tmp11_ = _data_->uri;
	_data_->_tmp12_ = 0U;
	_data_->_state_ = 1;
	tuner_http_client_GETasync (_data_->_tmp11_, G_PRIORITY_HIGH_IDLE, tuner_data_provider_radio_browser_station_query_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp13_ = tuner_http_client_GETasync_finish (_data_->_res_, &_data_->_tmp12_);
	_data_->status_code = _data_->_tmp12_;
	_data_->stream = _data_->_tmp13_;
	if (_data_->status_code == ((guint) 200)) {
		_data_->_tmp15_ = _data_->stream;
		_data_->_tmp14_ = _data_->_tmp15_ != NULL;
	} else {
		_data_->_tmp14_ = FALSE;
	}
	if (_data_->_tmp14_) {
		tuner_data_provider_radio_browser_degrade (_data_->self, FALSE);
		{
			_data_->_tmp16_ = _data_->stream;
			_data_->_tmp17_ = tuner_data_provider_radio_browser_parse_json_response (_data_->self, _data_->_tmp16_, &_data_->_inner_error0_);
			_data_->stations = _data_->_tmp17_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_data_->result = _data_->stations;
			_g_object_unref0 (_data_->stream);
			_g_uri_unref0 (_data_->uri);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp18_ = _data_->e;
			_data_->_tmp19_ = _data_->_tmp18_->message;
			_data_->_tmp20_ = string_to_string (_data_->_tmp19_);
			_data_->_tmp21_ = _data_->uri;
			_data_->_tmp22_ = g_uri_to_string (_data_->_tmp21_);
			_data_->_tmp23_ = _data_->_tmp22_;
			_data_->_tmp24_ = g_strconcat ("JSON error \"", _data_->_tmp20_, "\" for uri ", _data_->_tmp23_, NULL);
			_data_->_tmp25_ = _data_->_tmp24_;
			g_debug ("RadioBrowser.vala:484: %s", _data_->_tmp25_);
			_g_free0 (_data_->_tmp25_);
			_g_free0 (_data_->_tmp23_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
				_g_object_unref0 (_data_->stream);
				_g_uri_unref0 (_data_->uri);
				g_object_unref (_data_->_async_result);
				return FALSE;
			} else {
				_g_object_unref0 (_data_->stream);
				_g_uri_unref0 (_data_->uri);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
	} else {
		_data_->_tmp26_ = g_strdup_printf ("%u", _data_->status_code);
		_data_->_tmp27_ = _data_->_tmp26_;
		_data_->_tmp28_ = _data_->uri;
		_data_->_tmp29_ = g_uri_to_string (_data_->_tmp28_);
		_data_->_tmp30_ = _data_->_tmp29_;
		_data_->_tmp31_ = string_to_string (_data_->_tmp30_);
		_data_->_tmp32_ = g_strconcat ("Response from 'radio-browser.info': ", _data_->_tmp27_, " for url: ", _data_->_tmp31_, NULL);
		_data_->_tmp33_ = _data_->_tmp32_;
		g_warning ("RadioBrowser.vala:489: %s", _data_->_tmp33_);
		_g_free0 (_data_->_tmp33_);
		_g_free0 (_data_->_tmp30_);
		_g_free0 (_data_->_tmp27_);
		tuner_data_provider_radio_browser_degrade (_data_->self, TRUE);
	}
	_data_->_tmp34_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_data_->result = (GeeSet*) _data_->_tmp34_;
	_g_object_unref0 (_data_->stream);
	_g_uri_unref0 (_data_->uri);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

/**
         * Generates query parameters string for radio-browser API search requests.
         *
         * @param params    SearchParams object containing search criteria
         * @param rowcount  Maximum number of results to return
         * @param offset    Starting position in the result set
         *
         * @return String containing formatted query parameters
         */
static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp20_ = str_array[0];
		if (_tmp20_ != NULL) {
			const gchar* _tmp21_;
			_tmp21_ = str_array[0];
			_tmp19_ = (const gchar*) _tmp21_;
		} else {
			_tmp19_ = "";
		}
		_tmp22_ = res;
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
		ptr = _tmp23_;
		{
			gboolean _tmp24_ = FALSE;
			i = 1;
			_tmp24_ = TRUE;
			while (TRUE) {
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
				ptr = _tmp27_;
				_tmp29_ = str_array[i];
				if (_tmp29_ != NULL) {
					const gchar* _tmp30_;
					_tmp30_ = str_array[i];
					_tmp28_ = (const gchar*) _tmp30_;
				} else {
					_tmp28_ = "";
				}
				_tmp31_ = ptr;
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
				ptr = _tmp32_;
			}
		}
		_tmp33_ = res;
		res = NULL;
		result = (gchar*) _tmp33_;
		return result;
	} else {
		gchar* _tmp34_;
		_tmp34_ = g_strdup ("");
		result = _tmp34_;
		return result;
	}
}

static gchar*
tuner_data_provider_radio_browser_get_search_query_params (TunerDataProviderRadioBrowser* self,
                                                           TunerDataProviderSearchParams* params,
                                                           guint rowcount,
                                                           guint offset)
{
	gchar* query = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	TunerDataProviderSearchParams _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	TunerDataProviderSearchParams _tmp9_;
	const gchar* _tmp10_;
	TunerDataProviderSearchParams _tmp20_;
	const gchar* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	TunerDataProviderSearchParams _tmp31_;
	TunerDataProviderSearchParams _tmp39_;
	GeeSet* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (params != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%u", rowcount);
	_tmp1_ = _tmp0_;
	_tmp2_ = *params;
	_tmp3_ = tuner_data_provider_sort_order_to_string (_tmp2_.order);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf ("%u", offset);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat ("limit=", _tmp1_, "&order=", _tmp4_, "&offset=", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp1_);
	query = _tmp8_;
	_tmp9_ = *params;
	_tmp10_ = _tmp9_.text;
	if (g_strcmp0 (_tmp10_, "") != 0) {
		const gchar* _tmp11_;
		TunerDataProviderSearchParams _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp11_ = query;
		_tmp12_ = *params;
		_tmp13_ = _tmp12_.text;
		_tmp14_ = tuner_data_provider_radio_browser_encode_text (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = string_to_string (_tmp15_);
		_tmp17_ = g_strconcat ("&name=", _tmp16_, NULL);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat (_tmp11_, _tmp18_, NULL);
		_g_free0 (query);
		query = _tmp19_;
		_g_free0 (_tmp18_);
		_g_free0 (_tmp15_);
	}
	_tmp20_ = *params;
	_tmp21_ = _tmp20_.countrycode;
	_tmp22_ = strlen (_tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ > 0) {
		const gchar* _tmp24_;
		TunerDataProviderSearchParams _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp24_ = query;
		_tmp25_ = *params;
		_tmp26_ = _tmp25_.countrycode;
		_tmp27_ = string_to_string (_tmp26_);
		_tmp28_ = g_strconcat ("&countrycode=", _tmp27_, NULL);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strconcat (_tmp24_, _tmp29_, NULL);
		_g_free0 (query);
		query = _tmp30_;
		_g_free0 (_tmp29_);
	}
	_tmp31_ = *params;
	if (_tmp31_.order != TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM) {
		const gchar* _tmp32_;
		TunerDataProviderSearchParams _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		_tmp32_ = query;
		_tmp33_ = *params;
		_tmp34_ = bool_to_string (_tmp33_.reverse);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strconcat ("&reverse=", _tmp35_, NULL);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_strconcat (_tmp32_, _tmp37_, NULL);
		_g_free0 (query);
		query = _tmp38_;
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
	}
	_tmp39_ = *params;
	_tmp40_ = _tmp39_.tags;
	_tmp41_ = gee_collection_get_size ((GeeCollection*) _tmp40_);
	_tmp42_ = _tmp41_;
	if (_tmp42_ > 0) {
		gchar* tag_list = NULL;
		TunerDataProviderSearchParams _tmp43_;
		GeeSet* _tmp44_;
		gint _tmp45_ = 0;
		gpointer* _tmp46_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		TunerDataProviderSearchParams _tmp51_;
		GeeSet* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		const gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		_tmp43_ = *params;
		_tmp44_ = _tmp43_.tags;
		_tmp46_ = gee_collection_to_array ((GeeCollection*) _tmp44_, &_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp47__length1 = _tmp45_;
		_tmp48_ = _tmp47_[0];
		_tmp49_ = g_strdup (_tmp48_);
		_tmp50_ = _tmp49_;
		_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
		tag_list = _tmp50_;
		_tmp51_ = *params;
		_tmp52_ = _tmp51_.tags;
		_tmp53_ = gee_collection_get_size ((GeeCollection*) _tmp52_);
		_tmp54_ = _tmp53_;
		if (_tmp54_ > 1) {
			TunerDataProviderSearchParams _tmp55_;
			GeeSet* _tmp56_;
			gint _tmp57_ = 0;
			gpointer* _tmp58_;
			gchar** _tmp59_;
			gint _tmp59__length1;
			gchar* _tmp60_;
			_tmp55_ = *params;
			_tmp56_ = _tmp55_.tags;
			_tmp58_ = gee_collection_to_array ((GeeCollection*) _tmp56_, &_tmp57_);
			_tmp59_ = _tmp58_;
			_tmp59__length1 = _tmp57_;
			_tmp60_ = _vala_g_strjoinv (",", _tmp59_, (gint) _tmp57_);
			_g_free0 (tag_list);
			tag_list = _tmp60_;
			_tmp59_ = (_vala_array_free (_tmp59_, _tmp59__length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp61_ = query;
		_tmp62_ = tag_list;
		_tmp63_ = tuner_data_provider_radio_browser_encode_text (_tmp62_);
		_tmp64_ = _tmp63_;
		_tmp65_ = string_to_string (_tmp64_);
		_tmp66_ = g_strconcat ("&tagExact=false&tagList=", _tmp65_, NULL);
		_tmp67_ = _tmp66_;
		_tmp68_ = g_strconcat (_tmp61_, _tmp67_, NULL);
		_g_free0 (query);
		query = _tmp68_;
		_g_free0 (_tmp67_);
		_g_free0 (_tmp64_);
		_g_free0 (tag_list);
	}
	result = query;
	return result;
}

/**
         * Parses JSON response from Radio Browser API into a set of stations.
         *
         * @param stream The input stream containing JSON data to be parsed
         *
         * @return Set<Model.Station> A set of Station objects parsed from the JSON
         *
         * @throws Error If there is an error parsing the JSON or processing the data
         */
static GeeSet*
tuner_data_provider_radio_browser_parse_json_response (TunerDataProviderRadioBrowser* self,
                                                       GInputStream* stream,
                                                       GError** error)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* rootnode = NULL;
	JsonNode* _tmp1_;
	JsonNode* _tmp2_;
	JsonArray* rootarray = NULL;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* _tmp6_;
	GeeSet* _tmp7_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (stream != NULL, NULL);
	_tmp0_ = json_parser_new_immutable ();
	parser = _tmp0_;
	json_parser_load_from_stream (parser, stream, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (parser);
		return NULL;
	}
	_tmp1_ = json_parser_get_root (parser);
	_tmp2_ = __vala_JsonNode_copy0 (_tmp1_);
	rootnode = _tmp2_;
	_tmp3_ = rootnode;
	_tmp4_ = json_node_get_array (_tmp3_);
	_tmp5_ = _json_array_ref0 (_tmp4_);
	rootarray = _tmp5_;
	_tmp6_ = rootarray;
	_tmp7_ = tuner_data_provider_radio_browser_jarray_to_stations (self, _tmp6_);
	result = _tmp7_;
	_json_array_unref0 (rootarray);
	__vala_JsonNode_free0 (rootnode);
	_g_object_unref0 (parser);
	return result;
}

/**
        * @brief Marshals JSON array data into an array of Station
        *
        * Not knowing what the produce did, allow null data
        *
        * @param data JSON array containing station data
        * @return ArrayList of Station objects
        */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		TunerDataProviderRadioBrowser* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->stations);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
___lambda101_ (Block4Data* _data4_,
               JsonArray* array,
               guint index,
               JsonNode* element)
{
	TunerDataProviderRadioBrowser* self;
	TunerModelStation* s = NULL;
	TunerModelStation* _tmp0_;
	GeeHashSet* _tmp1_;
	self = _data4_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (element != NULL);
	_tmp0_ = tuner_model_station_make (element);
	s = _tmp0_;
	_tmp1_ = _data4_->stations;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, s);
	_g_object_unref0 (s);
}

static void
____lambda101__json_array_foreach (JsonArray* array,
                                   guint index_,
                                   JsonNode* element_node,
                                   gpointer self)
{
	___lambda101_ (self, array, index_, element_node);
}

static GeeSet*
tuner_data_provider_radio_browser_jarray_to_stations (TunerDataProviderRadioBrowser* self,
                                                      JsonArray* data)
{
	Block4Data* _data4_;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_data4_->stations = _tmp0_;
	if (data != NULL) {
		json_array_foreach_element (data, ____lambda101__json_array_foreach, _data4_);
	}
	_tmp1_ = _data4_->stations;
	_tmp2_ = _g_object_ref0 ((GeeSet*) _tmp1_);
	result = _tmp2_;
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return result;
}

/**
        * @brief Converts a JSON node to a Tag object
        *
        * @param node JSON node representing a tag
        * @return Tag object
        */
static TunerDataProviderTag*
tuner_data_provider_radio_browser_jnode_to_tag (TunerDataProviderRadioBrowser* self,
                                                JsonNode* node)
{
	GObject* _tmp0_;
	TunerDataProviderTag* _tmp1_;
	TunerDataProviderTag* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_tmp0_ = json_gobject_deserialize (TUNER_DATA_PROVIDER_TYPE_TAG, node);
	_tmp1_ = TUNER_DATA_PROVIDER_IS_TAG (_tmp0_) ? ((TunerDataProviderTag*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	result = _tmp1_;
	return result;
}

/**
        * @brief Marshals JSON tag data into an array of Tag
        *
        * Not knowing what the produce did, allow null data
        *
        * @param data JSON array containing tag data
        * @return ArrayList of Tag objects
        */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		TunerDataProviderRadioBrowser* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->tags);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
___lambda100_ (Block5Data* _data5_,
               JsonArray* array,
               guint index,
               JsonNode* element)
{
	TunerDataProviderRadioBrowser* self;
	TunerDataProviderTag* s = NULL;
	TunerDataProviderTag* _tmp0_;
	GeeHashSet* _tmp1_;
	self = _data5_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (element != NULL);
	_tmp0_ = tuner_data_provider_radio_browser_jnode_to_tag (self, element);
	s = _tmp0_;
	_tmp1_ = _data5_->tags;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, s);
	_g_object_unref0 (s);
}

static void
____lambda100__json_array_foreach (JsonArray* array,
                                   guint index_,
                                   JsonNode* element_node,
                                   gpointer self)
{
	___lambda100_ (self, array, index_, element_node);
}

static GeeSet*
tuner_data_provider_radio_browser_jarray_to_tags (TunerDataProviderRadioBrowser* self,
                                                  JsonArray* data)
{
	Block5Data* _data5_;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = gee_hash_set_new (TUNER_DATA_PROVIDER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_data5_->tags = _tmp0_;
	if (data != NULL) {
		json_array_foreach_element (data, ____lambda100__json_array_foreach, _data5_);
	}
	_tmp1_ = _data5_->tags;
	_tmp2_ = _g_object_ref0 ((GeeSet*) _tmp1_);
	result = _tmp2_;
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return result;
}

/**
         * @brief Get all radio-browser.info API servers
         * 
         * Gets server list from Radio Browser DNS SRV record, 
         * and failing that, from the API
         *
         * @since 1.5.4
         * @return ArrayList of strings containing the resolved hostnames
         * @throw DataError if unable to resolve DNS records
         */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		TunerDataProviderRadioBrowser* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->results);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static GSrvTarget*
_vala_GSrvTarget_copy (GSrvTarget* self)
{
	return g_boxed_copy (g_srv_target_get_type (), self);
}

static gpointer
__vala_GSrvTarget_copy0 (gpointer self)
{
	return self ? _vala_GSrvTarget_copy (self) : NULL;
}

static void
_vala_GSrvTarget_free (GSrvTarget* self)
{
	g_boxed_free (g_srv_target_get_type (), self);
}

static void
__vala_GSrvTarget_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GSrvTarget_free (var), NULL));
}

static inline void
_g_list_free___vala_GSrvTarget_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GSrvTarget_free0_);
}

static void
______lambda99_ (Block6Data* _data6_,
                 JsonArray* array,
                 guint index_,
                 JsonNode* element_node)
{
	TunerDataProviderRadioBrowser* self;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonObject* _tmp2_;
	self = _data6_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (element_node != NULL);
	_tmp0_ = json_node_get_object (element_node);
	_tmp1_ = _json_object_ref0 (_tmp0_);
	object = _tmp1_;
	_tmp2_ = object;
	if (_tmp2_ != NULL) {
		gchar* name = NULL;
		JsonObject* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
		_tmp3_ = object;
		_tmp4_ = json_object_get_string_member (_tmp3_, "name");
		_tmp5_ = g_strdup (_tmp4_);
		name = _tmp5_;
		_tmp7_ = name;
		if (_tmp7_ != NULL) {
			GeeArrayList* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = _data6_->results;
			_tmp9_ = name;
			_tmp6_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			GeeArrayList* _tmp10_;
			const gchar* _tmp11_;
			_tmp10_ = _data6_->results;
			_tmp11_ = name;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
		}
		_g_free0 (name);
	}
	_json_object_unref0 (object);
}

static void
_______lambda99__json_array_foreach (JsonArray* array,
                                     guint index_,
                                     JsonNode* element_node,
                                     gpointer self)
{
	______lambda99_ (self, array, index_, element_node);
}

static GeeArrayList*
tuner_data_provider_radio_browser_get_srv_api_servers (TunerDataProviderRadioBrowser* self,
                                                       GError** error)
{
	Block6Data* _data6_;
	GeeArrayList* _tmp0_;
	TunerApplication* _tmp1_;
	TunerApplication* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GeeArrayList* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GeeArrayList* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	GeeArrayList* _tmp63_;
	GeeArrayList* _tmp64_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_data6_->results = _tmp0_;
	_tmp1_ = tuner_app ();
	_tmp2_ = _tmp1_;
	_tmp3_ = tuner_application_get_is_offline (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp2_);
	if (_tmp5_) {
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		_tmp6_ = _data6_->results;
		_tmp7_ = _g_object_ref0 (_tmp6_);
		result = _tmp7_;
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return result;
	}
	{
		GList* srv_targets = NULL;
		GResolver* _tmp8_;
		GResolver* _tmp9_;
		GList* _tmp10_;
		GList* _tmp11_;
		GList* _tmp12_;
		_tmp8_ = g_resolver_get_default ();
		_tmp9_ = _tmp8_;
		_tmp10_ = g_resolver_lookup_service (_tmp9_, TUNER_DATA_PROVIDER_SRV_SERVICE, TUNER_DATA_PROVIDER_SRV_PROTOCOL, TUNER_DATA_PROVIDER_SRV_DOMAIN, NULL, &_inner_error0_);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp9_);
		srv_targets = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp12_ = srv_targets;
		{
			GList* target_collection = NULL;
			GList* target_it = NULL;
			target_collection = _tmp12_;
			for (target_it = target_collection; target_it != NULL; target_it = target_it->next) {
				GSrvTarget* _tmp13_;
				GSrvTarget* target = NULL;
				_tmp13_ = __vala_GSrvTarget_copy0 ((GSrvTarget*) target_it->data);
				target = _tmp13_;
				{
					GeeArrayList* _tmp14_;
					GSrvTarget* _tmp15_;
					const gchar* _tmp16_;
					_tmp14_ = _data6_->results;
					_tmp15_ = target;
					_tmp16_ = g_srv_target_get_hostname (_tmp15_);
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp16_);
					__vala_GSrvTarget_free0 (target);
				}
			}
		}
		(srv_targets == NULL) ? NULL : (srv_targets = (_g_list_free___vala_GSrvTarget_free0_ (srv_targets), NULL));
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		_tmp19_ = string_to_string (_tmp18_);
		_tmp20_ = g_strconcat ("Unable to resolve Radio-Browser SRV records: ", _tmp19_, NULL);
		_tmp21_ = _tmp20_;
		g_warning ("RadioBrowser.vala:636: %s", _tmp21_);
		_g_free0 (_tmp21_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
			g_propagate_error (error, _inner_error0_);
			block6_data_unref (_data6_);
			_data6_ = NULL;
			return NULL;
		} else {
			block6_data_unref (_data6_);
			_data6_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp22_ = _data6_->results;
	_tmp23_ = gee_collection_get_is_empty ((GeeCollection*) _tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_) {
		{
			guint status_code = 0U;
			GInputStream* stream = NULL;
			const gchar* _tmp25_;
			GUri* _tmp26_;
			GUri* _tmp27_;
			guint _tmp28_ = 0U;
			GInputStream* _tmp29_;
			GInputStream* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			_tmp25_ = string_to_string (TUNER_DATA_PROVIDER_RBI_SERVERS);
			_tmp26_ = tuner_data_provider_radio_browser_build_uri (self, _tmp25_, "");
			_tmp27_ = _tmp26_;
			_tmp29_ = tuner_http_client_GET (_tmp27_, &_tmp28_);
			status_code = _tmp28_;
			_tmp30_ = _tmp29_;
			_g_uri_unref0 (_tmp27_);
			stream = _tmp30_;
			_tmp31_ = self->priv->_current_server;
			_tmp32_ = string_to_string (_tmp31_);
			_tmp33_ = string_to_string (TUNER_DATA_PROVIDER_RBI_SERVERS);
			_tmp34_ = g_strdup_printf ("%u", status_code);
			_tmp35_ = _tmp34_;
			_tmp36_ = g_strconcat ("response from ", _tmp32_, _tmp33_, ": ", _tmp35_, NULL);
			_tmp37_ = _tmp36_;
			g_debug ("RadioBrowser.vala:649: %s", _tmp37_);
			_g_free0 (_tmp37_);
			_g_free0 (_tmp35_);
			if (status_code == ((guint) 200)) {
				JsonNode* root_node = NULL;
				gboolean _tmp51_ = FALSE;
				JsonNode* _tmp52_;
				{
					JsonParser* parser = NULL;
					JsonParser* _tmp38_;
					JsonParser* _tmp39_;
					GInputStream* _tmp40_;
					JsonParser* _tmp41_;
					JsonNode* _tmp42_;
					JsonNode* _tmp43_;
					_tmp38_ = json_parser_new ();
					parser = _tmp38_;
					_tmp39_ = parser;
					_tmp40_ = stream;
					json_parser_load_from_stream (_tmp39_, _tmp40_, NULL, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (parser);
						goto __catch2_g_error;
					}
					_tmp41_ = parser;
					_tmp42_ = json_parser_get_root (_tmp41_);
					_tmp43_ = __vala_JsonNode_copy0 (_tmp42_);
					__vala_JsonNode_free0 (root_node);
					root_node = _tmp43_;
					_g_object_unref0 (parser);
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* e = NULL;
					GError* _tmp44_;
					const gchar* _tmp45_;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					GError* _tmp49_;
					GError* _tmp50_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp44_ = e;
					_tmp45_ = _tmp44_->message;
					_tmp46_ = string_to_string (_tmp45_);
					_tmp47_ = g_strconcat ("RBI API get servers - unable to parse JSON response: ", _tmp46_, NULL);
					_tmp48_ = _tmp47_;
					_tmp49_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA, _tmp48_);
					_tmp50_ = _tmp49_;
					_g_free0 (_tmp48_);
					_inner_error0_ = _tmp50_;
					_g_error_free0 (e);
					goto __finally2;
				}
				__finally2:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					__vala_JsonNode_free0 (root_node);
					_g_object_unref0 (stream);
					goto __catch1_g_error;
				}
				_tmp52_ = root_node;
				if (_tmp52_ != NULL) {
					JsonNode* _tmp53_;
					_tmp53_ = root_node;
					_tmp51_ = json_node_get_node_type (_tmp53_) == JSON_NODE_ARRAY;
				} else {
					_tmp51_ = FALSE;
				}
				if (_tmp51_) {
					JsonNode* _tmp54_;
					JsonArray* _tmp55_;
					_tmp54_ = root_node;
					_tmp55_ = json_node_get_array (_tmp54_);
					json_array_foreach_element (_tmp55_, _______lambda99__json_array_foreach, _data6_);
				}
				__vala_JsonNode_free0 (root_node);
			}
			_g_object_unref0 (stream);
		}
		goto __finally1;
		__catch1_g_error:
		{
			g_clear_error (&_inner_error0_);
			g_warning ("RadioBrowser.vala:675: Failed to parse RBI APIs JSON response: $(e.mes" \
"sage)");
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
				g_propagate_error (error, _inner_error0_);
				block6_data_unref (_data6_);
				_data6_ = NULL;
				return NULL;
			} else {
				block6_data_unref (_data6_);
				_data6_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp56_ = _data6_->results;
	_tmp57_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp56_);
	_tmp58_ = _tmp57_;
	_tmp59_ = g_strdup_printf ("%i", _tmp58_);
	_tmp60_ = _tmp59_;
	_tmp61_ = g_strconcat ("Results ", _tmp60_, NULL);
	_tmp62_ = _tmp61_;
	g_debug ("RadioBrowser.vala:679: %s", _tmp62_);
	_g_free0 (_tmp62_);
	_g_free0 (_tmp60_);
	_tmp63_ = _data6_->results;
	_tmp64_ = _g_object_ref0 (_tmp63_);
	result = _tmp64_;
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}

/**
        * Encodes a text string for use in RadioBrowser API requests.
        *
        * This method ensures that the text is properly encoded for use in URLs
        * by converting special characters into their URL-safe equivalents.
        *
        * @param tag The text string to be encoded
        * @return A URL-encoded string representation of the input text
        */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
tuner_data_provider_radio_browser_encode_text (const gchar* tag)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar** x = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gint x_length1;
	gint x_length2;
	gchar* result;
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp0_ = g_strdup (tag);
	output = _tmp0_;
	_tmp1_ = g_strdup ("%");
	_tmp2_ = g_strdup ("%25");
	_tmp3_ = g_strdup (":");
	_tmp4_ = g_strdup ("%3B");
	_tmp5_ = g_strdup ("/");
	_tmp6_ = g_strdup ("%2F");
	_tmp7_ = g_strdup ("#");
	_tmp8_ = g_strdup ("%23");
	_tmp9_ = g_strdup ("?");
	_tmp10_ = g_strdup ("%3F");
	_tmp11_ = g_strdup ("&");
	_tmp12_ = g_strdup ("%26");
	_tmp13_ = g_strdup ("@");
	_tmp14_ = g_strdup ("%40");
	_tmp15_ = g_strdup ("+");
	_tmp16_ = g_strdup ("%2B");
	_tmp17_ = g_strdup (" ");
	_tmp18_ = g_strdup ("%20");
	_tmp19_ = g_new0 (gchar*, (9 * 2) + 1);
	_tmp19_[0] = _tmp1_;
	_tmp19_[1] = _tmp2_;
	_tmp19_[2] = _tmp3_;
	_tmp19_[3] = _tmp4_;
	_tmp19_[4] = _tmp5_;
	_tmp19_[5] = _tmp6_;
	_tmp19_[6] = _tmp7_;
	_tmp19_[7] = _tmp8_;
	_tmp19_[8] = _tmp9_;
	_tmp19_[9] = _tmp10_;
	_tmp19_[10] = _tmp11_;
	_tmp19_[11] = _tmp12_;
	_tmp19_[12] = _tmp13_;
	_tmp19_[13] = _tmp14_;
	_tmp19_[14] = _tmp15_;
	_tmp19_[15] = _tmp16_;
	_tmp19_[16] = _tmp17_;
	_tmp19_[17] = _tmp18_;
	x = _tmp19_;
	x_length1 = 9;
	x_length2 = 2;
	{
		gint a = 0;
		a = 0;
		{
			gboolean _tmp20_ = FALSE;
			_tmp20_ = TRUE;
			while (TRUE) {
				const gchar* _tmp22_;
				gchar** _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
				const gchar* _tmp24_;
				gchar** _tmp25_;
				gint _tmp25__length1;
				gint _tmp25__length2;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				if (!_tmp20_) {
					gint _tmp21_;
					_tmp21_ = a;
					a = _tmp21_ + 1;
				}
				_tmp20_ = FALSE;
				if (!(a < 9)) {
					break;
				}
				_tmp22_ = output;
				_tmp23_ = x;
				_tmp23__length1 = x_length1;
				_tmp23__length2 = x_length2;
				_tmp24_ = _tmp23_[(a * _tmp23__length2) + 0];
				_tmp25_ = x;
				_tmp25__length1 = x_length1;
				_tmp25__length2 = x_length2;
				_tmp26_ = _tmp25_[(a * _tmp25__length2) + 1];
				_tmp27_ = string_replace (_tmp22_, _tmp24_, _tmp26_);
				_g_free0 (output);
				output = _tmp27_;
			}
		}
	}
	result = output;
	x = (_vala_array_free (x, x_length1 * x_length2, (GDestroyNotify) g_free), NULL);
	return result;
}

static TunerDataProviderAPIStatus
tuner_data_provider_radio_browser_real_get_status (TunerDataProviderAPI* base)
{
	TunerDataProviderAPIStatus result;
	TunerDataProviderRadioBrowser* self;
	self = (TunerDataProviderRadioBrowser*) base;
	result = self->priv->_status;
	return result;
}

static void
tuner_data_provider_radio_browser_real_set_status (TunerDataProviderAPI* base,
                                                   TunerDataProviderAPIStatus value)
{
	TunerDataProviderRadioBrowser* self;
	TunerDataProviderAPIStatus old_value;
	self = (TunerDataProviderRadioBrowser*) base;
	old_value = tuner_data_provider_radio_browser_real_get_status (base);
	if (old_value != value) {
		self->priv->_status = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY]);
	}
}

static GError*
tuner_data_provider_radio_browser_real_get_last_data_error (TunerDataProviderAPI* base)
{
	GError* result;
	TunerDataProviderRadioBrowser* self;
	GError* _tmp0_;
	self = (TunerDataProviderRadioBrowser*) base;
	_tmp0_ = self->priv->_last_data_error;
	result = _tmp0_;
	return result;
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static void
tuner_data_provider_radio_browser_real_set_last_data_error (TunerDataProviderAPI* base,
                                                            GError* value)
{
	TunerDataProviderRadioBrowser* self;
	GError* old_value;
	self = (TunerDataProviderRadioBrowser*) base;
	old_value = tuner_data_provider_radio_browser_real_get_last_data_error (base);
	if (old_value != value) {
		GError* _tmp0_;
		_tmp0_ = _g_error_copy0 (value);
		_g_error_free0 (self->priv->_last_data_error);
		self->priv->_last_data_error = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY]);
	}
}

static void
tuner_data_provider_radio_browser_class_init (TunerDataProviderRadioBrowserClass * klass,
                                              gpointer klass_data)
{
	tuner_data_provider_radio_browser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerDataProviderRadioBrowser_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_data_provider_radio_browser_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_data_provider_radio_browser_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_data_provider_radio_browser_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", TUNER_DATA_PROVIDER_API_TYPE_STATUS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY] = g_param_spec_boxed ("last-data-error", "last-data-error", "last-data-error", G_TYPE_ERROR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
tuner_data_provider_radio_browser_tuner_data_provider_api_interface_init (TunerDataProviderAPIIface * iface,
                                                                          gpointer iface_data)
{
	tuner_data_provider_radio_browser_tuner_data_provider_api_parent_iface = g_type_interface_peek_parent (iface);
	iface->name = (gchar* (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_name;
	iface->available_stations = (gint (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_available_stations;
	iface->available_tags = (gint (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_available_tags;
	iface->initialize = (gboolean (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_initialize;
	iface->click = (void (*) (TunerDataProviderAPI*, const gchar*)) tuner_data_provider_radio_browser_real_click;
	iface->vote = (void (*) (TunerDataProviderAPI*, const gchar*)) tuner_data_provider_radio_browser_real_vote;
	iface->get_tags = (GeeSet* (*) (TunerDataProviderAPI*, gint, gint, GError**)) tuner_data_provider_radio_browser_real_get_tags;
	iface->by_uuid = (GeeSet* (*) (TunerDataProviderAPI*, const gchar*, GError**)) tuner_data_provider_radio_browser_real_by_uuid;
	iface->by_uuids = (GeeSet* (*) (TunerDataProviderAPI*, GeeCollection*, GError**)) tuner_data_provider_radio_browser_real_by_uuids;
	iface->search = (GeeSet* (*) (TunerDataProviderAPI*, TunerDataProviderSearchParams*, guint, guint, GError**)) tuner_data_provider_radio_browser_real_search;
	iface->search_async = (void (*) (TunerDataProviderAPI*, TunerDataProviderSearchParams*, guint, guint, GAsyncReadyCallback, gpointer)) tuner_data_provider_radio_browser_real_search_async;
	iface->search_finish = (GeeSet* (*) (TunerDataProviderAPI*, GAsyncResult*, GError**)) tuner_data_provider_radio_browser_search_finish;
	iface->get_status = tuner_data_provider_radio_browser_real_get_status;
	iface->set_status = tuner_data_provider_radio_browser_real_set_status;
	iface->get_last_data_error = tuner_data_provider_radio_browser_real_get_last_data_error;
	iface->set_last_data_error = tuner_data_provider_radio_browser_real_set_last_data_error;
}

static void
tuner_data_provider_radio_browser_instance_init (TunerDataProviderRadioBrowser * self,
                                                 gpointer klass)
{
	gchar* _tmp0_;
	self->priv = tuner_data_provider_radio_browser_get_instance_private (self);
	_tmp0_ = g_strdup (TUNER_DATA_PROVIDER_RBI_ALL_API);
	self->priv->_current_server = _tmp0_;
	self->priv->_degrade = TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL;
	self->priv->_available_stations = 1000;
	self->priv->_available_tags = 1000;
}

static void
tuner_data_provider_radio_browser_finalize (GObject * obj)
{
	TunerDataProviderRadioBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser);
	_g_free0 (self->priv->_optionalservers);
	_g_object_unref0 (self->priv->_servers);
	_g_free0 (self->priv->_current_server);
	_g_error_free0 (self->priv->_last_data_error);
	G_OBJECT_CLASS (tuner_data_provider_radio_browser_parent_class)->finalize (obj);
}

/**
     * A data provider implementation for the Radio Browser API.
     * 
     * RadioBrowser class implements the DataProvider.API interface to fetch
     * radio station data from the Radio Browser service.
     * 
     * See https://www.radio-browser.info/ for API details.
     */
static GType
tuner_data_provider_radio_browser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerDataProviderRadioBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_data_provider_radio_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerDataProviderRadioBrowser), 0, (GInstanceInitFunc) tuner_data_provider_radio_browser_instance_init, NULL };
	static const GInterfaceInfo tuner_data_provider_api_info = { (GInterfaceInitFunc) tuner_data_provider_radio_browser_tuner_data_provider_api_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType tuner_data_provider_radio_browser_type_id;
	tuner_data_provider_radio_browser_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerDataProviderRadioBrowser", &g_define_type_info, 0);
	g_type_add_interface_static (tuner_data_provider_radio_browser_type_id, TUNER_DATA_PROVIDER_TYPE_API, &tuner_data_provider_api_info);
	TunerDataProviderRadioBrowser_private_offset = g_type_add_instance_private (tuner_data_provider_radio_browser_type_id, sizeof (TunerDataProviderRadioBrowserPrivate));
	return tuner_data_provider_radio_browser_type_id;
}

GType
tuner_data_provider_radio_browser_get_type (void)
{
	static volatile gsize tuner_data_provider_radio_browser_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_radio_browser_type_id__once)) {
		GType tuner_data_provider_radio_browser_type_id;
		tuner_data_provider_radio_browser_type_id = tuner_data_provider_radio_browser_get_type_once ();
		g_once_init_leave (&tuner_data_provider_radio_browser_type_id__once, tuner_data_provider_radio_browser_type_id);
	}
	return tuner_data_provider_radio_browser_type_id__once;
}

static void
_vala_tuner_data_provider_radio_browser_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	TunerDataProviderRadioBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser);
	switch (property_id) {
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY:
		g_value_set_enum (value, tuner_data_provider_api_get_status ((TunerDataProviderAPI*) self));
		break;
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY:
		g_value_set_boxed (value, tuner_data_provider_api_get_last_data_error ((TunerDataProviderAPI*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_data_provider_radio_browser_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	TunerDataProviderRadioBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser);
	switch (property_id) {
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY:
		tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, g_value_get_enum (value));
		break;
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY:
		tuner_data_provider_api_set_last_data_error ((TunerDataProviderAPI*) self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

