/* DataProvider.c generated by valac 0.56.8, the Vala compiler
 * generated from DataProvider.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file DataProvider.vala
 * 
 * @author technosf
 * @date 2024-12-01
 * @since 2.0.0
 * @brief Interface to radio-browser.info API and servers
 * 
 */
/**
         * @brief Get a station or stations by Streaming URL  
         *
         * @param url streaming url the stations to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_DATA_PROVIDER_TYPE_SEARCH_PARAMS (tuner_data_provider_search_params_get_type ())
typedef struct _TunerDataProviderSearchParams TunerDataProviderSearchParams;
typedef enum  {
	TUNER_DATA_PROVIDER_SORT_ORDER_NAME,
	TUNER_DATA_PROVIDER_SORT_ORDER_URL,
	TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON,
	TUNER_DATA_PROVIDER_SORT_ORDER_TAGS,
	TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY,
	TUNER_DATA_PROVIDER_SORT_ORDER_STATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_VOTES,
	TUNER_DATA_PROVIDER_SORT_ORDER_CODEC,
	TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND,
	TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM
} TunerDataProviderSortOrder;

#define TUNER_DATA_PROVIDER_TYPE_SORT_ORDER (tuner_data_provider_sort_order_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_DATA_PROVIDER_TYPE_DATA_ERROR (tuner_data_provider_data_error_get_type ())

#define TUNER_DATA_PROVIDER_TYPE_TAG (tuner_data_provider_tag_get_type ())
#define TUNER_DATA_PROVIDER_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag))
#define TUNER_DATA_PROVIDER_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))
#define TUNER_DATA_PROVIDER_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))

typedef struct _TunerDataProviderTag TunerDataProviderTag;
typedef struct _TunerDataProviderTagClass TunerDataProviderTagClass;
typedef struct _TunerDataProviderTagPrivate TunerDataProviderTagPrivate;
enum  {
	TUNER_DATA_PROVIDER_TAG_0_PROPERTY,
	TUNER_DATA_PROVIDER_TAG_NAME_PROPERTY,
	TUNER_DATA_PROVIDER_TAG_STATIONCOUNT_PROPERTY,
	TUNER_DATA_PROVIDER_TAG_NUM_PROPERTIES
};
static GParamSpec* tuner_data_provider_tag_properties[TUNER_DATA_PROVIDER_TAG_NUM_PROPERTIES];

#define TUNER_DATA_PROVIDER_TYPE_API (tuner_data_provider_api_get_type ())
#define TUNER_DATA_PROVIDER_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPI))
#define TUNER_DATA_PROVIDER_IS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_API))
#define TUNER_DATA_PROVIDER_API_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPIIface))

typedef struct _TunerDataProviderAPI TunerDataProviderAPI;
typedef struct _TunerDataProviderAPIIface TunerDataProviderAPIIface;

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
typedef enum  {
	TUNER_DATA_PROVIDER_API_STATUS_OK,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED,
	TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE,
	TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR
} TunerDataProviderAPIStatus;

#define TUNER_DATA_PROVIDER_API_TYPE_STATUS (tuner_data_provider_api_status_get_type ())

struct _TunerDataProviderSearchParams {
	gchar* text;
	GeeSet* tags;
	GeeSet* uuids;
	gchar* countrycode;
	TunerDataProviderSortOrder order;
	gboolean reverse;
};

/**
     * @brief Error domain for DataProvider-related errors
     * 
     */
typedef enum  {
	TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA,
	TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION
} TunerDataProviderDataError;
#define TUNER_DATA_PROVIDER_DATA_ERROR tuner_data_provider_data_error_quark ()

struct _TunerDataProviderTag {
	GObject parent_instance;
	TunerDataProviderTagPrivate * priv;
};

struct _TunerDataProviderTagClass {
	GObjectClass parent_class;
};

struct _TunerDataProviderTagPrivate {
	gchar* _name;
	guint _stationcount;
};

struct _TunerDataProviderAPIIface {
	GTypeInterface parent_iface;
	void (*clear_last_error) (TunerDataProviderAPI* self);
	gchar* (*name) (TunerDataProviderAPI* self);
	gint (*available_stations) (TunerDataProviderAPI* self);
	gint (*available_tags) (TunerDataProviderAPI* self);
	gboolean (*initialize) (TunerDataProviderAPI* self);
	void (*click) (TunerDataProviderAPI* self, const gchar* stationuuid);
	void (*vote) (TunerDataProviderAPI* self, const gchar* stationuuid);
	GeeSet* (*get_tags) (TunerDataProviderAPI* self, gint offset, gint limit, GError** error);
	GeeSet* (*by_uuid) (TunerDataProviderAPI* self, const gchar* uuids, GError** error);
	GeeSet* (*by_uuids) (TunerDataProviderAPI* self, GeeCollection* uuids, GError** error);
	GeeSet* (*search) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GError** error);
	void (*search_async) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeSet* (*search_finish) (TunerDataProviderAPI* self, GAsyncResult* _res_, GError** error);
	GError* (*get_last_data_error) (TunerDataProviderAPI* self);
	void (*set_last_data_error) (TunerDataProviderAPI* self, GError* value);
	TunerDataProviderAPIStatus (*get_status) (TunerDataProviderAPI* self);
	void (*set_status) (TunerDataProviderAPI* self, TunerDataProviderAPIStatus value);
};

static gint TunerDataProviderTag_private_offset;
static gpointer tuner_data_provider_tag_parent_class = NULL;

VALA_EXTERN GType tuner_data_provider_search_params_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_sort_order_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TunerDataProviderSearchParams* tuner_data_provider_search_params_dup (const TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_free (TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_copy (const TunerDataProviderSearchParams* self,
                                             TunerDataProviderSearchParams* dest);
VALA_EXTERN void tuner_data_provider_search_params_destroy (TunerDataProviderSearchParams* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TunerDataProviderSearchParams, tuner_data_provider_search_params_destroy)
VALA_EXTERN GQuark tuner_data_provider_data_error_quark (void);
GType tuner_data_provider_data_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* tuner_data_provider_sort_order_to_string (TunerDataProviderSortOrder self);
VALA_EXTERN GType tuner_data_provider_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderTag, g_object_unref)
VALA_EXTERN TunerDataProviderTag* tuner_data_provider_tag_new (void);
VALA_EXTERN TunerDataProviderTag* tuner_data_provider_tag_construct (GType object_type);
VALA_EXTERN const gchar* tuner_data_provider_tag_get_name (TunerDataProviderTag* self);
VALA_EXTERN void tuner_data_provider_tag_set_name (TunerDataProviderTag* self,
                                       const gchar* value);
VALA_EXTERN guint tuner_data_provider_tag_get_stationcount (TunerDataProviderTag* self);
VALA_EXTERN void tuner_data_provider_tag_set_stationcount (TunerDataProviderTag* self,
                                               guint value);
static void tuner_data_provider_tag_finalize (GObject * obj);
static GType tuner_data_provider_tag_get_type_once (void);
static void _vala_tuner_data_provider_tag_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_tuner_data_provider_tag_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_data_provider_api_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_api_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderAPI, g_object_unref)
VALA_EXTERN void tuner_data_provider_api_clear_last_error (TunerDataProviderAPI* self);
static void tuner_data_provider_api_real_clear_last_error (TunerDataProviderAPI* self);
VALA_EXTERN void tuner_data_provider_api_set_last_data_error (TunerDataProviderAPI* self,
                                                  GError* value);
VALA_EXTERN gchar* tuner_data_provider_api_name (TunerDataProviderAPI* self);
VALA_EXTERN gint tuner_data_provider_api_available_stations (TunerDataProviderAPI* self);
VALA_EXTERN gint tuner_data_provider_api_available_tags (TunerDataProviderAPI* self);
VALA_EXTERN gboolean tuner_data_provider_api_initialize (TunerDataProviderAPI* self);
VALA_EXTERN void tuner_data_provider_api_click (TunerDataProviderAPI* self,
                                    const gchar* stationuuid);
VALA_EXTERN void tuner_data_provider_api_vote (TunerDataProviderAPI* self,
                                   const gchar* stationuuid);
VALA_EXTERN GeeSet* tuner_data_provider_api_get_tags (TunerDataProviderAPI* self,
                                          gint offset,
                                          gint limit,
                                          GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuid (TunerDataProviderAPI* self,
                                         const gchar* uuids,
                                         GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuids (TunerDataProviderAPI* self,
                                          GeeCollection* uuids,
                                          GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_search (TunerDataProviderAPI* self,
                                        TunerDataProviderSearchParams* params,
                                        guint rowcount,
                                        guint offset,
                                        GError** error);
VALA_EXTERN void tuner_data_provider_api_search_async (TunerDataProviderAPI* self,
                                           TunerDataProviderSearchParams* params,
                                           guint rowcount,
                                           guint offset,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN GeeSet* tuner_data_provider_api_search_finish (TunerDataProviderAPI* self,
                                               GAsyncResult* _res_,
                                               GError** error);
VALA_EXTERN GError* tuner_data_provider_api_get_last_data_error (TunerDataProviderAPI* self);
VALA_EXTERN TunerDataProviderAPIStatus tuner_data_provider_api_get_status (TunerDataProviderAPI* self);
VALA_EXTERN void tuner_data_provider_api_set_status (TunerDataProviderAPI* self,
                                         TunerDataProviderAPIStatus value);
static GType tuner_data_provider_api_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_data_provider_search_params_copy (const TunerDataProviderSearchParams* self,
                                        TunerDataProviderSearchParams* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	_tmp0_ = (*self).text;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).text);
	(*dest).text = _tmp1_;
	_tmp2_ = (*self).tags;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 ((*dest).tags);
	(*dest).tags = _tmp3_;
	_tmp4_ = (*self).uuids;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 ((*dest).uuids);
	(*dest).uuids = _tmp5_;
	_tmp6_ = (*self).countrycode;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).countrycode);
	(*dest).countrycode = _tmp7_;
	(*dest).order = (*self).order;
	(*dest).reverse = (*self).reverse;
}

void
tuner_data_provider_search_params_destroy (TunerDataProviderSearchParams* self)
{
	_g_free0 ((*self).text);
	_g_object_unref0 ((*self).tags);
	_g_object_unref0 ((*self).uuids);
	_g_free0 ((*self).countrycode);
}

TunerDataProviderSearchParams*
tuner_data_provider_search_params_dup (const TunerDataProviderSearchParams* self)
{
	TunerDataProviderSearchParams* dup;
	dup = g_new0 (TunerDataProviderSearchParams, 1);
	tuner_data_provider_search_params_copy (self, dup);
	return dup;
}

void
tuner_data_provider_search_params_free (TunerDataProviderSearchParams* self)
{
	tuner_data_provider_search_params_destroy (self);
	g_free (self);
}

static GType
tuner_data_provider_search_params_get_type_once (void)
{
	GType tuner_data_provider_search_params_type_id;
	tuner_data_provider_search_params_type_id = g_boxed_type_register_static ("TunerDataProviderSearchParams", (GBoxedCopyFunc) tuner_data_provider_search_params_dup, (GBoxedFreeFunc) tuner_data_provider_search_params_free);
	return tuner_data_provider_search_params_type_id;
}

GType
tuner_data_provider_search_params_get_type (void)
{
	static volatile gsize tuner_data_provider_search_params_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_search_params_type_id__once)) {
		GType tuner_data_provider_search_params_type_id;
		tuner_data_provider_search_params_type_id = tuner_data_provider_search_params_get_type_once ();
		g_once_init_leave (&tuner_data_provider_search_params_type_id__once, tuner_data_provider_search_params_type_id);
	}
	return tuner_data_provider_search_params_type_id__once;
}

GQuark
tuner_data_provider_data_error_quark (void)
{
	return g_quark_from_static_string ("tuner-data-provider-data-error-quark");
}

static GType
tuner_data_provider_data_error_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA, "TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA", "parse-data"}, {TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION, "TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION", "no-connection"}, {0, NULL, NULL}};
	GType tuner_data_provider_data_error_type_id;
	tuner_data_provider_data_error_type_id = g_enum_register_static ("TunerDataProviderDataError", values);
	return tuner_data_provider_data_error_type_id;
}

GType
tuner_data_provider_data_error_get_type (void)
{
	static volatile gsize tuner_data_provider_data_error_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_data_error_type_id__once)) {
		GType tuner_data_provider_data_error_type_id;
		tuner_data_provider_data_error_type_id = tuner_data_provider_data_error_get_type_once ();
		g_once_init_leave (&tuner_data_provider_data_error_type_id__once, tuner_data_provider_data_error_type_id);
	}
	return tuner_data_provider_data_error_type_id__once;
}

/**
     * @enum SortOrder
     * @brief Enumeration of sorting options for station search results
     * 
     */
/**
         * @brief Convert SortOrder enum to string representation
         *
         * @return String representation of the SortOrder
         */
gchar*
tuner_data_provider_sort_order_to_string (TunerDataProviderSortOrder self)
{
	gchar* result;
	switch (self) {
		case TUNER_DATA_PROVIDER_SORT_ORDER_NAME:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("name");
			result = _tmp0_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_URL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("url");
			result = _tmp1_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("homepage");
			result = _tmp2_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("favicon");
			result = _tmp3_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_TAGS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("tags");
			result = _tmp4_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("country");
			result = _tmp5_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_STATE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("state");
			result = _tmp6_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("language");
			result = _tmp7_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_VOTES:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("votes");
			result = _tmp8_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_CODEC:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("codec");
			result = _tmp9_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup ("bitrate");
			result = _tmp10_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup ("lastcheckok");
			result = _tmp11_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME:
		{
			gchar* _tmp12_;
			_tmp12_ = g_strdup ("lastchecktime");
			result = _tmp12_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP:
		{
			gchar* _tmp13_;
			_tmp13_ = g_strdup ("clicktimestamp");
			result = _tmp13_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT:
		{
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("clickcount");
			result = _tmp14_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND:
		{
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("clicktrend");
			result = _tmp15_;
			return result;
		}
		case TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM:
		{
			gchar* _tmp16_;
			_tmp16_ = g_strdup ("random");
			result = _tmp16_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
tuner_data_provider_sort_order_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_DATA_PROVIDER_SORT_ORDER_NAME, "TUNER_DATA_PROVIDER_SORT_ORDER_NAME", "name"}, {TUNER_DATA_PROVIDER_SORT_ORDER_URL, "TUNER_DATA_PROVIDER_SORT_ORDER_URL", "url"}, {TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE, "TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE", "homepage"}, {TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON, "TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON", "favicon"}, {TUNER_DATA_PROVIDER_SORT_ORDER_TAGS, "TUNER_DATA_PROVIDER_SORT_ORDER_TAGS", "tags"}, {TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY, "TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY", "country"}, {TUNER_DATA_PROVIDER_SORT_ORDER_STATE, "TUNER_DATA_PROVIDER_SORT_ORDER_STATE", "state"}, {TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE, "TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE", "language"}, {TUNER_DATA_PROVIDER_SORT_ORDER_VOTES, "TUNER_DATA_PROVIDER_SORT_ORDER_VOTES", "votes"}, {TUNER_DATA_PROVIDER_SORT_ORDER_CODEC, "TUNER_DATA_PROVIDER_SORT_ORDER_CODEC", "codec"}, {TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE, "TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE", "bitrate"}, {TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK, "TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK", "lastcheckok"}, {TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME, "TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME", "lastchecktime"}, {TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP, "TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP", "clicktimestamp"}, {TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT, "TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT", "clickcount"}, {TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND, "TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND", "clicktrend"}, {TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM, "TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM", "random"}, {0, NULL, NULL}};
	GType tuner_data_provider_sort_order_type_id;
	tuner_data_provider_sort_order_type_id = g_enum_register_static ("TunerDataProviderSortOrder", values);
	return tuner_data_provider_sort_order_type_id;
}

GType
tuner_data_provider_sort_order_get_type (void)
{
	static volatile gsize tuner_data_provider_sort_order_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_sort_order_type_id__once)) {
		GType tuner_data_provider_sort_order_type_id;
		tuner_data_provider_sort_order_type_id = tuner_data_provider_sort_order_get_type_once ();
		g_once_init_leave (&tuner_data_provider_sort_order_type_id__once, tuner_data_provider_sort_order_type_id);
	}
	return tuner_data_provider_sort_order_type_id__once;
}

static inline gpointer
tuner_data_provider_tag_get_instance_private (TunerDataProviderTag* self)
{
	return G_STRUCT_MEMBER_P (self, TunerDataProviderTag_private_offset);
}

TunerDataProviderTag*
tuner_data_provider_tag_construct (GType object_type)
{
	TunerDataProviderTag * self = NULL;
	self = (TunerDataProviderTag*) g_object_new (object_type, NULL);
	return self;
}

TunerDataProviderTag*
tuner_data_provider_tag_new (void)
{
	return tuner_data_provider_tag_construct (TUNER_DATA_PROVIDER_TYPE_TAG);
}

const gchar*
tuner_data_provider_tag_get_name (TunerDataProviderTag* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
tuner_data_provider_tag_set_name (TunerDataProviderTag* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_data_provider_tag_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_data_provider_tag_properties[TUNER_DATA_PROVIDER_TAG_NAME_PROPERTY]);
	}
}

guint
tuner_data_provider_tag_get_stationcount (TunerDataProviderTag* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_stationcount;
	return result;
}

void
tuner_data_provider_tag_set_stationcount (TunerDataProviderTag* self,
                                          guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_data_provider_tag_get_stationcount (self);
	if (old_value != value) {
		self->priv->_stationcount = value;
		g_object_notify_by_pspec ((GObject *) self, tuner_data_provider_tag_properties[TUNER_DATA_PROVIDER_TAG_STATIONCOUNT_PROPERTY]);
	}
}

static void
tuner_data_provider_tag_class_init (TunerDataProviderTagClass * klass,
                                    gpointer klass_data)
{
	tuner_data_provider_tag_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerDataProviderTag_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_data_provider_tag_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_data_provider_tag_set_property;
	G_OBJECT_CLASS (klass)->finalize = tuner_data_provider_tag_finalize;
	/** @brief The tag name */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DATA_PROVIDER_TAG_NAME_PROPERTY, tuner_data_provider_tag_properties[TUNER_DATA_PROVIDER_TAG_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** @brief Number of stations using this tag */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DATA_PROVIDER_TAG_STATIONCOUNT_PROPERTY, tuner_data_provider_tag_properties[TUNER_DATA_PROVIDER_TAG_STATIONCOUNT_PROPERTY] = g_param_spec_uint ("stationcount", "stationcount", "stationcount", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
tuner_data_provider_tag_instance_init (TunerDataProviderTag * self,
                                       gpointer klass)
{
	self->priv = tuner_data_provider_tag_get_instance_private (self);
}

static void
tuner_data_provider_tag_finalize (GObject * obj)
{
	TunerDataProviderTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag);
	_g_free0 (self->priv->_name);
	G_OBJECT_CLASS (tuner_data_provider_tag_parent_class)->finalize (obj);
}

/**
     * @class Tag
     *
     * @brief Represents a radio station tag with usage statistics
     * 
     * Encapsulates metadata about a tag used to categorize radio stations,
     * including its name and the number of stations using it.
     */
static GType
tuner_data_provider_tag_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerDataProviderTagClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_data_provider_tag_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerDataProviderTag), 0, (GInstanceInitFunc) tuner_data_provider_tag_instance_init, NULL };
	GType tuner_data_provider_tag_type_id;
	tuner_data_provider_tag_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerDataProviderTag", &g_define_type_info, 0);
	TunerDataProviderTag_private_offset = g_type_add_instance_private (tuner_data_provider_tag_type_id, sizeof (TunerDataProviderTagPrivate));
	return tuner_data_provider_tag_type_id;
}

GType
tuner_data_provider_tag_get_type (void)
{
	static volatile gsize tuner_data_provider_tag_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_tag_type_id__once)) {
		GType tuner_data_provider_tag_type_id;
		tuner_data_provider_tag_type_id = tuner_data_provider_tag_get_type_once ();
		g_once_init_leave (&tuner_data_provider_tag_type_id__once, tuner_data_provider_tag_type_id);
	}
	return tuner_data_provider_tag_type_id__once;
}

static void
_vala_tuner_data_provider_tag_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TunerDataProviderTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag);
	switch (property_id) {
		case TUNER_DATA_PROVIDER_TAG_NAME_PROPERTY:
		g_value_set_string (value, tuner_data_provider_tag_get_name (self));
		break;
		case TUNER_DATA_PROVIDER_TAG_STATIONCOUNT_PROPERTY:
		g_value_set_uint (value, tuner_data_provider_tag_get_stationcount (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_data_provider_tag_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TunerDataProviderTag * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag);
	switch (property_id) {
		case TUNER_DATA_PROVIDER_TAG_NAME_PROPERTY:
		tuner_data_provider_tag_set_name (self, g_value_get_string (value));
		break;
		case TUNER_DATA_PROVIDER_TAG_STATIONCOUNT_PROPERTY:
		tuner_data_provider_tag_set_stationcount (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

/**
         * @brief DataProvider status
         *
         */
static GType
tuner_data_provider_api_status_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_DATA_PROVIDER_API_STATUS_OK, "TUNER_DATA_PROVIDER_API_STATUS_OK", "ok"}, {TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST, "TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST", "no-server-list"}, {TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED, "TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED", "no-servers-presented"}, {TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE, "TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE", "not-available"}, {TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR, "TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR", "unknow-error"}, {0, NULL, NULL}};
	GType tuner_data_provider_api_status_type_id;
	tuner_data_provider_api_status_type_id = g_enum_register_static ("TunerDataProviderAPIStatus", values);
	return tuner_data_provider_api_status_type_id;
}

GType
tuner_data_provider_api_status_get_type (void)
{
	static volatile gsize tuner_data_provider_api_status_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_api_status_type_id__once)) {
		GType tuner_data_provider_api_status_type_id;
		tuner_data_provider_api_status_type_id = tuner_data_provider_api_status_get_type_once ();
		g_once_init_leave (&tuner_data_provider_api_status_type_id__once, tuner_data_provider_api_status_type_id);
	}
	return tuner_data_provider_api_status_type_id__once;
}

/**
         * @brief Clears the last data error 
         *
         */
static void
tuner_data_provider_api_real_clear_last_error (TunerDataProviderAPI* self)
{
	tuner_data_provider_api_set_last_data_error (self, NULL);
}

void
tuner_data_provider_api_clear_last_error (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->clear_last_error) {
		_iface_->clear_last_error (self);
	}
}

/**
         * @brief DataProvider name property
         *
         */
gchar*
tuner_data_provider_api_name (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->name) {
		return _iface_->name (self);
	}
	return NULL;
}

/**
         * @brief Number of stations available
         *
         * @return the number of available stations
         */
gint
tuner_data_provider_api_available_stations (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->available_stations) {
		return _iface_->available_stations (self);
	}
	return -1;
}

/**
          * @brief Number of tags available
          *
          * @return the number of available tags
          */
gint
tuner_data_provider_api_available_tags (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->available_tags) {
		return _iface_->available_tags (self);
	}
	return -1;
}

/**
         * @brief Initialize the DataProvider implementation
         *
         * @return true if initialization successful
         */
gboolean
tuner_data_provider_api_initialize (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->initialize) {
		return _iface_->initialize (self);
	}
	return FALSE;
}

/**
         * @brief Register a station listen event
         *
         * @param stationuuid UUID of the station being listened to
         */
void
tuner_data_provider_api_click (TunerDataProviderAPI* self,
                               const gchar* stationuuid)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->click) {
		_iface_->click (self, stationuuid);
	}
}

/**
         * @brief Vote for a station
         *
         * @param stationuuid UUID of the station being voted for
         */
void
tuner_data_provider_api_vote (TunerDataProviderAPI* self,
                              const gchar* stationuuid)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->vote) {
		_iface_->vote (self, stationuuid);
	}
}

/**
         * @brief Get all available tags
         *
         * @return ArrayList of Tag objects
         * @throw DataError if unable to retrieve or parse tag data
         */
GeeSet*
tuner_data_provider_api_get_tags (TunerDataProviderAPI* self,
                                  gint offset,
                                  gint limit,
                                  GError** error)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->get_tags) {
		return _iface_->get_tags (self, offset, limit, error);
	}
	return NULL;
}

/**
         * @brief Get a station or stations by UUID/S
         *
         * @param uuids comma seperated lists of the stations to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */
GeeSet*
tuner_data_provider_api_by_uuid (TunerDataProviderAPI* self,
                                 const gchar* uuids,
                                 GError** error)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->by_uuid) {
		return _iface_->by_uuid (self, uuids, error);
	}
	return NULL;
}

GeeSet*
tuner_data_provider_api_by_uuids (TunerDataProviderAPI* self,
                                  GeeCollection* uuids,
                                  GError** error)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->by_uuids) {
		return _iface_->by_uuids (self, uuids, error);
	}
	return NULL;
}

/**
 * @brief Search for stations based on given parameters
 *
 * @param params Search parameters
 * @param rowcount Maximum number of results to return
 * @param offset Offset for pagination
 * @return ArrayList of Station objects matching the search criteria
 * @throw DataError if unable to retrieve or parse station data
 */
GeeSet*
tuner_data_provider_api_search (TunerDataProviderAPI* self,
                                TunerDataProviderSearchParams* params,
                                guint rowcount,
                                guint offset,
                                GError** error)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->search) {
		return _iface_->search (self, params, rowcount, offset, error);
	}
	return NULL;
}

void
tuner_data_provider_api_search_async (TunerDataProviderAPI* self,
                                      TunerDataProviderSearchParams* params,
                                      guint rowcount,
                                      guint offset,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	TunerDataProviderAPIIface* _iface_;
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->search_async) {
		_iface_->search_async (self, params, rowcount, offset, _callback_, _user_data_);
	}
}

GeeSet*
tuner_data_provider_api_search_finish (TunerDataProviderAPI* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	TunerDataProviderAPIIface* _iface_;
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->search_finish) {
		return _iface_->search_finish (self, _res_, error);
	}
	return NULL;
}

GError*
tuner_data_provider_api_get_last_data_error (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->get_last_data_error) {
		return _iface_->get_last_data_error (self);
	}
	return NULL;
}

void
tuner_data_provider_api_set_last_data_error (TunerDataProviderAPI* self,
                                             GError* value)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->set_last_data_error) {
		_iface_->set_last_data_error (self, value);
	}
}

TunerDataProviderAPIStatus
tuner_data_provider_api_get_status (TunerDataProviderAPI* self)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->get_status) {
		return _iface_->get_status (self);
	}
	return 0;
}

void
tuner_data_provider_api_set_status (TunerDataProviderAPI* self,
                                    TunerDataProviderAPIStatus value)
{
	TunerDataProviderAPIIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = TUNER_DATA_PROVIDER_API_GET_INTERFACE (self);
	if (_iface_->set_status) {
		_iface_->set_status (self, value);
	}
}

static void
tuner_data_provider_api_default_init (TunerDataProviderAPIIface * iface,
                                      gpointer iface_data)
{
	/**
	         * @brief The last DataError from the DataProvider
	         *
	         */
	g_object_interface_install_property (iface, g_param_spec_boxed ("last-data-error", "last-data-error", "last-data-error", G_TYPE_ERROR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * @brief DataProvider status property
	         *
	         */
	g_object_interface_install_property (iface, g_param_spec_enum ("status", "status", "status", TUNER_DATA_PROVIDER_API_TYPE_STATUS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	iface->clear_last_error = tuner_data_provider_api_real_clear_last_error;
}

/**
     * @class API
     *
     * @brief Main DataProvider API 
     * 
     * Defines methods to interact with the DataProvider API, including:
     * - Station search and retrieval
     * - User interaction tracking (votes, listens)
     * - Tag management
     * - Server discovery and connection handling
     *
     */
static GType
tuner_data_provider_api_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerDataProviderAPIIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_data_provider_api_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType tuner_data_provider_api_type_id;
	tuner_data_provider_api_type_id = g_type_register_static (G_TYPE_INTERFACE, "TunerDataProviderAPI", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (tuner_data_provider_api_type_id, G_TYPE_OBJECT);
	return tuner_data_provider_api_type_id;
}

GType
tuner_data_provider_api_get_type (void)
{
	static volatile gsize tuner_data_provider_api_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_api_type_id__once)) {
		GType tuner_data_provider_api_type_id;
		tuner_data_provider_api_type_id = tuner_data_provider_api_get_type_once ();
		g_once_init_leave (&tuner_data_provider_api_type_id__once, tuner_data_provider_api_type_id);
	}
	return tuner_data_provider_api_type_id__once;
}

