/* HttpClient.c generated by valac 0.56.8, the Vala compiler
 * generated from HttpClient.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file HttpClient.vala
 * @author technosf
 * @date 2024-10-01
 * @since 1.5.4
 * @brief HTTP client implementation using Soup library
 */

#include <glib-object.h>
#include <libsoup/soup.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#define TUNER_APPLICATION_APP_ID "com.github.louis77.tuner"
#define VERSION "2.0.0"
#define TUNER_APPLICATION_APP_VERSION VERSION
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_HTTP_CLIENT (tuner_http_client_get_type ())
#define TUNER_HTTP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HTTP_CLIENT, TunerHttpClient))
#define TUNER_HTTP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HTTP_CLIENT, TunerHttpClientClass))
#define TUNER_IS_HTTP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HTTP_CLIENT))
#define TUNER_IS_HTTP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HTTP_CLIENT))
#define TUNER_HTTP_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HTTP_CLIENT, TunerHttpClientClass))

typedef struct _TunerHttpClient TunerHttpClient;
typedef struct _TunerHttpClientClass TunerHttpClientClass;
typedef struct _TunerHttpClientPrivate TunerHttpClientPrivate;
enum  {
	TUNER_HTTP_CLIENT_0_PROPERTY,
	TUNER_HTTP_CLIENT_NUM_PROPERTIES
};
static GParamSpec* tuner_http_client_properties[TUNER_HTTP_CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
typedef struct _tuner_http_client_GETasyncData tuner_http_client_GETasyncData;

struct _TunerHttpClient {
	GObject parent_instance;
	TunerHttpClientPrivate * priv;
};

struct _TunerHttpClientClass {
	GObjectClass parent_class;
};

struct _tuner_http_client_GETasyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GUri* uri;
	gint priority;
	guint status_code;
	GInputStream* result;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoupMessage* msg;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	guint loop;
	gboolean _tmp7_;
	guint _tmp8_;
	GInputStream* inputStream;
	SoupSession* _tmp9_;
	SoupSession* _tmp10_;
	SoupMessage* _tmp11_;
	TunerApplication* _tmp12_;
	TunerApplication* _tmp13_;
	GCancellable* _tmp14_;
	GCancellable* _tmp15_;
	GInputStream* _tmp16_;
	GInputStream* _tmp17_;
	SoupMessage* _tmp18_;
	guint _tmp19_;
	guint _tmp20_;
	gboolean _tmp21_;
	GError* e;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	GError* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GError* _inner_error0_;
};

static gpointer tuner_http_client_parent_class = NULL;
static SoupSession* tuner_http_client__session;
static SoupSession* tuner_http_client__session = NULL;

VALA_EXTERN GType tuner_http_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHttpClient, g_object_unref)
static SoupSession* tuner_http_client_getSession (void);
VALA_EXTERN guint tuner_http_client_HEAD (GUri* uri);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN gboolean tuner_application_get_is_offline (TunerApplication* self);
static gboolean __lambda105_ (SoupMessage* msg,
                       GTlsCertificate* cert,
                       GTlsCertificateFlags errors);
static gboolean ___lambda105__soup_message_accept_certificate (SoupMessage* _sender,
                                                        GTlsCertificate* tls_peer_certificate,
                                                        GTlsCertificateFlags tls_peer_errors,
                                                        gpointer self);
VALA_EXTERN GInputStream* tuner_http_client_GET (GUri* uri,
                                     guint* status_code);
static gboolean __lambda98_ (SoupMessage* msg,
                      GTlsCertificate* cert,
                      GTlsCertificateFlags errors);
static gboolean ___lambda98__soup_message_accept_certificate (SoupMessage* _sender,
                                                       GTlsCertificate* tls_peer_certificate,
                                                       GTlsCertificateFlags tls_peer_errors,
                                                       gpointer self);
static void tuner_http_client_GETasync_data_free (gpointer _data);
VALA_EXTERN void tuner_http_client_GETasync (GUri* uri,
                                 gint priority,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static gboolean tuner_http_client_GETasync_co (tuner_http_client_GETasyncData* _data_);
static gboolean __lambda102_ (SoupMessage* msg,
                       GTlsCertificate* cert,
                       GTlsCertificateFlags errors);
static gboolean ___lambda102__soup_message_accept_certificate (SoupMessage* _sender,
                                                        GTlsCertificate* tls_peer_certificate,
                                                        GTlsCertificateFlags tls_peer_errors,
                                                        gpointer self);
VALA_EXTERN GCancellable* tuner_application_get_offline_cancel (TunerApplication* self);
static void tuner_http_client_GETasync_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
VALA_EXTERN void tuner_nap (guint interval,
                GAsyncReadyCallback _callback_,
                gpointer _user_data_);
VALA_EXTERN void tuner_nap_finish (GAsyncResult* _res_);
VALA_EXTERN TunerHttpClient* tuner_http_client_new (void);
VALA_EXTERN TunerHttpClient* tuner_http_client_construct (GType object_type);
static void tuner_http_client_finalize (GObject * obj);
static GType tuner_http_client_get_type_once (void);

/**
     * @brief Get the singleton Soup.Session instance
     *
     * This method returns the singleton Soup.Session instance, creating it
     * if it doesn't already exist. The session is configured with a custom
     * user agent string and a timeout of 2 seconds, maximum 30 connections
     * with only one connection per host.
     * 
     *
     * @return The singleton Soup.Session instance
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static SoupSession*
tuner_http_client_getSession (void)
{
	SoupSession* _tmp0_;
	SoupSession* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	SoupSession* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	SoupSession* _tmp14_;
	SoupSession* _tmp15_;
	SoupSession* result;
	_tmp0_ = tuner_http_client__session;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		SoupSession* _tmp5_;
		_tmp1_ = string_to_string (TUNER_APPLICATION_APP_ID);
		_tmp2_ = string_to_string (TUNER_APPLICATION_APP_VERSION);
		_tmp3_ = g_strconcat (_tmp1_, "/", _tmp2_, NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = soup_session_new_with_options ("max-conns", 50, "max-conns-per-host", 2, "timeout", 3, "user_agent", _tmp4_, NULL);
		_g_object_unref0 (tuner_http_client__session);
		tuner_http_client__session = _tmp5_;
		_g_free0 (_tmp4_);
	}
	_tmp6_ = tuner_http_client__session;
	_tmp7_ = g_strdup_printf ("%u", soup_session_get_max_conns (_tmp6_));
	_tmp8_ = _tmp7_;
	_tmp9_ = tuner_http_client__session;
	_tmp10_ = g_strdup_printf ("%u", soup_session_get_max_conns_per_host (_tmp9_));
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat ("Conns Max: ", _tmp8_, ", Conns PH: ", _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	g_debug ("HttpClient.vala:58: %s", _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	_tmp14_ = tuner_http_client__session;
	_tmp15_ = _g_object_ref0 (_tmp14_);
	result = _tmp15_;
	return result;
}

/**
     * @brief Perform a HEAD request to the specified URL
     *
     *  Does not sanity check the URL
     *
     * @param url_string The URL to send the GET request to     
     * @return status_code the HTTP status code of the response
     * @throws Error if there's an error sending the request or receiving the response
     */
static gboolean
__lambda105_ (SoupMessage* msg,
              GTlsCertificate* cert,
              GTlsCertificateFlags errors)
{
	gboolean result;
	g_return_val_if_fail (msg != NULL, FALSE);
	g_return_val_if_fail (cert != NULL, FALSE);
	result = TRUE;
	return result;
}

static gboolean
___lambda105__soup_message_accept_certificate (SoupMessage* _sender,
                                               GTlsCertificate* tls_peer_certificate,
                                               GTlsCertificateFlags tls_peer_errors,
                                               gpointer self)
{
	gboolean result;
	result = __lambda105_ (_sender, tls_peer_certificate, tls_peer_errors);
	return result;
}

guint
tuner_http_client_HEAD (GUri* uri)
{
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoupMessage* msg = NULL;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GError* _inner_error0_ = NULL;
	guint result;
	g_return_val_if_fail (uri != NULL, 0U);
	_tmp0_ = tuner_app ();
	_tmp1_ = _tmp0_;
	_tmp2_ = tuner_application_get_is_offline (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		result = (guint) 0;
		return result;
	}
	_tmp5_ = soup_message_new_from_uri ("HEAD", uri);
	msg = _tmp5_;
	_tmp6_ = msg;
	g_signal_connect (_tmp6_, "accept-certificate", (GCallback) ___lambda105__soup_message_accept_certificate, NULL);
	{
		SoupSession* _tmp7_;
		SoupSession* _tmp8_;
		SoupMessage* _tmp9_;
		GInputStream* _tmp10_;
		GInputStream* _tmp11_;
		SoupMessage* _tmp12_;
		guint _tmp13_;
		guint _tmp14_;
		_tmp7_ = tuner_http_client_getSession ();
		_tmp8_ = _tmp7_;
		_tmp9_ = msg;
		_tmp10_ = soup_session_send (_tmp8_, _tmp9_, NULL, &_inner_error0_);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp11_);
		_g_object_unref0 (_tmp8_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp12_ = msg;
		g_object_get (_tmp12_, "status-code", &_tmp13_, NULL);
		_tmp14_ = _tmp13_;
		result = _tmp14_;
		_g_object_unref0 (msg);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp15_ = g_uri_to_string (uri);
		_tmp16_ = _tmp15_;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		g_warning ("HttpClient.vala:88: HEAD - Error accessing URL: %s (%s)", _tmp16_, _tmp18_);
		_g_free0 (_tmp16_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint _tmp19_ = 0U;
		_g_object_unref0 (msg);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp19_;
	}
	result = (guint) 0;
	_g_object_unref0 (msg);
	return result;
}

/**
     * @brief Perform a GET request to the specified URL
     *
     * @param url_string The URL to send the GET request to
     * @param status_code Output parameter for the HTTP status code of the response
     * @return InputStream containing the response body, or null if the request failed
     * @throws Error if there's an error sending the request or receiving the response
     */
static gboolean
__lambda98_ (SoupMessage* msg,
             GTlsCertificate* cert,
             GTlsCertificateFlags errors)
{
	gboolean result;
	g_return_val_if_fail (msg != NULL, FALSE);
	g_return_val_if_fail (cert != NULL, FALSE);
	result = TRUE;
	return result;
}

static gboolean
___lambda98__soup_message_accept_certificate (SoupMessage* _sender,
                                              GTlsCertificate* tls_peer_certificate,
                                              GTlsCertificateFlags tls_peer_errors,
                                              gpointer self)
{
	gboolean result;
	result = __lambda98_ (_sender, tls_peer_certificate, tls_peer_errors);
	return result;
}

GInputStream*
tuner_http_client_GET (GUri* uri,
                       guint* status_code)
{
	guint _vala_status_code = 0U;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	TunerApplication* _tmp5_;
	TunerApplication* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	SoupMessage* msg = NULL;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	GError* _inner_error0_ = NULL;
	GInputStream* result;
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = g_uri_to_string (uri);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_to_string (_tmp1_);
	_tmp3_ = g_strconcat ("Get: ", _tmp2_, " ", NULL);
	_tmp4_ = _tmp3_;
	g_debug ("HttpClient.vala:107: %s", _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp1_);
	_vala_status_code = (guint) 0;
	_tmp5_ = tuner_app ();
	_tmp6_ = _tmp5_;
	_tmp7_ = tuner_application_get_is_offline (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _tmp8_;
	_g_object_unref0 (_tmp6_);
	if (_tmp9_) {
		result = NULL;
		if (status_code) {
			*status_code = _vala_status_code;
		}
		return result;
	}
	_tmp10_ = soup_message_new_from_uri ("GET", uri);
	msg = _tmp10_;
	_tmp11_ = msg;
	g_signal_connect (_tmp11_, "accept-certificate", (GCallback) ___lambda98__soup_message_accept_certificate, NULL);
	{
		GInputStream* inputStream = NULL;
		SoupSession* _tmp12_;
		SoupSession* _tmp13_;
		SoupMessage* _tmp14_;
		GInputStream* _tmp15_;
		GInputStream* _tmp16_;
		SoupMessage* _tmp17_;
		guint _tmp18_;
		guint _tmp19_;
		_tmp12_ = tuner_http_client_getSession ();
		_tmp13_ = _tmp12_;
		_tmp14_ = msg;
		_tmp15_ = soup_session_send (_tmp13_, _tmp14_, NULL, &_inner_error0_);
		_tmp16_ = _tmp15_;
		_g_object_unref0 (_tmp13_);
		inputStream = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp17_ = msg;
		g_object_get (_tmp17_, "status-code", &_tmp18_, NULL);
		_tmp19_ = _tmp18_;
		_vala_status_code = _tmp19_;
		result = inputStream;
		_g_object_unref0 (msg);
		if (status_code) {
			*status_code = _vala_status_code;
		}
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		GError* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp20_ = g_uri_to_string (uri);
		_tmp21_ = _tmp20_;
		_tmp22_ = string_to_string (_tmp21_);
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		_tmp25_ = string_to_string (_tmp24_);
		_tmp26_ = g_strconcat ("GET - Error accessing URL: ", _tmp22_, " (", _tmp25_, ")", NULL);
		_tmp27_ = _tmp26_;
		g_warning ("HttpClient.vala:127: %s", _tmp27_);
		_g_free0 (_tmp27_);
		_g_free0 (_tmp21_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (msg);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	_g_object_unref0 (msg);
	if (status_code) {
		*status_code = _vala_status_code;
	}
	return result;
}

static void
tuner_http_client_GETasync_data_free (gpointer _data)
{
	tuner_http_client_GETasyncData* _data_;
	_data_ = _data;
	_g_uri_unref0 (_data_->uri);
	_g_object_unref0 (_data_->result);
	g_slice_free (tuner_http_client_GETasyncData, _data_);
}

static gpointer
_g_uri_ref0 (gpointer self)
{
	return self ? g_uri_ref (self) : NULL;
}

void
tuner_http_client_GETasync (GUri* uri,
                            gint priority,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	tuner_http_client_GETasyncData* _data_;
	GUri* _tmp0_;
	g_return_if_fail (uri != NULL);
	_data_ = g_slice_new0 (tuner_http_client_GETasyncData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_http_client_GETasync_data_free);
	_tmp0_ = _g_uri_ref0 (uri);
	_g_uri_unref0 (_data_->uri);
	_data_->uri = _tmp0_;
	_data_->priority = priority;
	tuner_http_client_GETasync_co (_data_);
}

GInputStream*
tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                   guint* status_code)
{
	GInputStream* result;
	tuner_http_client_GETasyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (status_code) {
		*status_code = _data_->status_code;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

/**
     * @brief Perform an asynchronous GET request to the specified URL
     *
     * @param url_string The URL to send the GET request to
     * @param status_code Output parameter for the HTTP status code of the response
     * @return InputStream containing the response body, or null if the request failed
     */
static gboolean
__lambda102_ (SoupMessage* msg,
              GTlsCertificate* cert,
              GTlsCertificateFlags errors)
{
	gboolean result;
	g_return_val_if_fail (msg != NULL, FALSE);
	g_return_val_if_fail (cert != NULL, FALSE);
	result = TRUE;
	return result;
}

static gboolean
___lambda102__soup_message_accept_certificate (SoupMessage* _sender,
                                               GTlsCertificate* tls_peer_certificate,
                                               GTlsCertificateFlags tls_peer_errors,
                                               gpointer self)
{
	gboolean result;
	result = __lambda102_ (_sender, tls_peer_certificate, tls_peer_errors);
	return result;
}

static void
tuner_http_client_GETasync_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	tuner_http_client_GETasyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	tuner_http_client_GETasync_co (_data_);
}

static gboolean
tuner_http_client_GETasync_co (tuner_http_client_GETasyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->status_code = (guint) 0;
	_data_->_tmp0_ = tuner_app ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = tuner_application_get_is_offline (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_tmp4_ = _data_->_tmp3_;
	_g_object_unref0 (_data_->_tmp1_);
	if (_data_->_tmp4_) {
		_data_->result = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp5_ = soup_message_new_from_uri ("GET", _data_->uri);
	_data_->msg = _data_->_tmp5_;
	_data_->_tmp6_ = _data_->msg;
	g_signal_connect (_data_->_tmp6_, "accept-certificate", (GCallback) ___lambda102__soup_message_accept_certificate, NULL);
	_data_->loop = (guint) 1;
	{
		_data_->_tmp7_ = TRUE;
		while (TRUE) {
			if (!_data_->_tmp7_) {
				_data_->_tmp8_ = _data_->loop;
				_data_->loop = _data_->_tmp8_ + 1;
				if (!(_data_->_tmp8_ < ((guint) 3))) {
					break;
				}
			}
			_data_->_tmp7_ = FALSE;
			{
				_data_->_tmp9_ = tuner_http_client_getSession ();
				_data_->_tmp10_ = _data_->_tmp9_;
				_data_->_tmp11_ = _data_->msg;
				_data_->_tmp12_ = tuner_app ();
				_data_->_tmp13_ = _data_->_tmp12_;
				_data_->_tmp14_ = tuner_application_get_offline_cancel (_data_->_tmp13_);
				_data_->_tmp15_ = _data_->_tmp14_;
				_data_->_state_ = 1;
				soup_session_send_async (_data_->_tmp10_, _data_->_tmp11_, _data_->priority, _data_->_tmp15_, tuner_http_client_GETasync_ready, _data_);
				return FALSE;
				_state_1:
				_data_->_tmp16_ = soup_session_send_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
				_data_->_tmp17_ = _data_->_tmp16_;
				_g_object_unref0 (_data_->_tmp13_);
				_g_object_unref0 (_data_->_tmp10_);
				_data_->inputStream = _data_->_tmp17_;
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_data_->_tmp18_ = _data_->msg;
				g_object_get (_data_->_tmp18_, "status-code", &_data_->_tmp19_, NULL);
				_data_->_tmp20_ = _data_->_tmp19_;
				_data_->status_code = _data_->_tmp20_;
				if (_data_->status_code >= ((guint) 200)) {
					_data_->_tmp21_ = _data_->status_code < ((guint) 300);
				} else {
					_data_->_tmp21_ = FALSE;
				}
				if (_data_->_tmp21_) {
					_data_->result = _data_->inputStream;
					_g_object_unref0 (_data_->msg);
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
					if (_data_->_state_ != 0) {
						while (!g_task_get_completed (_data_->_async_result)) {
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
						}
					}
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				_g_object_unref0 (_data_->inputStream);
			}
			goto __finally0;
			__catch0_g_error:
			{
				_data_->e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				_data_->_tmp22_ = g_strdup_printf ("%u", _data_->loop);
				_data_->_tmp23_ = _data_->_tmp22_;
				_data_->_tmp24_ = g_uri_to_string (_data_->uri);
				_data_->_tmp25_ = _data_->_tmp24_;
				_data_->_tmp26_ = string_to_string (_data_->_tmp25_);
				_data_->_tmp27_ = _data_->e;
				_data_->_tmp28_ = _data_->_tmp27_->message;
				_data_->_tmp29_ = string_to_string (_data_->_tmp28_);
				_data_->_tmp30_ = g_strconcat ("GETasync - Try ", _data_->_tmp23_, " failed to fetch: ", _data_->_tmp26_, " ", _data_->_tmp29_, NULL);
				_data_->_tmp31_ = _data_->_tmp30_;
				g_info ("HttpClient.vala:171: %s", _data_->_tmp31_);
				_g_free0 (_data_->_tmp31_);
				_g_free0 (_data_->_tmp25_);
				_g_free0 (_data_->_tmp23_);
				_g_error_free0 (_data_->e);
			}
			__finally0:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_object_unref0 (_data_->msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
			_data_->_state_ = 2;
			tuner_nap (200 * _data_->loop, tuner_http_client_GETasync_ready, _data_);
			return FALSE;
			_state_2:
			tuner_nap_finish (_data_->_res_);
		}
	}
	_data_->_tmp32_ = g_uri_to_string (_data_->uri);
	_data_->_tmp33_ = _data_->_tmp32_;
	_data_->_tmp34_ = string_to_string (_data_->_tmp33_);
	_data_->_tmp35_ = g_strconcat ("GETasync - GETasync failed for: ", _data_->_tmp34_, NULL);
	_data_->_tmp36_ = _data_->_tmp35_;
	g_info ("HttpClient.vala:176: %s", _data_->_tmp36_);
	_g_free0 (_data_->_tmp36_);
	_g_free0 (_data_->_tmp33_);
	_data_->result = NULL;
	_g_object_unref0 (_data_->msg);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

TunerHttpClient*
tuner_http_client_construct (GType object_type)
{
	TunerHttpClient * self = NULL;
	self = (TunerHttpClient*) g_object_new (object_type, NULL);
	return self;
}

TunerHttpClient*
tuner_http_client_new (void)
{
	return tuner_http_client_construct (TUNER_TYPE_HTTP_CLIENT);
}

static void
tuner_http_client_class_init (TunerHttpClientClass * klass,
                              gpointer klass_data)
{
	tuner_http_client_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = tuner_http_client_finalize;
}

static void
tuner_http_client_instance_init (TunerHttpClient * self,
                                 gpointer klass)
{
}

static void
tuner_http_client_finalize (GObject * obj)
{
	TunerHttpClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_HTTP_CLIENT, TunerHttpClient);
	G_OBJECT_CLASS (tuner_http_client_parent_class)->finalize (obj);
}

/**
 * @class Tuner.HttpClient
 * @brief HTTP functions abstracting Soup library
 *
 * This class provides static methods for making HTTP requests using the Soup library.
 * It includes a singleton Soup.Session instance for efficient request handling.
 */
static GType
tuner_http_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerHttpClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_http_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerHttpClient), 0, (GInstanceInitFunc) tuner_http_client_instance_init, NULL };
	GType tuner_http_client_type_id;
	tuner_http_client_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerHttpClient", &g_define_type_info, 0);
	return tuner_http_client_type_id;
}

GType
tuner_http_client_get_type (void)
{
	static volatile gsize tuner_http_client_type_id__once = 0;
	if (g_once_init_enter (&tuner_http_client_type_id__once)) {
		GType tuner_http_client_type_id;
		tuner_http_client_type_id = tuner_http_client_get_type_once ();
		g_once_init_leave (&tuner_http_client_type_id__once, tuner_http_client_type_id);
	}
	return tuner_http_client_type_id__once;
}

