/* StationContextMenu.c generated by valac 0.56.8, the Vala compiler
 * generated from StationContextMenu.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file StationContextMenu.vala
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define TUNER_APPLICATION_UNSTAR_CHAR "☆ "
#define TUNER_APPLICATION_STAR_CHAR "★ "
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_STATION_CONTEXT_MENU (tuner_station_context_menu_get_type ())
#define TUNER_STATION_CONTEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenu))
#define TUNER_STATION_CONTEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenuClass))
#define TUNER_IS_STATION_CONTEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_CONTEXT_MENU))
#define TUNER_IS_STATION_CONTEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_CONTEXT_MENU))
#define TUNER_STATION_CONTEXT_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenuClass))

typedef struct _TunerStationContextMenu TunerStationContextMenu;
typedef struct _TunerStationContextMenuClass TunerStationContextMenuClass;
typedef struct _TunerStationContextMenuPrivate TunerStationContextMenuPrivate;

#define TUNER_TYPE_DISPLAY_BUTTON (tuner_display_button_get_type ())
#define TUNER_DISPLAY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButton))
#define TUNER_DISPLAY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButtonClass))
#define TUNER_IS_DISPLAY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DISPLAY_BUTTON))
#define TUNER_IS_DISPLAY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DISPLAY_BUTTON))
#define TUNER_DISPLAY_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButtonClass))

typedef struct _TunerDisplayButton TunerDisplayButton;
typedef struct _TunerDisplayButtonClass TunerDisplayButtonClass;

#define TUNER_TYPE_STATION_BUTTON (tuner_station_button_get_type ())
#define TUNER_STATION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_BUTTON, TunerStationButton))
#define TUNER_STATION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_BUTTON, TunerStationButtonClass))
#define TUNER_IS_STATION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_BUTTON))
#define TUNER_IS_STATION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_BUTTON))
#define TUNER_STATION_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_BUTTON, TunerStationButtonClass))

typedef struct _TunerStationButton TunerStationButton;
typedef struct _TunerStationButtonClass TunerStationButtonClass;

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
enum  {
	TUNER_STATION_CONTEXT_MENU_0_PROPERTY,
	TUNER_STATION_CONTEXT_MENU_STATION_BUTTON_PROPERTY,
	TUNER_STATION_CONTEXT_MENU_NUM_PROPERTIES
};
static GParamSpec* tuner_station_context_menu_properties[TUNER_STATION_CONTEXT_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block17Data Block17Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _TunerModelFaviconPrivate TunerModelFaviconPrivate;
typedef struct _TunerModelStationPrivate TunerModelStationPrivate;

struct _TunerStationContextMenu {
	GtkMenu parent_instance;
	TunerStationContextMenuPrivate * priv;
};

struct _TunerStationContextMenuClass {
	GtkMenuClass parent_class;
};

struct _TunerStationContextMenuPrivate {
	TunerStationButton* _station_button;
	TunerModelStation* _station;
};

struct _Block17Data {
	int _ref_count_;
	TunerStationContextMenu* self;
	GtkMenuItem* not_up_to_date;
	GtkMenuItem* make_up_to_date;
	GtkMenuItem* star;
};

struct _TunerModelFavicon {
	GObject parent_instance;
	TunerModelFaviconPrivate * priv;
};

struct _TunerModelFaviconClass {
	GObjectClass parent_class;
	gchar* (*favicon_cache_file) (TunerModelFavicon* self);
};

struct _TunerModelStation {
	TunerModelFavicon parent_instance;
	TunerModelStationPrivate * priv;
	gint votes;
	gchar* lastchangetime;
	gchar* lastchangetime_iso8601;
	gint lastcheckok;
	gchar* lastchecktime;
	gchar* lastchecktime_iso8601;
	gchar* lastcheckoktime;
	gchar* lastcheckoktime_iso8601;
	gchar* lastlocalchecktime;
	gchar* lastlocalchecktime_iso8601;
	gchar* clicktimestamp;
	gchar* clicktimestamp_iso8601;
	gint clickcount;
	gint clicktrend;
	gint ssl_error;
	gchar* geo_lat;
	gchar* geo_long;
	gboolean has_extended_info;
	gboolean is_in_index;
	gboolean is_up_to_date;
	gchar* up_to_date_difference;
};

struct _TunerModelStationClass {
	TunerModelFaviconClass parent_class;
};

static gint TunerStationContextMenu_private_offset;
static gpointer tuner_station_context_menu_parent_class = NULL;

VALA_EXTERN GType tuner_station_context_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationContextMenu, g_object_unref)
VALA_EXTERN GType tuner_display_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDisplayButton, g_object_unref)
VALA_EXTERN GType tuner_station_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationButton, g_object_unref)
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN TunerStationContextMenu* tuner_station_context_menu_new (TunerStationButton* station_button);
VALA_EXTERN TunerStationContextMenu* tuner_station_context_menu_construct (GType object_type,
                                                               TunerStationButton* station_button);
static void tuner_station_context_menu_on_website_handler (TunerStationContextMenu* self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
VALA_EXTERN TunerWindow* tuner_application_get_window (TunerApplication* self);
VALA_EXTERN const gchar* tuner_model_station_get_homepage (TunerModelStation* self);
static void tuner_station_context_menu_on_streamurl_handler (TunerStationContextMenu* self);
VALA_EXTERN const gchar* tuner_model_station_get_urlResolved (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
static void tuner_station_context_menu_set_context_star (TunerStationContextMenu* self,
                                                  GtkMenuItem* item);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
VALA_EXTERN TunerStationButton* tuner_station_context_menu_get_station_button (TunerStationContextMenu* self);
static void tuner_station_context_menu_set_station_button (TunerStationContextMenu* self,
                                                    TunerStationButton* value);
static GObject * tuner_station_context_menu_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
VALA_EXTERN TunerModelStation* tuner_station_button_get_station (TunerStationButton* self);
VALA_EXTERN const gchar* tuner_model_station_get_name (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_countrycode (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_state (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_language (TunerModelStation* self);
VALA_EXTERN gchar* tuner_model_station_popularity (TunerModelStation* self);
static void _tuner_station_context_menu___lambda36_ (Block17Data* _data17_);
VALA_EXTERN void tuner_station_button_update (TunerStationButton* self,
                                  gboolean starred);
static void __tuner_station_context_menu___lambda36__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                      gpointer self);
static void _tuner_station_context_menu_on_website_handler_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                            gpointer self);
static void _tuner_station_context_menu_on_streamurl_handler_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                              gpointer self);
static void _tuner_station_context_menu___lambda37_ (Block17Data* _data17_);
VALA_EXTERN gboolean tuner_model_station_toggle_starred (TunerModelStation* self);
static void __tuner_station_context_menu___lambda37__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                      gpointer self);
static void tuner_station_context_menu_finalize (GObject * obj);
static GType tuner_station_context_menu_get_type_once (void);
static void _vala_tuner_station_context_menu_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_tuner_station_context_menu_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
tuner_station_context_menu_get_instance_private (TunerStationContextMenu* self)
{
	return G_STRUCT_MEMBER_P (self, TunerStationContextMenu_private_offset);
}

/**
     * @brief Constructs a new StationContextMenu.
     * @param station_button The radio station for which this menu is created.
     */
TunerStationContextMenu*
tuner_station_context_menu_construct (GType object_type,
                                      TunerStationButton* station_button)
{
	TunerStationContextMenu * self = NULL;
	g_return_val_if_fail (station_button != NULL, NULL);
	self = (TunerStationContextMenu*) g_object_new (object_type, "station-button", station_button, NULL);
	return self;
}

TunerStationContextMenu*
tuner_station_context_menu_new (TunerStationButton* station_button)
{
	return tuner_station_context_menu_construct (TUNER_TYPE_STATION_CONTEXT_MENU, station_button);
}

/**
    * @brief Handles the action to open the station's website.
    */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
tuner_station_context_menu_on_website_handler (TunerStationContextMenu* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		TunerApplication* _tmp0_;
		TunerApplication* _tmp1_;
		TunerWindow* _tmp2_;
		TunerWindow* _tmp3_;
		TunerModelStation* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp0_ = tuner_app ();
		_tmp1_ = _tmp0_;
		_tmp2_ = tuner_application_get_window (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = self->priv->_station;
		_tmp5_ = tuner_model_station_get_homepage (_tmp4_);
		_tmp6_ = _tmp5_;
		gtk_show_uri_on_window ((GtkWindow*) _tmp3_, _tmp6_, (guint32) GDK_CURRENT_TIME, &_inner_error0_);
		_g_object_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = string_to_string (_tmp8_);
		_tmp10_ = g_strconcat ("Unable to open website: ", _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		g_warning ("StationContextMenu.vala:142: %s", _tmp11_);
		_g_free0 (_tmp11_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

/**
    * @brief Handles copying the stream URL to clipboard. UrlResolved is the stream url, url can be playlists
    */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
tuner_station_context_menu_on_streamurl_handler (TunerStationContextMenu* self)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp2_;
	GtkClipboard* _tmp3_;
	GtkClipboard* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	TunerModelStation* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkClipboard* _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp2_ = display;
	_tmp3_ = gtk_clipboard_get_for_display (_tmp2_, GDK_SELECTION_CLIPBOARD);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	clipboard = _tmp4_;
	_tmp7_ = self->priv->_station;
	_tmp8_ = tuner_model_station_get_urlResolved (_tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_ == NULL) {
		_tmp6_ = TRUE;
	} else {
		TunerModelStation* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		_tmp10_ = self->priv->_station;
		_tmp11_ = tuner_model_station_get_urlResolved (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp6_ = g_strcmp0 (_tmp12_, "") == 0;
	}
	if (_tmp6_) {
		TunerModelStation* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp13_ = self->priv->_station;
		_tmp14_ = tuner_model_station_get_url (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp5_ = _tmp15_;
	} else {
		TunerModelStation* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		_tmp16_ = self->priv->_station;
		_tmp17_ = tuner_model_station_get_urlResolved (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp5_ = _tmp18_;
	}
	_tmp19_ = clipboard;
	gtk_clipboard_set_text (_tmp19_, _tmp5_, -1);
	_g_object_unref0 (clipboard);
	_g_object_unref0 (display);
}

/**
    * @brief Updates the star menu item's label based on the station's starred status.
    * @param item The menu item to update.
    */
static void
tuner_station_context_menu_set_context_star (TunerStationContextMenu* self,
                                             GtkMenuItem* item)
{
	gchar* _tmp0_ = NULL;
	TunerModelStation* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp1_ = self->priv->_station;
	_tmp2_ = tuner_model_station_get_starred (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gchar* _tmp4_;
		_tmp4_ = g_strconcat (TUNER_APPLICATION_UNSTAR_CHAR, _ ("Unstar this station"), NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strconcat (TUNER_APPLICATION_STAR_CHAR, _ ("Star this station"), NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	gtk_menu_item_set_label (item, _tmp0_);
	_g_free0 (_tmp0_);
}

TunerStationButton*
tuner_station_context_menu_get_station_button (TunerStationContextMenu* self)
{
	TunerStationButton* result;
	TunerStationButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_station_button;
	result = _tmp0_;
	return result;
}

static void
tuner_station_context_menu_set_station_button (TunerStationContextMenu* self,
                                               TunerStationButton* value)
{
	TunerStationButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_station_context_menu_get_station_button (self);
	if (old_value != value) {
		TunerStationButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_station_button);
		self->priv->_station_button = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_station_context_menu_properties[TUNER_STATION_CONTEXT_MENU_STATION_BUTTON_PROPERTY]);
	}
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
	g_atomic_int_inc (&_data17_->_ref_count_);
	return _data17_;
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
		TunerStationContextMenu* self;
		self = _data17_->self;
		_g_object_unref0 (_data17_->star);
		_g_object_unref0 (_data17_->make_up_to_date);
		_g_object_unref0 (_data17_->not_up_to_date);
		_g_object_unref0 (self);
		g_slice_free (Block17Data, _data17_);
	}
}

static void
_tuner_station_context_menu___lambda36_ (Block17Data* _data17_)
{
	TunerStationContextMenu* self;
	TunerStationButton* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	self = _data17_->self;
	_tmp0_ = self->priv->_station_button;
	tuner_station_button_update (_tmp0_, TRUE);
	_tmp1_ = _data17_->not_up_to_date;
	gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = _data17_->make_up_to_date;
	gtk_container_remove ((GtkContainer*) self, (GtkWidget*) _tmp2_);
}

static void
__tuner_station_context_menu___lambda36__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                 gpointer self)
{
	_tuner_station_context_menu___lambda36_ (self);
}

static void
_tuner_station_context_menu_on_website_handler_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                       gpointer self)
{
	tuner_station_context_menu_on_website_handler ((TunerStationContextMenu*) self);
}

static void
_tuner_station_context_menu_on_streamurl_handler_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                         gpointer self)
{
	tuner_station_context_menu_on_streamurl_handler ((TunerStationContextMenu*) self);
}

static void
_tuner_station_context_menu___lambda37_ (Block17Data* _data17_)
{
	TunerStationContextMenu* self;
	TunerModelStation* _tmp0_;
	GtkMenuItem* _tmp1_;
	self = _data17_->self;
	_tmp0_ = self->priv->_station;
	tuner_model_station_toggle_starred (_tmp0_);
	_tmp1_ = _data17_->star;
	tuner_station_context_menu_set_context_star (self, _tmp1_);
}

static void
__tuner_station_context_menu___lambda37__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                 gpointer self)
{
	_tuner_station_context_menu___lambda37_ (self);
}

static GObject *
tuner_station_context_menu_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerStationContextMenu * self;
	Block17Data* _data17_;
	TunerStationButton* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
	TunerModelStation* _tmp3_;
	GtkMenuItem* name = NULL;
	TunerStationButton* _tmp4_;
	TunerModelStation* _tmp5_;
	TunerModelStation* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenuItem* _tmp11_;
	gboolean _tmp12_ = FALSE;
	TunerModelStation* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GtkSeparatorMenuItem* _tmp65_;
	GtkSeparatorMenuItem* _tmp66_;
	GtkMenuItem* popularity = NULL;
	TunerStationButton* _tmp67_;
	TunerModelStation* _tmp68_;
	TunerModelStation* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	GtkMenuItem* _tmp72_;
	GtkMenuItem* _tmp73_;
	GtkMenuItem* _tmp74_;
	GtkMenuItem* _tmp75_;
	GtkSeparatorMenuItem* _tmp76_;
	GtkSeparatorMenuItem* _tmp77_;
	GtkMenuItem* _tmp78_;
	GtkMenuItem* _tmp79_;
	GtkMenuItem* _tmp80_;
	GtkMenuItem* website = NULL;
	GtkMenuItem* _tmp81_;
	gboolean _tmp82_ = FALSE;
	TunerModelStation* _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	GtkMenuItem* stream_url = NULL;
	GtkMenuItem* _tmp92_;
	GtkMenuItem* _tmp93_;
	GtkMenuItem* _tmp94_;
	GtkMenuItem* _tmp95_;
	GtkMenuItem* _tmp96_;
	GtkMenuItem* _tmp97_;
	TunerModelStation* _tmp98_;
	GtkMenuItem* _tmp108_;
	GtkMenuItem* _tmp109_;
	GtkMenuItem* _tmp110_;
	parent_class = G_OBJECT_CLASS (tuner_station_context_menu_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenu);
	_data17_ = g_slice_new0 (Block17Data);
	_data17_->_ref_count_ = 1;
	_data17_->self = g_object_ref (self);
	_tmp0_ = self->priv->_station_button;
	_tmp1_ = tuner_station_button_get_station (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->_station);
	self->priv->_station = _tmp3_;
	_tmp4_ = self->priv->_station_button;
	_tmp5_ = tuner_station_button_get_station (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = tuner_model_station_get_name (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp8_);
	g_object_ref_sink (_tmp9_);
	name = _tmp9_;
	_tmp10_ = name;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
	_tmp11_ = name;
	gtk_menu_shell_append ((GtkMenuShell*) self, _tmp11_);
	_tmp13_ = self->priv->_station;
	_tmp14_ = tuner_model_station_get_countrycode (_tmp13_);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != NULL) {
		TunerModelStation* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		_tmp16_ = self->priv->_station;
		_tmp17_ = tuner_model_station_get_countrycode (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = strlen (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp12_ = _tmp20_ > 0;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		GString* sb = NULL;
		TunerModelStation* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		GString* _tmp24_;
		gboolean _tmp25_ = FALSE;
		TunerModelStation* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gboolean _tmp39_ = FALSE;
		TunerStationButton* _tmp40_;
		TunerModelStation* _tmp41_;
		TunerModelStation* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		GtkMenuItem* info = NULL;
		GString* _tmp60_;
		const gchar* _tmp61_;
		GtkMenuItem* _tmp62_;
		GtkMenuItem* _tmp63_;
		GtkMenuItem* _tmp64_;
		_tmp21_ = self->priv->_station;
		_tmp22_ = tuner_model_station_get_countrycode (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = g_string_new (_tmp23_);
		sb = _tmp24_;
		_tmp26_ = self->priv->_station;
		_tmp27_ = tuner_model_station_get_state (_tmp26_);
		_tmp28_ = _tmp27_;
		if (_tmp28_ != NULL) {
			TunerModelStation* _tmp29_;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
			_tmp29_ = self->priv->_station;
			_tmp30_ = tuner_model_station_get_state (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = strlen (_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp25_ = _tmp33_ > 0;
		} else {
			_tmp25_ = FALSE;
		}
		if (_tmp25_) {
			GString* _tmp34_;
			GString* _tmp35_;
			TunerModelStation* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			_tmp34_ = sb;
			_tmp35_ = g_string_append (_tmp34_, " - ");
			_tmp36_ = self->priv->_station;
			_tmp37_ = tuner_model_station_get_state (_tmp36_);
			_tmp38_ = _tmp37_;
			g_string_append (_tmp35_, _tmp38_);
		}
		_tmp40_ = self->priv->_station_button;
		_tmp41_ = tuner_station_button_get_station (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = tuner_model_station_get_language (_tmp42_);
		_tmp44_ = _tmp43_;
		if (_tmp44_ != NULL) {
			TunerStationButton* _tmp45_;
			TunerModelStation* _tmp46_;
			TunerModelStation* _tmp47_;
			const gchar* _tmp48_;
			const gchar* _tmp49_;
			gint _tmp50_;
			gint _tmp51_;
			_tmp45_ = self->priv->_station_button;
			_tmp46_ = tuner_station_button_get_station (_tmp45_);
			_tmp47_ = _tmp46_;
			_tmp48_ = tuner_model_station_get_language (_tmp47_);
			_tmp49_ = _tmp48_;
			_tmp50_ = strlen (_tmp49_);
			_tmp51_ = _tmp50_;
			_tmp39_ = _tmp51_ > 0;
		} else {
			_tmp39_ = FALSE;
		}
		if (_tmp39_) {
			GString* _tmp52_;
			GString* _tmp53_;
			TunerStationButton* _tmp54_;
			TunerModelStation* _tmp55_;
			TunerModelStation* _tmp56_;
			const gchar* _tmp57_;
			const gchar* _tmp58_;
			GString* _tmp59_;
			_tmp52_ = sb;
			_tmp53_ = g_string_append (_tmp52_, "\t[");
			_tmp54_ = self->priv->_station_button;
			_tmp55_ = tuner_station_button_get_station (_tmp54_);
			_tmp56_ = _tmp55_;
			_tmp57_ = tuner_model_station_get_language (_tmp56_);
			_tmp58_ = _tmp57_;
			_tmp59_ = g_string_append (_tmp53_, _tmp58_);
			g_string_append (_tmp59_, "]");
		}
		_tmp60_ = sb;
		_tmp61_ = _tmp60_->str;
		_tmp62_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp61_);
		g_object_ref_sink (_tmp62_);
		info = _tmp62_;
		_tmp63_ = info;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp63_, FALSE);
		_tmp64_ = info;
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp64_);
		_g_object_unref0 (info);
		_g_string_free0 (sb);
	}
	_tmp65_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp65_);
	_tmp66_ = _tmp65_;
	gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp66_);
	_g_object_unref0 (_tmp66_);
	_tmp67_ = self->priv->_station_button;
	_tmp68_ = tuner_station_button_get_station (_tmp67_);
	_tmp69_ = _tmp68_;
	_tmp70_ = tuner_model_station_popularity (_tmp69_);
	_tmp71_ = _tmp70_;
	_tmp72_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp71_);
	g_object_ref_sink (_tmp72_);
	_tmp73_ = _tmp72_;
	_g_free0 (_tmp71_);
	popularity = _tmp73_;
	_tmp74_ = popularity;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp74_, FALSE);
	_tmp75_ = popularity;
	gtk_menu_shell_append ((GtkMenuShell*) self, _tmp75_);
	_tmp76_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp76_);
	_tmp77_ = _tmp76_;
	gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp77_);
	_g_object_unref0 (_tmp77_);
	_tmp78_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Station info updated Online - View changes"));
	g_object_ref_sink (_tmp78_);
	_data17_->not_up_to_date = _tmp78_;
	_tmp79_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Update Station from Online"));
	g_object_ref_sink (_tmp79_);
	_data17_->make_up_to_date = _tmp79_;
	_tmp80_ = _data17_->make_up_to_date;
	g_signal_connect_data (_tmp80_, "activate", (GCallback) __tuner_station_context_menu___lambda36__gtk_menu_item_activate, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
	_tmp81_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Visit Website"));
	g_object_ref_sink (_tmp81_);
	website = _tmp81_;
	_tmp83_ = self->priv->_station;
	_tmp84_ = tuner_model_station_get_homepage (_tmp83_);
	_tmp85_ = _tmp84_;
	if (_tmp85_ != NULL) {
		TunerModelStation* _tmp86_;
		const gchar* _tmp87_;
		const gchar* _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		_tmp86_ = self->priv->_station;
		_tmp87_ = tuner_model_station_get_homepage (_tmp86_);
		_tmp88_ = _tmp87_;
		_tmp89_ = strlen (_tmp88_);
		_tmp90_ = _tmp89_;
		_tmp82_ = _tmp90_ > 0;
	} else {
		_tmp82_ = FALSE;
	}
	if (_tmp82_) {
		GtkMenuItem* _tmp91_;
		_tmp91_ = website;
		g_signal_connect_object (_tmp91_, "activate", (GCallback) _tuner_station_context_menu_on_website_handler_gtk_menu_item_activate, self, 0);
	}
	_tmp92_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Copy Stream-URL to clipboard"));
	g_object_ref_sink (_tmp92_);
	stream_url = _tmp92_;
	_tmp93_ = stream_url;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp93_, TRUE);
	_tmp94_ = stream_url;
	g_signal_connect_object (_tmp94_, "activate", (GCallback) _tuner_station_context_menu_on_streamurl_handler_gtk_menu_item_activate, self, 0);
	_tmp95_ = (GtkMenuItem*) gtk_menu_item_new ();
	g_object_ref_sink (_tmp95_);
	_data17_->star = _tmp95_;
	_tmp96_ = _data17_->star;
	tuner_station_context_menu_set_context_star (self, _tmp96_);
	_tmp97_ = _data17_->star;
	g_signal_connect_data (_tmp97_, "activate", (GCallback) __tuner_station_context_menu___lambda37__gtk_menu_item_activate, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
	_tmp98_ = self->priv->_station;
	if (!_tmp98_->is_up_to_date) {
		GtkMenuItem* _tmp99_;
		TunerModelStation* _tmp100_;
		const gchar* _tmp101_;
		TunerModelStation* _tmp102_;
		GtkMenuItem* _tmp104_;
		GtkMenuItem* _tmp105_;
		GtkSeparatorMenuItem* _tmp106_;
		GtkSeparatorMenuItem* _tmp107_;
		_tmp99_ = _data17_->not_up_to_date;
		_tmp100_ = self->priv->_station;
		_tmp101_ = _tmp100_->up_to_date_difference;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp99_, _tmp101_);
		_tmp102_ = self->priv->_station;
		if (!_tmp102_->is_in_index) {
			GtkMenuItem* _tmp103_;
			_tmp103_ = _data17_->make_up_to_date;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp103_, FALSE);
		}
		_tmp104_ = _data17_->not_up_to_date;
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp104_);
		_tmp105_ = _data17_->make_up_to_date;
		gtk_menu_shell_append ((GtkMenuShell*) self, _tmp105_);
		_tmp106_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		g_object_ref_sink (_tmp106_);
		_tmp107_ = _tmp106_;
		gtk_menu_shell_append ((GtkMenuShell*) self, (GtkMenuItem*) _tmp107_);
		_g_object_unref0 (_tmp107_);
	}
	_tmp108_ = website;
	gtk_menu_shell_append ((GtkMenuShell*) self, _tmp108_);
	_tmp109_ = stream_url;
	gtk_menu_shell_append ((GtkMenuShell*) self, _tmp109_);
	_tmp110_ = _data17_->star;
	gtk_menu_shell_append ((GtkMenuShell*) self, _tmp110_);
	_g_object_unref0 (stream_url);
	_g_object_unref0 (website);
	_g_object_unref0 (popularity);
	_g_object_unref0 (name);
	block17_data_unref (_data17_);
	_data17_ = NULL;
	return obj;
}

static void
tuner_station_context_menu_class_init (TunerStationContextMenuClass * klass,
                                       gpointer klass_data)
{
	tuner_station_context_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerStationContextMenu_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_station_context_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_station_context_menu_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_station_context_menu_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_station_context_menu_finalize;
	/**
	     * @property station
	     * @brief The radio station associated with this context menu.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_STATION_CONTEXT_MENU_STATION_BUTTON_PROPERTY, tuner_station_context_menu_properties[TUNER_STATION_CONTEXT_MENU_STATION_BUTTON_PROPERTY] = g_param_spec_object ("station-button", "station-button", "station-button", TUNER_TYPE_STATION_BUTTON, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
tuner_station_context_menu_instance_init (TunerStationContextMenu * self,
                                          gpointer klass)
{
	self->priv = tuner_station_context_menu_get_instance_private (self);
}

static void
tuner_station_context_menu_finalize (GObject * obj)
{
	TunerStationContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenu);
	_g_object_unref0 (self->priv->_station_button);
	_g_object_unref0 (self->priv->_station);
	G_OBJECT_CLASS (tuner_station_context_menu_parent_class)->finalize (obj);
}

/**
 * @class StationContextMenu
 * @brief A context menu for radio stations.
 *
 * This class represents a context menu that appears when interacting with a radio station.
 * It provides options such as visiting the station's website, copying the stream URL,
 * and starring/unstarring the station.
 *
 * @extends Gtk.Menu
 */
static GType
tuner_station_context_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerStationContextMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_station_context_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerStationContextMenu), 0, (GInstanceInitFunc) tuner_station_context_menu_instance_init, NULL };
	GType tuner_station_context_menu_type_id;
	tuner_station_context_menu_type_id = g_type_register_static (gtk_menu_get_type (), "TunerStationContextMenu", &g_define_type_info, 0);
	TunerStationContextMenu_private_offset = g_type_add_instance_private (tuner_station_context_menu_type_id, sizeof (TunerStationContextMenuPrivate));
	return tuner_station_context_menu_type_id;
}

GType
tuner_station_context_menu_get_type (void)
{
	static volatile gsize tuner_station_context_menu_type_id__once = 0;
	if (g_once_init_enter (&tuner_station_context_menu_type_id__once)) {
		GType tuner_station_context_menu_type_id;
		tuner_station_context_menu_type_id = tuner_station_context_menu_get_type_once ();
		g_once_init_leave (&tuner_station_context_menu_type_id__once, tuner_station_context_menu_type_id);
	}
	return tuner_station_context_menu_type_id__once;
}

static void
_vala_tuner_station_context_menu_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	TunerStationContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenu);
	switch (property_id) {
		case TUNER_STATION_CONTEXT_MENU_STATION_BUTTON_PROPERTY:
		g_value_set_object (value, tuner_station_context_menu_get_station_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_station_context_menu_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	TunerStationContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_STATION_CONTEXT_MENU, TunerStationContextMenu);
	switch (property_id) {
		case TUNER_STATION_CONTEXT_MENU_STATION_BUTTON_PROPERTY:
		tuner_station_context_menu_set_station_button (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

