/* DisplayButton.c generated by valac 0.56.8, the Vala compiler
 * generated from DisplayButton.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <pango/pango.h>

#define TUNER_DISPLAY_BUTTON_TITLE_WIDTH 25
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_DISPLAY_BUTTON (tuner_display_button_get_type ())
#define TUNER_DISPLAY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButton))
#define TUNER_DISPLAY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButtonClass))
#define TUNER_IS_DISPLAY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DISPLAY_BUTTON))
#define TUNER_IS_DISPLAY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DISPLAY_BUTTON))
#define TUNER_DISPLAY_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButtonClass))

typedef struct _TunerDisplayButton TunerDisplayButton;
typedef struct _TunerDisplayButtonClass TunerDisplayButtonClass;
typedef struct _TunerDisplayButtonPrivate TunerDisplayButtonPrivate;
enum  {
	TUNER_DISPLAY_BUTTON_0_PROPERTY,
	TUNER_DISPLAY_BUTTON_TITLE_PROPERTY,
	TUNER_DISPLAY_BUTTON_TAG_PROPERTY,
	TUNER_DISPLAY_BUTTON_DESCRIPTION_PROPERTY,
	TUNER_DISPLAY_BUTTON_FAVICON_IMAGE_PROPERTY,
	TUNER_DISPLAY_BUTTON_NUM_PROPERTIES
};
static GParamSpec* tuner_display_button_properties[TUNER_DISPLAY_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TunerDisplayButton {
	GtkButton parent_instance;
	TunerDisplayButtonPrivate * priv;
	GtkImage* _favicon_image;
};

struct _TunerDisplayButtonClass {
	GtkButtonClass parent_class;
};

struct _TunerDisplayButtonPrivate {
	GtkLabel* button_title;
	GtkLabel* button_tag;
	GtkLabel* button_description;
	GtkGrid* button_grid;
};

static gint TunerDisplayButton_private_offset;
static gpointer tuner_display_button_parent_class = NULL;

VALA_EXTERN GType tuner_display_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDisplayButton, g_object_unref)
VALA_EXTERN TunerDisplayButton* tuner_display_button_new (void);
VALA_EXTERN TunerDisplayButton* tuner_display_button_construct (GType object_type);
VALA_EXTERN const gchar* tuner_display_button_get_title (TunerDisplayButton* self);
VALA_EXTERN void tuner_display_button_set_title (TunerDisplayButton* self,
                                     const gchar* value);
VALA_EXTERN const gchar* tuner_display_button_get_tag (TunerDisplayButton* self);
VALA_EXTERN void tuner_display_button_set_tag (TunerDisplayButton* self,
                                   const gchar* value);
VALA_EXTERN const gchar* tuner_display_button_get_description (TunerDisplayButton* self);
VALA_EXTERN void tuner_display_button_set_description (TunerDisplayButton* self,
                                           const gchar* value);
VALA_EXTERN GtkImage* tuner_display_button_get_favicon_image (TunerDisplayButton* self);
static void tuner_display_button_set_favicon_image (TunerDisplayButton* self,
                                             GtkImage* value);
static GObject * tuner_display_button_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void tuner_display_button_finalize (GObject * obj);
static GType tuner_display_button_get_type_once (void);
static void _vala_tuner_display_button_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_tuner_display_button_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
tuner_display_button_get_instance_private (TunerDisplayButton* self)
{
	return G_STRUCT_MEMBER_P (self, TunerDisplayButton_private_offset);
}

TunerDisplayButton*
tuner_display_button_construct (GType object_type)
{
	TunerDisplayButton * self = NULL;
	self = (TunerDisplayButton*) g_object_new (object_type, NULL);
	return self;
}

TunerDisplayButton*
tuner_display_button_new (void)
{
	return tuner_display_button_construct (TUNER_TYPE_DISPLAY_BUTTON);
}

const gchar*
tuner_display_button_get_title (TunerDisplayButton* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->button_title;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
tuner_display_button_set_title (TunerDisplayButton* self,
                                const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_title;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_TITLE_PROPERTY]);
}

const gchar*
tuner_display_button_get_tag (TunerDisplayButton* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->button_tag;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
tuner_display_button_set_tag (TunerDisplayButton* self,
                              const gchar* value)
{
	GtkLabel* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_tag;
	gtk_label_set_text (_tmp0_, value);
	if (value == NULL) {
		_tmp1_ = TRUE;
	} else {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = strlen (value);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_ == 0;
	}
	if (_tmp1_) {
		GtkLabel* _tmp4_;
		_tmp4_ = self->priv->button_tag;
		g_object_run_dispose ((GObject*) _tmp4_);
	}
	g_object_notify_by_pspec ((GObject *) self, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_TAG_PROPERTY]);
}

const gchar*
tuner_display_button_get_description (TunerDisplayButton* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->button_description;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
tuner_display_button_set_description (TunerDisplayButton* self,
                                      const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_description;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_DESCRIPTION_PROPERTY]);
}

GtkImage*
tuner_display_button_get_favicon_image (TunerDisplayButton* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->_favicon_image;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
tuner_display_button_set_favicon_image (TunerDisplayButton* self,
                                        GtkImage* value)
{
	GtkImage* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->_favicon_image);
	self->_favicon_image = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_FAVICON_IMAGE_PROPERTY]);
}

static GObject *
tuner_display_button_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerDisplayButton * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkLabel* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkGrid* _tmp27_;
	GtkGrid* _tmp28_;
	GtkGrid* _tmp29_;
	GtkLabel* _tmp30_;
	GtkGrid* _tmp31_;
	GtkLabel* _tmp32_;
	GtkGrid* _tmp33_;
	GtkLabel* _tmp34_;
	GtkGrid* _tmp35_;
	GtkImage* _tmp36_;
	GtkGrid* _tmp37_;
	parent_class = G_OBJECT_CLASS (tuner_display_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButton);
	_tmp0_ = self->_favicon_image;
	gtk_image_set_pixel_size (_tmp0_, 48);
	_tmp1_ = self->_favicon_image;
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	_tmp2_ = self->_favicon_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	_tmp3_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->button_title);
	self->priv->button_title = _tmp3_;
	_tmp4_ = self->priv->button_title;
	gtk_label_set_max_width_chars (_tmp4_, TUNER_DISPLAY_BUTTON_TITLE_WIDTH);
	_tmp5_ = self->priv->button_title;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp7_ = self->priv->button_title;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	_tmp8_ = self->priv->button_title;
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	_tmp9_ = self->priv->button_title;
	gtk_label_set_ellipsize (_tmp9_, PANGO_ELLIPSIZE_END);
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->button_tag);
	self->priv->button_tag = _tmp10_;
	_tmp11_ = self->priv->button_tag;
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
	_tmp12_ = self->priv->button_tag;
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
	_tmp13_ = self->priv->button_tag;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "keycap");
	_tmp15_ = self->priv->button_tag;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
	gtk_style_context_add_class (_tmp16_, "tag");
	_tmp17_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->button_description);
	self->priv->button_description = _tmp17_;
	_tmp18_ = self->priv->button_description;
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_START | GTK_ALIGN_FILL);
	_tmp19_ = self->priv->button_description;
	gtk_widget_set_valign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
	_tmp20_ = self->priv->button_description;
	gtk_label_set_line_wrap (_tmp20_, TRUE);
	_tmp21_ = self->priv->button_description;
	gtk_label_set_line_wrap_mode (_tmp21_, PANGO_WRAP_WORD);
	_tmp22_ = self->priv->button_description;
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
	gtk_style_context_add_class (_tmp23_, "station-button-description");
	_tmp24_ = self->priv->button_description;
	gtk_label_set_ellipsize (_tmp24_, PANGO_ELLIPSIZE_MIDDLE);
	_tmp25_ = self->priv->button_description;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp26_, GTK_STYLE_CLASS_FLAT);
	_tmp27_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->button_grid);
	self->priv->button_grid = _tmp27_;
	_tmp28_ = self->priv->button_grid;
	gtk_grid_set_column_spacing (_tmp28_, 6);
	_tmp29_ = self->priv->button_grid;
	_tmp30_ = self->priv->button_title;
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, 0, 2, 1);
	_tmp31_ = self->priv->button_grid;
	_tmp32_ = self->priv->button_tag;
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 1, 1, 1, 1);
	_tmp33_ = self->priv->button_grid;
	_tmp34_ = self->priv->button_description;
	gtk_grid_attach (_tmp33_, (GtkWidget*) _tmp34_, 2, 1, 1, 1);
	_tmp35_ = self->priv->button_grid;
	_tmp36_ = self->_favicon_image;
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 0, 0, 1, 2);
	_tmp37_ = self->priv->button_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp37_);
	return obj;
}

static void
tuner_display_button_class_init (TunerDisplayButtonClass * klass,
                                 gpointer klass_data)
{
	tuner_display_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerDisplayButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_display_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_display_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_display_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_display_button_finalize;
	/**
	     * @brief Gets or sets the title of the button.
	     * @return The current title of the button.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DISPLAY_BUTTON_TITLE_PROPERTY, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * @brief Gets or sets the tag of the button.
	     * @return The current tag of the button.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DISPLAY_BUTTON_TAG_PROPERTY, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_TAG_PROPERTY] = g_param_spec_string ("tag", "tag", "tag", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * @brief Gets or sets the description of the button.
	     * @return The current description of the button.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DISPLAY_BUTTON_DESCRIPTION_PROPERTY, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * @brief Gets the favicon image.
	     * @return The current favicon image.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DISPLAY_BUTTON_FAVICON_IMAGE_PROPERTY, tuner_display_button_properties[TUNER_DISPLAY_BUTTON_FAVICON_IMAGE_PROPERTY] = g_param_spec_object ("favicon-image", "favicon-image", "favicon-image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
tuner_display_button_instance_init (TunerDisplayButton * self,
                                    gpointer klass)
{
	self->priv = tuner_display_button_get_instance_private (self);
}

static void
tuner_display_button_finalize (GObject * obj)
{
	TunerDisplayButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButton);
	_g_object_unref0 (self->priv->button_title);
	_g_object_unref0 (self->priv->button_tag);
	_g_object_unref0 (self->priv->button_description);
	_g_object_unref0 (self->priv->button_grid);
	_g_object_unref0 (self->_favicon_image);
	G_OBJECT_CLASS (tuner_display_button_parent_class)->finalize (obj);
}

/**
 * @class Tuner.DisplayButton
 * @brief A button widget that displays a title, tag, description, and an optional favicon.
 *
 * This class extends Gtk.Button and is used to represent a display button
 * in the tuner application, showing relevant information about a station.
 */
static GType
tuner_display_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerDisplayButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_display_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerDisplayButton), 0, (GInstanceInitFunc) tuner_display_button_instance_init, NULL };
	GType tuner_display_button_type_id;
	tuner_display_button_type_id = g_type_register_static (gtk_button_get_type (), "TunerDisplayButton", &g_define_type_info, 0);
	TunerDisplayButton_private_offset = g_type_add_instance_private (tuner_display_button_type_id, sizeof (TunerDisplayButtonPrivate));
	return tuner_display_button_type_id;
}

GType
tuner_display_button_get_type (void)
{
	static volatile gsize tuner_display_button_type_id__once = 0;
	if (g_once_init_enter (&tuner_display_button_type_id__once)) {
		GType tuner_display_button_type_id;
		tuner_display_button_type_id = tuner_display_button_get_type_once ();
		g_once_init_leave (&tuner_display_button_type_id__once, tuner_display_button_type_id);
	}
	return tuner_display_button_type_id__once;
}

static void
_vala_tuner_display_button_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	TunerDisplayButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButton);
	switch (property_id) {
		case TUNER_DISPLAY_BUTTON_TITLE_PROPERTY:
		g_value_set_string (value, tuner_display_button_get_title (self));
		break;
		case TUNER_DISPLAY_BUTTON_TAG_PROPERTY:
		g_value_set_string (value, tuner_display_button_get_tag (self));
		break;
		case TUNER_DISPLAY_BUTTON_DESCRIPTION_PROPERTY:
		g_value_set_string (value, tuner_display_button_get_description (self));
		break;
		case TUNER_DISPLAY_BUTTON_FAVICON_IMAGE_PROPERTY:
		g_value_set_object (value, tuner_display_button_get_favicon_image (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_display_button_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	TunerDisplayButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_DISPLAY_BUTTON, TunerDisplayButton);
	switch (property_id) {
		case TUNER_DISPLAY_BUTTON_TITLE_PROPERTY:
		tuner_display_button_set_title (self, g_value_get_string (value));
		break;
		case TUNER_DISPLAY_BUTTON_TAG_PROPERTY:
		tuner_display_button_set_tag (self, g_value_get_string (value));
		break;
		case TUNER_DISPLAY_BUTTON_DESCRIPTION_PROPERTY:
		tuner_display_button_set_description (self, g_value_get_string (value));
		break;
		case TUNER_DISPLAY_BUTTON_FAVICON_IMAGE_PROPERTY:
		tuner_display_button_set_favicon_image (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

