/* RevealLabel.c generated by valac 0.56.8, the Vala compiler
 * generated from RevealLabel.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later 
 *
 * @file RevealLabel.vala
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>

#define TUNER_REVEAL_LABEL_DEFAULT_FADE_DURATION 1200U
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_REVEAL_LABEL (tuner_reveal_label_get_type ())
#define TUNER_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel))
#define TUNER_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabelClass))
#define TUNER_IS_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_REVEAL_LABEL))
#define TUNER_IS_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_REVEAL_LABEL))
#define TUNER_REVEAL_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabelClass))

typedef struct _TunerRevealLabel TunerRevealLabel;
typedef struct _TunerRevealLabelClass TunerRevealLabelClass;
typedef struct _TunerRevealLabelPrivate TunerRevealLabelPrivate;
enum  {
	TUNER_REVEAL_LABEL_0_PROPERTY,
	TUNER_REVEAL_LABEL_LABEL_CHILD_PROPERTY,
	TUNER_REVEAL_LABEL_LABEL_PROPERTY,
	TUNER_REVEAL_LABEL_NUM_PROPERTIES
};
static GParamSpec* tuner_reveal_label_properties[TUNER_REVEAL_LABEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TunerRevealLabel {
	GtkRevealer parent_instance;
	TunerRevealLabelPrivate * priv;
};

struct _TunerRevealLabelClass {
	GtkRevealerClass parent_class;
};

struct _TunerRevealLabelPrivate {
	GMutex _set_text_lock;
	gchar* _next_text;
	GtkLabel* _label_child;
};

static gint TunerRevealLabel_private_offset;
static gpointer tuner_reveal_label_parent_class = NULL;

VALA_EXTERN GType tuner_reveal_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerRevealLabel, g_object_unref)
VALA_EXTERN void tuner_reveal_label_clear (TunerRevealLabel* self);
VALA_EXTERN GtkLabel* tuner_reveal_label_get_label_child (TunerRevealLabel* self);
VALA_EXTERN const gchar* tuner_reveal_label_get_text (TunerRevealLabel* self);
VALA_EXTERN gboolean tuner_reveal_label_set_text (TunerRevealLabel* self,
                                      const gchar* text);
static gboolean __lambda22_ (TunerRevealLabel* self);
static gboolean ___lambda22__gsource_func (gpointer self);
static gboolean __lambda23_ (TunerRevealLabel* self);
static gboolean ___lambda23__gsource_func (gpointer self);
VALA_EXTERN TunerRevealLabel* tuner_reveal_label_new (void);
VALA_EXTERN TunerRevealLabel* tuner_reveal_label_construct (GType object_type);
VALA_EXTERN void tuner_reveal_label_set_label_child (TunerRevealLabel* self,
                                         GtkLabel* value);
VALA_EXTERN const gchar* tuner_reveal_label_get_label (TunerRevealLabel* self);
VALA_EXTERN void tuner_reveal_label_set_label (TunerRevealLabel* self,
                                   const gchar* value);
static GObject * tuner_reveal_label_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void tuner_reveal_label_finalize (GObject * obj);
static GType tuner_reveal_label_get_type_once (void);
static void _vala_tuner_reveal_label_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_tuner_reveal_label_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static inline gpointer
tuner_reveal_label_get_instance_private (TunerRevealLabel* self)
{
	return G_STRUCT_MEMBER_P (self, TunerRevealLabel_private_offset);
}

void
tuner_reveal_label_clear (TunerRevealLabel* self)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	_g_free0 (self->priv->_next_text);
	self->priv->_next_text = _tmp0_;
	_tmp1_ = self->priv->_label_child;
	gtk_label_set_label (_tmp1_, "");
}

/**
     * @brief The text displayed in the label.
     *
     */
const gchar*
tuner_reveal_label_get_text (TunerRevealLabel* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_child;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/**
     * @brief The text to display in the label.
     *
     * Setting this text triggers the reveal animation.
     */
static gboolean
__lambda22_ (TunerRevealLabel* self)
{
	GtkLabel* _tmp0_;
	gboolean result;
	_tmp0_ = self->priv->_label_child;
	gtk_label_set_label (_tmp0_, "");
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda22__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda22_ ((TunerRevealLabel*) self);
	return result;
}

static gboolean
__lambda23_ (TunerRevealLabel* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
	_tmp0_ = self->priv->_label_child;
	_tmp1_ = self->priv->_next_text;
	gtk_label_set_label (_tmp0_, _tmp1_);
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
	g_mutex_unlock (&self->priv->_set_text_lock);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda23_ ((TunerRevealLabel*) self);
	return result;
}

gboolean
tuner_reveal_label_set_text (TunerRevealLabel* self,
                             const gchar* text)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkLabel* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (text != NULL, FALSE);
	_tmp0_ = self->priv->_label_child;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, text) == 0) {
		result = TRUE;
		return result;
	}
	if (g_mutex_trylock (&self->priv->_set_text_lock) == FALSE) {
		result = FALSE;
		return result;
	}
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, FALSE);
	_tmp3_ = g_strdup (text);
	_g_free0 (self->priv->_next_text);
	self->priv->_next_text = _tmp3_;
	_tmp5_ = self->priv->_label_child;
	_tmp6_ = gtk_label_get_label (_tmp5_);
	_tmp7_ = _tmp6_;
	if (g_strcmp0 (_tmp7_, "") == 0) {
		_tmp4_ = g_strcmp0 (text, "") != 0;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GtkLabel* _tmp8_;
		const gchar* _tmp9_;
		_tmp8_ = self->priv->_label_child;
		_tmp9_ = self->priv->_next_text;
		gtk_label_set_label (_tmp8_, _tmp9_);
		gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
		g_mutex_unlock (&self->priv->_set_text_lock);
		result = TRUE;
		return result;
	}
	g_timeout_add_full (G_PRIORITY_HIGH_IDLE, (11 * TUNER_REVEAL_LABEL_DEFAULT_FADE_DURATION) / 10, ___lambda22__gsource_func, g_object_ref (self), g_object_unref);
	g_timeout_add_full (G_PRIORITY_DEFAULT_IDLE, (3 * TUNER_REVEAL_LABEL_DEFAULT_FADE_DURATION) / 2, ___lambda23__gsource_func, g_object_ref (self), g_object_unref);
	result = TRUE;
	return result;
}

TunerRevealLabel*
tuner_reveal_label_construct (GType object_type)
{
	TunerRevealLabel * self = NULL;
	self = (TunerRevealLabel*) g_object_new (object_type, NULL);
	return self;
}

TunerRevealLabel*
tuner_reveal_label_new (void)
{
	return tuner_reveal_label_construct (TUNER_TYPE_REVEAL_LABEL);
}

GtkLabel*
tuner_reveal_label_get_label_child (TunerRevealLabel* self)
{
	GtkLabel* result;
	GtkLabel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label_child;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_reveal_label_set_label_child (TunerRevealLabel* self,
                                    GtkLabel* value)
{
	GtkLabel* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_reveal_label_get_label_child (self);
	if (old_value != value) {
		GtkLabel* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_label_child);
		self->priv->_label_child = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_reveal_label_properties[TUNER_REVEAL_LABEL_LABEL_CHILD_PROPERTY]);
	}
}

const gchar*
tuner_reveal_label_get_label (TunerRevealLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = tuner_reveal_label_get_text (self);
	result = _tmp0_;
	return result;
}

void
tuner_reveal_label_set_label (TunerRevealLabel* self,
                              const gchar* value)
{
	g_return_if_fail (self != NULL);
	tuner_reveal_label_set_text (self, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_reveal_label_properties[TUNER_REVEAL_LABEL_LABEL_PROPERTY]);
}

static GObject *
tuner_reveal_label_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerRevealLabel * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	parent_class = G_OBJECT_CLASS (tuner_reveal_label_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel);
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	tuner_reveal_label_set_label_child (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = self->priv->_label_child;
	gtk_label_set_ellipsize (_tmp2_, PANGO_ELLIPSIZE_MIDDLE);
	_tmp3_ = self->priv->_label_child;
	g_object_set ((GtkContainer*) self, "child", (GtkWidget*) _tmp3_, NULL);
	gtk_revealer_set_transition_type ((GtkRevealer*) self, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	gtk_revealer_set_transition_duration ((GtkRevealer*) self, TUNER_REVEAL_LABEL_DEFAULT_FADE_DURATION);
	return obj;
}

static void
tuner_reveal_label_class_init (TunerRevealLabelClass * klass,
                               gpointer klass_data)
{
	tuner_reveal_label_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerRevealLabel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_reveal_label_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_reveal_label_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_reveal_label_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_reveal_label_finalize;
	/**
	     * @property label_child
	     * @brief The Gtk.Label widget contained within the revealer.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_REVEAL_LABEL_LABEL_CHILD_PROPERTY, tuner_reveal_label_properties[TUNER_REVEAL_LABEL_LABEL_CHILD_PROPERTY] = g_param_spec_object ("label-child", "label-child", "label-child", gtk_label_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/** @property {string} label - Label text. Setting this property triggers the reveal animation. */
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_REVEAL_LABEL_LABEL_PROPERTY, tuner_reveal_label_properties[TUNER_REVEAL_LABEL_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
tuner_reveal_label_instance_init (TunerRevealLabel * self,
                                  gpointer klass)
{
	self->priv = tuner_reveal_label_get_instance_private (self);
	g_mutex_init (&self->priv->_set_text_lock);
}

static void
tuner_reveal_label_finalize (GObject * obj)
{
	TunerRevealLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel);
	_vala_clear_GMutex (&self->priv->_set_text_lock);
	_g_free0 (self->priv->_next_text);
	_g_object_unref0 (self->priv->_label_child);
	G_OBJECT_CLASS (tuner_reveal_label_parent_class)->finalize (obj);
}

/**
 * @class RevealLabel
 * @brief A custom widget that reveals a label with animation.
 *
 * This class extends Gtk.Revealer to create a label that can be revealed
 * and hidden with smooth transitions.
 * Uses Gtk.Label get_text and set_text for label text
 *
 * @extends Gtk.Revealer
 */
static GType
tuner_reveal_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerRevealLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_reveal_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerRevealLabel), 0, (GInstanceInitFunc) tuner_reveal_label_instance_init, NULL };
	GType tuner_reveal_label_type_id;
	tuner_reveal_label_type_id = g_type_register_static (gtk_revealer_get_type (), "TunerRevealLabel", &g_define_type_info, 0);
	TunerRevealLabel_private_offset = g_type_add_instance_private (tuner_reveal_label_type_id, sizeof (TunerRevealLabelPrivate));
	return tuner_reveal_label_type_id;
}

GType
tuner_reveal_label_get_type (void)
{
	static volatile gsize tuner_reveal_label_type_id__once = 0;
	if (g_once_init_enter (&tuner_reveal_label_type_id__once)) {
		GType tuner_reveal_label_type_id;
		tuner_reveal_label_type_id = tuner_reveal_label_get_type_once ();
		g_once_init_leave (&tuner_reveal_label_type_id__once, tuner_reveal_label_type_id);
	}
	return tuner_reveal_label_type_id__once;
}

static void
_vala_tuner_reveal_label_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	TunerRevealLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel);
	switch (property_id) {
		case TUNER_REVEAL_LABEL_LABEL_CHILD_PROPERTY:
		g_value_set_object (value, tuner_reveal_label_get_label_child (self));
		break;
		case TUNER_REVEAL_LABEL_LABEL_PROPERTY:
		g_value_set_string (value, tuner_reveal_label_get_label (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_reveal_label_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	TunerRevealLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel);
	switch (property_id) {
		case TUNER_REVEAL_LABEL_LABEL_CHILD_PROPERTY:
		tuner_reveal_label_set_label_child (self, g_value_get_object (value));
		break;
		case TUNER_REVEAL_LABEL_LABEL_PROPERTY:
		tuner_reveal_label_set_label (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

